/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package Graphic;

import java.awt.Color;
import java.awt.Font;
import javax.swing.BorderFactory;
import javax.swing.JDesktopPane;
import javax.swing.JFrame;
import javax.swing.JInternalFrame;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import org.jfree.chart.ChartFactory;
import org.jfree.chart.ChartPanel;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.plot.PlotOrientation;
import org.jfree.data.category.DefaultCategoryDataset;

/**
 *
 * @author z
 */
public class BarChart extends JFrame {
    
    private final DefaultCategoryDataset dataset;
    private final String title;
    private final String category_label;
    private final String value_label;
    
    public BarChart(String title, String category_label, String value_label) {
        this.title = title;
        this.category_label = category_label;
        this.value_label = value_label;
        
        dataset = new DefaultCategoryDataset();
    }

    private void createGUI() {
          
          
//        CategoryDataset dataset = createDataset();
//
//        JFreeChart chart = createChart(dataset);
//        ChartPanel chartPanel = new ChartPanel(chart);
//        chartPanel.setBorder(BorderFactory.createEmptyBorder(15, 15, 15, 15));
//        chartPanel.setBackground(Color.white);
//        add(chartPanel);
//
//        pack();
//        setTitle("Bar chart");
//        setLocationRelativeTo(null);
//        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    }

    public void createDataset(double[] data, String y_label, String[] x_labels) {

        for (int i=0; i < data.length; i++){
            this.dataset.setValue(data[i], y_label, x_labels[i]);  
        }
    }

    private JFreeChart createChart() {

        return ChartFactory.createBarChart(
                this.title, this.category_label, this.value_label, this.dataset,
                PlotOrientation.VERTICAL, false, true, false);
    }

    public JInternalFrame createFrame(JDesktopPane jdp, String frame_title) {
        JFreeChart chart = createChart();
        
        final ChartPanel chartPanel = new ChartPanel(chart);
        chartPanel.setPreferredSize(jdp.getPreferredSize());
        chartPanel.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
        chartPanel.setBackground(Color.white);

        final JInternalFrame frame = new JInternalFrame(frame_title, false);
        
        JMenuBar menuBar = new JMenuBar(); 
        JMenuItem frameMenu = new JMenuItem("Открепить");
        frameMenu.setFont(new Font("Times New Roman", 0, 18));
        frameMenu.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                System.out.println("BarChart - открепить");
            }
        });
        menuBar.add(frameMenu);
        frame.setJMenuBar(menuBar);
        
        frame.setPreferredSize(jdp.getPreferredSize());
        frame.getContentPane().add(chartPanel);
        
        return frame;
    }

}