/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package Graphic;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.util.Vector;
import javax.swing.*;
import org.jfree.chart.ChartFactory;
import org.jfree.chart.ChartPanel;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.block.BlockBorder;
import org.jfree.chart.plot.PlotOrientation;
import org.jfree.chart.plot.XYPlot;
import org.jfree.chart.renderer.xy.XYLineAndShapeRenderer;
import org.jfree.chart.title.TextTitle;
import org.jfree.data.xy.XYSeries;
import org.jfree.data.xy.XYSeriesCollection;

/**
 *
 * @author z
 */
public class LineChart extends JPanel{
    
    private final XYSeriesCollection dataset;
    private final String chart_title;
    private final String x_label;
    private final String y_label;
    
    public LineChart(String title, String x_label, String y_label) {

        this.chart_title = title;
        this.x_label = x_label;
        this.y_label = y_label;
        
        this.dataset = new XYSeriesCollection();
    }
    
    public void addData(String line_name, Vector<Double> x_data, Vector<Double> y_data) {

        XYSeries series1 = new XYSeries(line_name);
        for (int i=0; i < x_data.size(); i++){
            series1.add(x_data.elementAt(i), y_data.elementAt(i));
            
        }   

        this.dataset.addSeries(series1);
    }
    
    public void addData(String line_name, Vector<Double> y_data) {

        int[] x_data = new int[y_data.size()];
        for (int i=0; i < y_data.size(); i++){
            x_data[i] = i+1;
        }
        
        XYSeries series1 = new XYSeries(line_name);
        for (int i=0; i < x_data.length; i++){
            series1.add(x_data[i], y_data.elementAt(i));
            
        }   

        this.dataset.addSeries(series1);
    } 
    
    public void addData(String line_name, int[] x_data, double[] y_data) {

        
        XYSeries series1 = new XYSeries(line_name);
        for (int i=0; i < x_data.length; i++){
            series1.add(x_data[i], y_data[i]);
            
        }   

        this.dataset.addSeries(series1);
    } 
    
    public void addData(String line_name, int[] x_data, int[] y_data) {

        XYSeries series1 = new XYSeries(line_name);
        for (int i=0; i < x_data.length; i++){
            series1.add(x_data[i], y_data[i]);
            
        }   

        this.dataset.addSeries(series1);
    } 
    
    public void addData(String line_name, double[] x_data, double[] y_data) {

        XYSeries series1 = new XYSeries(line_name);
        for (int i=0; i < x_data.length; i++){
            series1.add(x_data[i], y_data[i]);
            
        }   

        this.dataset.addSeries(series1);
    }  

    private JFreeChart createChart() {

        JFreeChart chart = ChartFactory.createXYLineChart(this.chart_title, this.x_label, this.y_label, 
                this.dataset, PlotOrientation.VERTICAL, true, true, false);

        XYPlot plot = chart.getXYPlot();
        
        XYLineAndShapeRenderer renderer = new XYLineAndShapeRenderer();
        
        renderer.setSeriesPaint(0, Color.RED);
        renderer.setSeriesStroke(0, new BasicStroke(2.0f));
        renderer.setSeriesPaint(1, Color.BLUE);
        renderer.setSeriesStroke(1, new BasicStroke(2.0f));        

        plot.setRenderer(renderer);
        plot.setBackgroundPaint(Color.white);
        plot.setRangeGridlinesVisible(false);
        plot.setDomainGridlinesVisible(false);

        chart.setTitle(new TextTitle(chart_title,
                        new Font("Times New Roman", Font.BOLD, 18)
                )
        );

        chart.getLegend().setFrame(BlockBorder.NONE);
            
        return chart;
    }
    
    public void run(Dimension jdp_pref_size){
        // вывод в отдельномм окне
        JFreeChart chart = createChart();
        
        ChartPanel chartPanel = new ChartPanel(chart);
        chartPanel.setPreferredSize(new Dimension((int) jdp_pref_size.getWidth(), (int) jdp_pref_size.getHeight()-30));
        chartPanel.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
        chartPanel.setBackground(Color.white);
        
        this.setPreferredSize(jdp_pref_size);
        this.add(chartPanel);

    }
    
    public JInternalFrame createFrame(Dimension jdp_pref_size, String frame_title) {
        // привязка к заданной JInternalFrame - пока оставляю, чтбы запускалось без ошибок (иначе будет ошибка в DemoGuiEupOld)
        JFreeChart chart = createChart();
        
        final ChartPanel chartPanel = new ChartPanel(chart);
        chartPanel.setPreferredSize(jdp_pref_size);
        chartPanel.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
        chartPanel.setBackground(Color.white);

        final JInternalFrame frame = new JInternalFrame(frame_title, false);
        
        JMenuBar menuBar = new JMenuBar(); 
        JMenuItem frameMenu = new JMenuItem("Открепить");
        frameMenu.setFont(new Font("Times New Roman", 0, 18));
        frameMenu.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                System.out.println("LineChart - открепить");
            }
        });
        menuBar.add(frameMenu);
        frame.setJMenuBar(menuBar);
        
        frame.setPreferredSize(jdp_pref_size);
        frame.getContentPane().add(chartPanel);
        
        return frame;
    }
}
