/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package smmum_alpha;

import Graphic.LineChart;
import java.io.IOException;
import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.function.Function;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JToggleButton;

/**
 *
 * @author z
 */
public class DemoGuiMiningStatistics extends javax.swing.JFrame {

    private final javax.swing.ButtonGroup buttonGroup1 = new javax.swing.ButtonGroup();
    
    private final ArrayList<String> names = new ArrayList<>();
    // Eup=0, Pk=1, Swu=2, Mox=3
    // массивы функций для построения графиков; заполнены в соответствии с кодами типов в Contract
    private Function<Mining,double[]> capacities_func;
    private Function<Mining,double[]> costs_func;
    private final ArrayList<Function<Mining,double[]>> volumes_func = new ArrayList<>();
    private final ArrayList<Function<Mining,double[]>> mean_prices_func = new ArrayList<>();
    
    private final String EXCEL_FILE = "example_mining.xlsx";    // TODO: изменить?
    private final String EXCEL_FILE_PATH = "./" + EXCEL_FILE; 
   
    private Mining mining;


    public DemoGuiMiningStatistics(Mining op) {
        initComponents();
        
        extraInit();
        this.mining = op;
    }

    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jButton7 = new javax.swing.JButton();
        jPanel2 = new javax.swing.JPanel();
        jRadioButton1 = new javax.swing.JRadioButton();
        jRadioButton2 = new javax.swing.JRadioButton();
        jRadioButton3 = new javax.swing.JRadioButton();
        jRadioButton4 = new javax.swing.JRadioButton();
        jTabbedPane1 = new javax.swing.JTabbedPane();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setAlwaysOnTop(true);
        setLocation(new java.awt.Point(485, 0));
        setResizable(false);

        jButton7.setFont(new java.awt.Font("Times New Roman", 0, 18)); // NOI18N
        jButton7.setText("Сохранить статистику");
        jButton7.setPreferredSize(new java.awt.Dimension(255, 41));
        jButton7.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton7ActionPerformed(evt);
            }
        });

        jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Выберите характеристику:", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Times New Roman", 0, 18))); // NOI18N
        jPanel2.setFont(new java.awt.Font("Times New Roman", 0, 18)); // NOI18N
        jPanel2.setPreferredSize(new java.awt.Dimension(879, 309));

        jRadioButton1.setFont(new java.awt.Font("Times New Roman", 0, 18)); // NOI18N
        jRadioButton1.setText("Запасы");
        jRadioButton1.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                jRadioButton1ItemStateChanged(evt);
            }
        });

        jRadioButton2.setFont(new java.awt.Font("Times New Roman", 0, 18)); // NOI18N
        jRadioButton2.setText("Себестоимость");
        jRadioButton2.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                jRadioButton2ItemStateChanged(evt);
            }
        });

        jRadioButton3.setFont(new java.awt.Font("Times New Roman", 0, 18)); // NOI18N
        jRadioButton3.setText("Объем поставок");
        jRadioButton3.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                jRadioButton3ItemStateChanged(evt);
            }
        });

        jRadioButton4.setFont(new java.awt.Font("Times New Roman", 0, 18)); // NOI18N
        jRadioButton4.setText("Средняя цена");
        jRadioButton4.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                jRadioButton4ItemStateChanged(evt);
            }
        });

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jRadioButton2)
                    .addComponent(jRadioButton1))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jRadioButton4)
                    .addComponent(jRadioButton3))
                .addGap(89, 89, 89))
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jRadioButton1)
                    .addComponent(jRadioButton3))
                .addGap(18, 18, 18)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jRadioButton2)
                    .addComponent(jRadioButton4)))
        );

        jTabbedPane1.setPreferredSize(new java.awt.Dimension(572, 342));

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jTabbedPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 640, Short.MAX_VALUE)
                    .addComponent(jButton7, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, 640, Short.MAX_VALUE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, 120, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addComponent(jTabbedPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 448, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addComponent(jButton7, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents
   
    // <editor-fold defaultstate="collapsed" desc="Extra init">
    private void extraInit(){

        JRadioButton[] arr = {jRadioButton1, jRadioButton2,
                    jRadioButton3, jRadioButton4};
        createButtonGroups(buttonGroup1, arr);
        
        names.add("ПК");
        names.add("ЕРР");
        names.add("ОУП");
        names.add("МОКС");
        
        capacities_func = ((op) -> op.getCapacities());
        costs_func = ((op) -> op.getCosts());  
        
        volumes_func.add((op) -> op.getStats().getEup_volume());
        volumes_func.add((op) -> op.getStats().getPk_volume());
        volumes_func.add((op) -> op.getStats().getSwu_volume());
        volumes_func.add((op) -> op.getStats().getMox_volume());
        
        mean_prices_func.add((op) -> op.getStats().getEup_price());
        mean_prices_func.add((op) -> op.getStats().getPk_price());
        mean_prices_func.add((op) -> op.getStats().getSwu_price());
        mean_prices_func.add((op) -> op.getStats().getMox_price());
    }
    
    private void createButtonGroups(javax.swing.ButtonGroup buttonGroup, JToggleButton ... buttons){
        
        for (int i=0; i < buttons.length; i++){
            buttonGroup.add(buttons[i]);
        }

    }
    //</editor-fold>
    
    // <editor-fold defaultstate="collapsed" desc="TabbedPane functions">

    // для одиночной характеристики
    private void showChart(String chart_name, String title, String x_label, int[] x_data, String y_label, Mining op, Function<Mining,double[]> func){  
        jTabbedPane1.addTab(title, createChart(this.jTabbedPane1, chart_name, title, x_label, Time.years, y_label, this.mining, func));
        jTabbedPane1.setSelectedIndex(jTabbedPane1.getTabCount()-1);
    }  
    
    // выводит общий график и по-отдельности; для графиков, отображающихся для разных типов
    private void showAllCharts(ArrayList<String> names, String chart_name, String x_label, int[] x_data, String y_label, Mining op, ArrayList<Function<Mining, double[]>> funcs){
        
        LineChart chart = new LineChart(chart_name, x_label, y_label);  
        for (int i=0; i < names.size(); i++){
            if (names.get(i).equals("ПК")){
                jTabbedPane1.addTab(names.get(i),
                        createChart(this.jTabbedPane1, chart_name, names.get(i), x_label, Time.years, y_label, op, funcs.get(1)));
                chart.addData(names.get(i), x_data, funcs.get(1).apply(op));
            }
            else if (names.get(i).equals("ЕРР")){
                jTabbedPane1.addTab(names.get(i),
                        createChart(this.jTabbedPane1, chart_name, names.get(i), x_label, Time.years, y_label, op, funcs.get(2)));
                chart.addData(names.get(i), x_data, funcs.get(2).apply(op));
            }
            else if (names.get(i).equals("ОУП")){
                jTabbedPane1.addTab(names.get(i),
                        createChart(this.jTabbedPane1, chart_name, names.get(i), x_label, Time.years, y_label, op, funcs.get(0)));
                chart.addData(names.get(i), x_data, funcs.get(0).apply(op));
            }
            else if (names.get(i).equals("МОКС")){
                jTabbedPane1.addTab(names.get(i),
                        createChart(this.jTabbedPane1, chart_name, names.get(i), x_label, Time.years, y_label, op, funcs.get(3)));
                chart.addData(names.get(i), x_data, funcs.get(3).apply(op));
            }
    
        } 
        
        chart.run(jTabbedPane1.getSize());
        
        jTabbedPane1.addTab("Общая", chart);
        jTabbedPane1.setSelectedIndex(jTabbedPane1.getTabCount()-1);
    }
    
    // добавляет какой-то 1 график double[] в component
    private LineChart createChart(java.awt.Component component, String chart_name, String title, String x_label, int[] x_data, String y_label, Mining op, Function<Mining,double[]> func){
        
        LineChart chart = new LineChart(chart_name, x_label, y_label);  
        chart.addData(title, x_data, func.apply(op));
        chart.run(component.getSize());
        return chart;
    }

    //</editor-fold>
    
    private void jButton7ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton7ActionPerformed
        // export to excel
        try {
            Function<Mining, LinkedHashMap> func = (actor)-> actor.getStats().assembleActorSet();
            ExcelLoader<Mining> el = new ExcelLoader<>(EXCEL_FILE_PATH);
            el.writeIntoExcel(this.mining, func, "Поставщик "+this.mining.getName());

            JOptionPane.showMessageDialog(new JPanel(),"Сохранено", "Готово!",
                    JOptionPane.INFORMATION_MESSAGE);
        }
        catch (IOException ex) {
            Logger.getLogger(DemoGuiArchive.class.getName()).log(Level.SEVERE, null, ex);
        }
        
    }//GEN-LAST:event_jButton7ActionPerformed

    // <editor-fold defaultstate="collapsed" desc="jRadioButton ItemStateChanged">
    private void jRadioButton1ItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jRadioButton1ItemStateChanged
        // запасы
        jTabbedPane1.removeAll();
        showChart("", "Запасы", "Год",  Time.years, "Запасы", this.mining, capacities_func);
    }//GEN-LAST:event_jRadioButton1ItemStateChanged

    private void jRadioButton2ItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jRadioButton2ItemStateChanged
        // себестоимость
        jTabbedPane1.removeAll();
        showChart("", "Себестоимость", "Год",  Time.years, "Себестоимость", this.mining, costs_func);
    }//GEN-LAST:event_jRadioButton2ItemStateChanged

    private void jRadioButton3ItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jRadioButton3ItemStateChanged
        // объем поставок
        jTabbedPane1.removeAll();
        showAllCharts(this.names, "", "Год", Time.years, "", this.mining, this.volumes_func);
    }//GEN-LAST:event_jRadioButton3ItemStateChanged

    private void jRadioButton4ItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jRadioButton4ItemStateChanged
        // средняя цена
        jTabbedPane1.removeAll();
        showAllCharts(this.names, "", "Год", Time.years, "", this.mining, this.mean_prices_func);
    }//GEN-LAST:event_jRadioButton4ItemStateChanged

 // </editor-fold> 
    
    // <editor-fold defaultstate="collapsed" desc="Public functions for managing">
    /*
    Here are a couple functions when you choose new Operator.
    Algorithm of updating:
    1) clear Panes and highlightnings/
    2) this operator is new operator
    */
    
    // если выбран оператор
    public void update_UI(Mining op){
        jTabbedPane1.removeAll();
        buttonGroup1.setSelected(buttonGroup1.getSelection(), false);
        
        this.mining = op;
  
    }
    
   
 // </editor-fold>    
    

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton7;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JRadioButton jRadioButton1;
    private javax.swing.JRadioButton jRadioButton2;
    private javax.swing.JRadioButton jRadioButton3;
    private javax.swing.JRadioButton jRadioButton4;
    private javax.swing.JTabbedPane jTabbedPane1;
    // End of variables declaration//GEN-END:variables
}
