/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package smmum_alpha;

import java.time.LocalDate;
import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.TreeMap;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextArea;

/**
 *
 * @author Dmitry
 */
public class DemoModule {
    ArrayList<Region> my_regions;
    ArrayList<Agent> my_agents;
    ArrayList<Operator> my_operators;
    ArrayList<Mining> my_minings;
    ArrayList<Enrichment> my_enrichments;
    ArrayList<MoxSupplier> my_mox_suppliers;
    ArrayList<Actor> AllActors;
    Scenario scenario;
    int tickCount = 0;
    int ItickCount = 0;
    ArrayList<Reactor> my_reactors;
    Trader trader;
    PKDump dump;
    RemixSupplier remix_supplier;
    public DemoModule(){
        scenario = new Scenario(this);
    }
    
    public DemoModule(String flag){
        if (flag.equals("demo4")){
            scenario = new ScenarioTest(this);
        }
        else
            if(flag.equals("demo5")){
                scenario = new ScenarioSWUPK(this);
            }else
                if(flag.equals("demo6")){
                    scenario = new ScenarioLight(this);
                }
            else{
                throw new Error("Unknown scenario");
            }
    }
    
    
    public void setup(){
        scenario.setup();
        setAllActors();
        setup_trade_bulletin();
        World.setStart();
        World.calc_total_supply_demand(AllActors);
        scenario.initialize_statistics();
    }
    
    
    public void run(){
        while(Time.iTime < Time.lastTime)
        {
            Queue.form_queue(AllActors);
            while (is_running()){
                ContractChain.tick();          
            }
            
            ContractChain.clearR();
            Queue.restore(AllActors);
            World.setTurn();
            Time.increment_iTime();
        }
        World.final_stat(AllActors);
        System.out.println("ALL IS DONE");

    //throw new UnsupportedOperationException("Time is OUT");
    }
    void run(JTextArea jTextArea1) {
        long time_elapsed  = 0;
        while(Time.iTime < Time.lastTime)
        {
            long start_currentTimeMillis = System.currentTimeMillis();
            System.err.println("\nYear: " + Time.yTime + "\n");
            //jTextArea1.append("\nStart time: " + start_currentTimeMillis + "\n");
            Queue.run(AllActors, this);
            if (need_not_satisfied()){
                System.err.println("Unsatisfied needs");
                throw new Error("Unsatisfied needs");
            }
            //ContractChain.clearR();
            World.setSpot();
            Queue.restore(AllActors);
            World.setTurn();
            System.err.println("\nYear: " + Time.yTime + " was ended \n");
            Time.increment_iTime();
            RChain.clear();
            long end_currentTimeMillis = System.currentTimeMillis();
            //jTextArea1.append("\nStart time: " + end_currentTimeMillis + "\n");
            time_elapsed = time_elapsed+ (end_currentTimeMillis - start_currentTimeMillis)/1000;
            
        }
        jTextArea1.append("\nЗатрачено времени: " + time_elapsed + " сек\n");
        World.final_stat(AllActors);
        System.out.println("ALL IS DONE");
    }
    
    public void exec(ArrayList<Actor> OrderedActors){
        OrderedActors.forEach(z -> z.form_demand());
        ItickCount = 0;
        while(need_not_satisfied()){
            while (is_running()){
                ContractChain.tick();          
            }
            ItickCount++;
            if (!need_not_satisfied()) {
                ContractChain.clearR();
                break;
            }
            else if (ItickCount < 3 || pk_yok(OrderedActors)){
                double N = calc_not_satisfied_needs(OrderedActors);
//                if ((!trader.isActive() || trader.capacity < 600) && calc_max_pk_vol() < 600){
//                    dump.increase_capacity(N*10);
//                }
                ArrayList<LinkedHashMap> E = new ArrayList();
                for (Enrichment my_enrichment : my_enrichments) {
                    E.add(my_enrichment.calc_region_eup_sales_stat(Time.yTime, my_regions));
                }
                dump.increase_capacity(N*10);
                //increase_other_capacity(N*10);
                Queue.retrade_crumbs(OrderedActors);
                ContractChain.clearR();
            }
            else{
                double[] pk_supply = new double[my_minings.size()]; 
                int i = 0;
                for (Mining my_mining : my_minings) {
                    pk_supply[i] = my_mining.capacity;
                    i++;
                }
                double sum_pk_supply = DMath.Arithmetic.sum(pk_supply);
                double max_pk_supply = pk_supply[DMath.Arithmetic.max(pk_supply)];
                
                double[] swu_supply = new double[my_enrichments.size()]; 
                double[] eup_supply = new double[my_enrichments.size()];
                i = 0;
                for (Enrichment my_en : my_enrichments) {
                    swu_supply[i] = my_en.capacity;
                    eup_supply[i] = my_en.hipp_capacity;
                    i++;
                }
                double sum_swu_supply = DMath.Arithmetic.sum(swu_supply);
                double max_swu_supply = swu_supply[DMath.Arithmetic.max(swu_supply)];
                double max_eup_supply = swu_supply[DMath.Arithmetic.max(eup_supply)];
                //try{
                JOptionPane.showMessageDialog(new JPanel(), "Критическая ошибка моделирования!\n Нехватка объемов предложенния для продолжения расчетов.", "Критическая ошибка!",
                    JOptionPane.ERROR_MESSAGE);
                    throw new Error("Too Many Needs");  
                /*}
                catch(Error e){
                    pk_yok(OrderedActors);
                    need_not_satisfied();
                    throw e;
                }*/
            }
        }
    }
    
    public void exec_pk(ArrayList<Enrichment> OrderedActors){
        ItickCount = 0;
        OrderedActors.forEach(a -> a.buy_pk());
        while(pk_need_not_satisfied()){
            while (is_running()){
                ContractChain.tick();          
            }
            ItickCount++;
            if (!pk_need_not_satisfied()) {
                ContractChain.clearR();
                break;
            }
            else if (ItickCount < 3){
                double N = calc_not_satisfied_pk_needs(OrderedActors);
                ArrayList<LinkedHashMap> E = new ArrayList();
                dump.increase_capacity(N);
                //increase_other_capacity(N*10);
                Queue.retrade_pk_crumbs(OrderedActors);
                ContractChain.clearR();
            }
            else{
                double[] pk_supply = new double[my_minings.size()]; 
                int i = 0;
                for (Mining my_mining : my_minings) {
                    pk_supply[i] = my_mining.capacity;
                    i++;
                }
                double sum_pk_supply = DMath.Arithmetic.sum(pk_supply);
                double max_pk_supply = pk_supply[DMath.Arithmetic.max(pk_supply)];
                throw new Error("Too Many Needs"); 
            }
        }
        
    }
    
    public void run_step_by_step(){
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public void setMy_regions(ArrayList<Region> my_regions) {
        this.my_regions = my_regions;
    }
    
    public void setMy_enrichments(ArrayList<Enrichment> my_enrichments) {
        this.my_enrichments = my_enrichments;
    }

    public void setMy_agents(ArrayList<Agent> my_agents) {
        this.my_agents = my_agents;
    }

    public void setMy_minings(ArrayList<Mining> my_minings) {
        this.my_minings = my_minings;
    }

    public void setMy_operators(ArrayList<Operator> my_operators) {
        this.my_operators = my_operators;
    }

    public void setMy_reactors(ArrayList<Reactor> my_reactors) {
        this.my_reactors = my_reactors;
    }
    
    public void setMy_mox_suppliers(ArrayList<MoxSupplier> my_mox_suppliers) {
        this.my_mox_suppliers = my_mox_suppliers;
    }
    
    public Trader getTrader(){
        return this.trader;
    }

    public void setAllActors() {
        if(this.AllActors != null )return; 
        this.AllActors = new ArrayList<Actor>(
            my_operators.size() + my_minings.size()
            + my_enrichments.size() + my_mox_suppliers.size());
        
        AllActors.addAll(my_operators);
        AllActors.addAll(my_minings);
        AllActors.addAll(my_enrichments);
        AllActors.addAll(my_mox_suppliers);
        AllActors.add(remix_supplier);
    }
    
    private void setup_trade_bulletin() {
        TradeBulletin tbulletin = new TradeBulletin();
        tbulletin.set_operators(my_operators);
        tbulletin.set_enrichments(my_enrichments);
        tbulletin.set_minings(my_minings);
        tbulletin.set_mox_suppliers(my_mox_suppliers);
        tbulletin.set_remix_supplier(remix_supplier);
        tbulletin.set_regions(my_regions);
        tbulletin.set_trader(trader);
        
        my_agents.forEach(my_agent -> my_agent.set_bulletin(tbulletin));
        
        World.set_tbulletin(tbulletin);
    }
    
    private boolean is_running() {
        tickCount++;
        if (tickCount < 2){
            return true;
        }
        return ContractChain.is_active();
        
    }
    
    public TreeMap<Integer, Country> getCountries(){
        return new TreeMap<Integer, Country>(this.scenario.getCountries());
    }

    private boolean need_not_satisfied() {
        if (ItickCount < 1)
            return true;
        for (Operator my_operator : my_operators) {
            if (Math.abs(my_operator.sum_needs) > 0.000001){
                ArrayList<Contract> cancelled_contracts = new ArrayList<>();
                Object[] unsatisfied_reactors_arr = my_operator.reactors.stream().filter(reac -> reac.fuel_needs >0.00000001).toArray();
                for (Object unsatisfied_reactor : unsatisfied_reactors_arr) {
                    Reactor r = (Reactor) unsatisfied_reactor;
                    System.err.println("Reactor "+r.getName() + " Unsatisfied");
                    Object[] O = ContractChain.getContracts().stream().filter(c -> c.get_reactor().equals(unsatisfied_reactor)).toArray();
                    for (Object obj : O) {
                        cancelled_contracts.add((Contract) obj);
                    }
                    O=null;
                }
                ArrayList<Integer> reasons = new ArrayList();
                cancelled_contracts.forEach(a -> reasons.add(a.reason));
                unsatisfied_reactors_arr = null;
                return true;
            }
        }
        if (Math.abs(trader.sum_needs) > 0.000001 ) 
            return true;
        return false;      
    }

    private double calc_max_pk_vol(){
        double volume[] = new double[my_minings.size()];
        int i = 0;
        for (Mining my_mining : my_minings) {
            volume[i] = my_mining.capacity;
            if (my_mining.equals(trader))
                volume[i] = 0;
            i++;
        }
        return volume[DMath.Arithmetic.max(volume)];
    }
    private boolean pk_yok(ArrayList<Actor> OrderedActors) {
        double volume[] = new double[my_minings.size()];
        int i = 0;
        for (Mining my_mining : my_minings) {
            volume[i] = my_mining.capacity;
            i++;
        }
        if (calc_max_pk_vol() < 600){
            return true;
        }
        ArrayList<Operator> operators = new ArrayList<>();
        for (Actor OrderedActor : OrderedActors) {
            if(OrderedActor.getClass().equals(Operator.class))
                operators.add((Operator) OrderedActor);
        }
        ArrayList<Contract> cancelled_contracts = new ArrayList<>();
        for (Operator operator : operators) {
            if (Math.abs(operator.sum_needs) > 0.000001){
                Object[] unsatisfied_reactors_arr = operator.reactors.stream().filter(reac -> reac.fuel_needs >0.00000001).toArray();
                for (Object unsatisfied_reactor : unsatisfied_reactors_arr) {
                    Reactor r = (Reactor) unsatisfied_reactor;
                    Object[] O = ContractChain.getContracts().stream().filter(c -> c.get_reactor().equals(unsatisfied_reactor) && c.product == Contract.P_OUP).toArray();
                    for (Object obj : O) {
                        cancelled_contracts.add((Contract) obj);
                    }
                }
            }
        }
        for (Contract cancelled_contract : cancelled_contracts) {
            if (cancelled_contract.reason == Contract.REASON_PK_YOK){
                return true;
            }
        }
        return false;
    }

    private void increase_other_capacity(double N) {
        my_enrichments.stream().filter(en -> en.id == 152).forEachOrdered(en -> en.increase_capacity(N));
    }

    private double calc_not_satisfied_needs(ArrayList<Actor> OrderedActors) {
        ArrayList<Operator> operators = new ArrayList<>();
        for (Actor OrderedActor : OrderedActors) {
            if(OrderedActor.getClass().equals(Operator.class))
                operators.add((Operator) OrderedActor);
        }
        double N = 0;
        for (Operator operator : operators) {
            if (Math.abs(operator.sum_needs) > 0.000001){
                Object[] unsatisfied_reactors_arr = operator.reactors.stream().filter(reac -> reac.fuel_needs >0.00000001).toArray();
                for (Object unsatisfied_reactor : unsatisfied_reactors_arr) {
                    Reactor r = (Reactor) unsatisfied_reactor;
                    N = N + r.fuel_needs;
                }
            }
        }
        return N;
    }

    private double calc_not_satisfied_pk_needs(ArrayList<Enrichment> OrderedActors) {
        double N = 0;
        for (Enrichment enrichment : OrderedActors) {
            if (Math.abs(enrichment.F) > 0.000001){
                    N = N + enrichment.F;
                }
            }
        return N;
    }
    
    private boolean pk_need_not_satisfied(){
        if (ItickCount < 1)
            return true;
        for (Enrichment my_enrichment : my_enrichments) {
            if (Math.abs(my_enrichment.F) > 0.000001){
                System.err.println("Enrichment "+my_enrichment.getName() + " Unsatisfied");
                return true;
            }
        }
        return false;
    }
}
