/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package smmum_alpha;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.time.LocalDate;
import java.util.ArrayList;
import java.util.logging.Level;
import java.util.logging.Logger;
import static smmum_alpha.ScenarioTest.DEFAULT_COMMERCIAL;

/**
 *
 * @author Dmitry
 */
public class DepositCapacityFiller {
    ArrayList<Country> my_countries;
    ArrayList<Deposit> deposits;
    String bd_path;
    String agents_table_path;
    String save_path;
    
    public void run(String bd_path, String agents_path, String save_path){
        this.bd_path = bd_path;
        this.agents_table_path = agents_path;
        this.save_path = save_path;
        load_country();
        load_deposits();
        calc_new_capacity();
        write_new_capacity();
    }
    
    private void load_country(){
        String sql_str = "SELECT *\n" +
                            "FROM countries";
        my_countries = new ArrayList<>() ;
        try {   
            DBDataLoader provider = new DBDataLoader(bd_path);
            ResultSet rsmain = provider.eval(sql_str);
            rsmain.beforeFirst();
            while(rsmain.next()){
                Country coun = new Country(rsmain.getInt("countries.id"), rsmain.getString("countries.country_name").trim());
                my_countries.add(coun);
            }
        } catch (SQLException ex) {
            Logger.getLogger(Reactor.class.getName()).log(Level.SEVERE, null, ex);
        }
        catch(java.lang.NullPointerException ex){
             System.out.println("Что-то сломалось");
        }      
    }
    
    private void load_deposits(){
        String sql_str = "SELECT *\n" +
                            "FROM deposits";
        deposits = new ArrayList<>() ;
        try {   
            DBDataLoader provider = new DBDataLoader(bd_path);
            ResultSet rsmain = provider.eval(sql_str);
            
            rsmain.beforeFirst();

            while(rsmain.next()){

                String dName = rsmain.getString("deposits.Dname");
                if (! rsmain.wasNull() ){
                  dName = dName.trim();  
                }              
                
                LocalDate start_date = (rsmain.getDate("deposits.Data start")).toLocalDate();

                int country_id = rsmain.getInt("deposits.country_id");
                int owner_id = rsmain.getInt("deposits.Owner_id");

                
                deposits.add(new Deposit(rsmain.getInt("deposits.id"),
                        dName, this.my_countries.get(country_id),
                        owner_id, rsmain.getDouble("deposits.Resource"), start_date));
                
            }
            provider.close_conn();
            
        } catch (SQLException ex) {
            Logger.getLogger(Reactor.class.getName()).log(Level.SEVERE, null, ex);
        }
         catch(java.lang.NullPointerException ex){
             System.out.println("Что-то сломалось");
        }   
    }

    private void calc_new_capacity() {
        double sum_cap = 0;
        for (Deposit deposit : deposits) {
                double prep_capacity = deposit.volume*0.02;
                if(prep_capacity < 200)
                    prep_capacity = 200;
                else if(prep_capacity > 8000)
                    prep_capacity = 8000;
                deposit.capacity = prep_capacity;
                
                sum_cap = sum_cap + prep_capacity;
                for (int i = 0; i < Time.years.length; i++) {
                    deposit.all_capacity[i] = prep_capacity;
                    if (deposit.status[i] == 0)
                        deposit.all_capacity[i] = 0;
                }
            }
        System.err.println(sum_cap);
    }

    private void write_new_capacity() {
        DBDataLoader provider = new DBDataLoader(bd_path);
        System.out.println( provider.check());
        int n = 1;
        for (Deposit deposit : deposits) {
            for (int i = 0; i < Time.years.length; i++) {
                String sql_str = "INSERT INTO deposit_history " + 
                        "(deposit_history.id, deposit_history.deposit_id, deposit_history.years, deposit_history.capacity)" +
                        "VALUES (" + n +","+ deposit.id +","+ Time.years[i] +","+ deposit.all_capacity[i]+")";
                n++;
                boolean result = provider.insert(sql_str);
                
            }
        }
    }
}
