/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package smmum_alpha;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.HashMap;
import java.util.Iterator;
import java.util.logging.Level;
import java.util.logging.Logger;
import org.apache.poi.xssf.usermodel.*;


/**
 *
 * @author Dima
 */
public class DepositFillerTenex{
    
    String bd_path;
    int n = 1;
    
    public DepositFillerTenex(String bd_path){
        this.bd_path = bd_path;
    }
    
    public void run(String file_path){
        
        try {
            ExelLoaderDFT EXL = new ExelLoaderDFT(file_path);
            HashMap<String, HashMap<String, Object>> ExlDepositData = EXL.read_data();
            write_ExlData_into_DB(ExlDepositData);
            
            write_history(ExlDepositData);
            
        } catch (IOException ex) {
            Logger.getLogger(DepositFillerTenex.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    private void write_ExlData_into_DB(HashMap<String, HashMap<String, Object>> ExlDepositData) {
        
        DBDataLoader provider = new DBDataLoader(bd_path);
        System.out.println( provider.check());
        
        
        ExlDepositData.forEach((key, value) -> {
            String sql_line = collect_sql_line(value,key);
            boolean result = provider.insert(sql_line);
            
        });
        provider.close_conn();
    }

    private String collect_sql_line(HashMap<String, Object> nash, String Dname) {
        String command = "INSERT INTO deposits_tenex ";
        String fields = "(id, Dname,";
        String values = " VALUES (" + n + ","+"\""+Dname+ "\",";
        for (HashMap.Entry<String, Object> pair : nash.entrySet()) {
            fields = fields + pair.getKey() + ", ";
            if (pair.getValue() instanceof String){
                values = values + "\"" + pair.getValue() + "\"" + ", ";
            }
            else{
                values = values + pair.getValue() + ", ";
                }
        }
        nash.put("id", n);
        fields = fields.substring(0, fields.length()-2);
        fields = fields+ ")";
        values = values.substring(0, values.length()-2);
        values = values+ ")";
        n++;
        return command + fields + values;
    }
    
    private void write_history(HashMap<String, HashMap<String, Object>> ExlDepositData) {
        DBDataLoader provider = new DBDataLoader(bd_path);
        n = 1;
        ExlDepositData.entrySet().forEach((deposit) -> {
            double prep_capacity = (double) deposit.getValue().get("Capacity");
            double[] all_capacity = new double[Time.years.length];
            Double start_double = (Double) deposit.getValue().get("Start");
            double[] status = init_status(start_double.intValue());
            for (int i = 0; i < Time.years.length; i++) {
                all_capacity[i] = prep_capacity;
                if (status[i] == 0)
                    all_capacity[i] = 0;
                String sql_str = "INSERT INTO deposit_tenex_history " + 
                        "(deposit_tenex_history.id, deposit_tenex_history.deposit_id, deposit_tenex_history.years, deposit_tenex_history.capacity)" +
                        "VALUES (" + n +","+ deposit.getValue().get("id") +","+ Time.years[i] +","+ all_capacity[i]+")";
                provider.insert(sql_str);
                n++;
            }
        });
        provider.close_conn();
        
    }
    
    private  double[] init_status(int start){
        double[] status = new double[Time.years.length];
        for (int i=0; i < status.length; i++){
            if (Time.years[i] < start) {
                status[i] = 0;
            }
            else{
                status[i] = 1;
            }
        }
        return status;
    }
    
    class ExelLoaderDFT{
        private String file_path;

        public ExelLoaderDFT(String file_path) {
            this.file_path = file_path;
        }

        private ExelLoaderDFT() {
            throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
        }
        
        
        public HashMap<String,HashMap<String,Object>> read_data() throws FileNotFoundException, IOException{
            
            HashMap<String, HashMap<String, Object>> res_table = new HashMap<>();    
            // Открываем книгу
            XSSFWorkbook book = new XSSFWorkbook(new FileInputStream(this.file_path));
            // Прочесть лист "Импорт"
            String sheet_name = "Импорт";
            XSSFSheet sheet = book.getSheet(sheet_name);
            // Считаем количество строк в листе
            int rowCount = sheet.getPhysicalNumberOfRows();
        
            // считываем шапку
            XSSFRow hat = sheet.getRow(0);
            // Для всех прочих строк
            for (int i = 1; i < rowCount; i++){
                XSSFRow row = sheet.getRow(i); 
                String Dname = row.getCell(0).getStringCellValue();  // назв-е страны по строке
                HashMap<String, Object> buf = new HashMap<>();
                for (int j=1; j < hat.getLastCellNum(); j++){
                    String header = hat.getCell(j).getStringCellValue();            
                switch (row.getCell(j).getCellType()) {
                    case XSSFCell.CELL_TYPE_BLANK:
                        buf.put(header, (double) 0);
                        //System.out.println(hat.getCell(j)+" :" + default_value[0]);
                        break;
                    case XSSFCell.CELL_TYPE_STRING:
                        //String name = row.getCell(j).getStringCellValue();
                        buf.put(header, row.getCell(j).getStringCellValue() );
                        //System.out.println(hat.getCell(j)+" : " + name);
                        break;
                    case XSSFCell.CELL_TYPE_NUMERIC:
                        //double value = row.getCell(j).getNumericCellValue();
                        buf.put(header, row.getCell(j).getNumericCellValue() );                        
                        //System.out.println(hat.getCell(j)+" :" + value);
                        break;
                    default:
                        break;
                }
                }
                res_table.put(Dname, buf);
            }
            
            return res_table;
        }
        
    }
    
}
