/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package smmum_alpha;

import DMath.FuzzyDiscount;
import com.fuzzylite.Engine;
import java.util.Collections;
import java.util.HashMap;

/**
 *
 * @author Dmitry
 */
public class EupDiscountFuzzyCalculator extends FuzzyCalculator {
    Enrichment enrichment;

    public EupDiscountFuzzyCalculator(Enrichment enrichment) {
        this.enrichment = enrichment;
    }
    

    @Override
    public double getCostPrice(Contract Cons) {
        return Cons.price/enrichment.cost;     
    }
    
    public double getSCostPrice(ContractSWUPK Cons) {
        return Cons.en_price/enrichment.cost;     
    }
    
    public double getSSpotPrice(ContractSWUPK Cons) {
        return Cons.en_price/World.spotSWUprice[Time.iTime];    
    }
    
    public double getLogistic(Contract c){
        Agent my_agent = enrichment.getAgent();
        HashMap<String, Double> aa = my_agent.getLogistics(Contract.P_OUP, c.year);
        double T = Collections.max(aa.values());
        if (T == 0) return 2.5;
        return aa.get(c.get_buyer().getAgent().getName())/T*5;
    }
    
    double calc_discount(Contract c){

        Engine engine = DMath.FuzzyStore.getEngine("discount",Contract.P_SWU, enrichment.getRegion().getBrain());
        FuzzyDiscount fis = new DMath.FuzzyDiscount(engine);
        fis.setBuyer_raiting(getBuyerRaiting(c));
        fis.setLogistic(getLogistic(c));
        if (c.getClass().equals(Contract.class))
            fis.setCost_price(getCostPrice(c));
        else
            fis.setCost_price(getSCostPrice((ContractSWUPK) c));
        if (c.getClass().equals(Contract.class))
            fis.setSpot_price(getSpotPrice(c));
        else
            fis.setSpot_price(getSSpotPrice((ContractSWUPK) c));
        fis.setPrice_dynamic(getPriceDynamic(c));
        fis.setSupply_demand(getDemandSupply(c));
        
        double discount = fis.eval();
        
        return discount; 
    }
}
