/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package smmum_alpha;

import DMath.FuzzyMarge;
import DMath.FuzzyPKMarge;
import com.fuzzylite.Engine;
import java.util.ArrayList;

/**
 *
 * @author Dima
 */
public class EupMargeFuzzyCalculator extends FuzzyCalculator{
    Enrichment enrichment;

    public EupMargeFuzzyCalculator(Enrichment enrichment) {
        this.enrichment = enrichment;
    }
    
    double calc_marge(Contract c){

        Engine engine = DMath.FuzzyStore.getEngine("marge",Contract.P_OUP, enrichment.getRegion().getBrain());
        FuzzyMarge fis = new DMath.FuzzyMarge(engine);
        fis.setCost_rank(getCostRank(c));
        fis.setRel_price(getRelPrice(c));
        fis.setLoading(getLoading(c));
        fis.setBuyer_raiting(getBuyerRaiting(c));
        fis.setPrice_dynamics(getPriceDynamic(c));
        fis.setSupply_demand(getDemandSupply(c));
        fis.setExpectense(getExpectence(c));
        fis.setCross_price_dynamics(getCrossPriceDynamic(c));
        
        double marge = fis.eval();
        
        return marge; 
    }
    
    double calc_marge(ContractSWUPK c){

        Engine engine_swu = DMath.FuzzyStore.getEngine("marge",Contract.P_SWU, enrichment.getRegion().getBrain());
        FuzzyMarge swu_fis = new DMath.FuzzyMarge(engine_swu);
        swu_fis.setCost_rank(getCostRank(c));
        swu_fis.setRel_price(getRelPrice(c));
        swu_fis.setLoading(getLoading(c));
        swu_fis.setBuyer_raiting(getBuyerRaiting(c));
        swu_fis.setPrice_dynamics(getPriceDynamic(c));
        swu_fis.setSupply_demand(getDemandSupply(c));
        swu_fis.setExpectense(getExpectence(c));
        swu_fis.setCross_price_dynamics(getCrossPriceDynamic(c));
        double marge = swu_fis.eval();
        
        return marge; 
    }
    
    @Override
    public double getBuyerRaiting(ContractSWUPK c){
        Agent agent = c.getEn_seller().getAgent();
        return agent.getRelation(c.get_buyer().getAgent().getName(),Time.yTime);
    }
    private double getLoading(Contract c) {
        ArrayList<Agreement> aa = enrichment.sales.get(c.year);
        double loading = 0;
        for (Agreement agreement : aa) {
            loading = loading + agreement.volume;
        }
        
        return loading/(enrichment.capacity/Time.years.length);
    }
    public double getRelPrice(ContractSWUPK c) {
        return enrichment.cost/World.spotSWUprice[DMath.Arithmetic.indexOf(Time.years, c.year)]; //To change body of generated methods, choose Tools | Templates.
    }
}
