/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package smmum_alpha;

import DMath.Arithmetic;
import static DMath.Arithmetic.sum;
import DMath.FuzzyRaiting;
import com.fuzzylite.Engine;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.HashMap;
import java.util.stream.Stream;

/**
 *
 * @author Dima
 */
public class EupRaitingFuzzyCalculator extends FuzzyCalculator{
    
    Operator operator;

    public EupRaitingFuzzyCalculator(Operator operator) {
        this.operator = operator;
    }
    
    public double getSupplierRaiting(Contract c){
        Agent agent = operator.getAgent();
        return agent.getRelation(c.get_seller().getAgent().getName(),Time.yTime);
    }
    
    @Override
    public double getRelPrice(Contract c){
        ArrayList<Contract> cons = (ArrayList<Contract>) c.getBrothers().clone();
        cons.add(c);
        double[] prices = new double[cons.size()];
        int i = 0;
        for (Contract con : cons) {
            prices[i] = con.getPrice();
            i++;
        }
        int M = Arithmetic.max(prices);
        return c.getPrice()/prices[M];
    }
    /*
    public double getSupplierShare(Contract c){
        try{
            HashMap v = ArchiveChain.getSpecificActorContract( c.year, operator);
            if (v == null){
                return 0;
            }
            Collection Values = v.values();
            ArrayList<Contract>ff = new ArrayList(Values);
            Stream<Contract> aa = ff.stream().filter(z -> z.get_seller().equals(c.get_seller()));
            Object[] tupoy_stream = aa.toArray();
            Contract[] cons = new Contract[tupoy_stream.length];
            int n = 0;
            for (Object object : tupoy_stream) {
                cons[n] = (Contract)object;
                n++;
            }
            if (cons.length >0){
                double[] sum_suuply = new double[cons.length];
                int i = 0;
                for (Contract con : cons) {
                    sum_suuply[i] = con.volume; 
                    i++;
                }
                return sum(sum_suuply)/operator.sum_needs;
            }else{
                return 0;
            }  
        }
        catch(java.lang.ClassCastException e){
             throw e; 
            }
            catch(Exception e){
                throw e;
            }
    }
    */
    public double getSpotPrice(Contract c){
        return c.price/World.spotEUPprice[Time.iTime];
    }
    
    public double getLogistic(Contract c){
        Agent my_agent = operator.getAgent();
        HashMap<String, Double> aa = my_agent.getLogistics(Contract.P_OUP, c.year);
        double T = Collections.max(aa.values());
        if (T == 0)
            return 2.5;
        return aa.get(c.get_seller().getAgent().getName())/T*5;
    }
    
    public double getExpectence(Contract c){
        return 5;
    }
    
    
    double calc_prioritet(Contract c) {
        Engine engine = DMath.FuzzyStore.getEngine("contr",c.product, operator.getRegion().getBrain());
        FuzzyRaiting fis = new DMath.FuzzyRaiting(engine);
        fis.setExpectense(getExpectence(c));
        fis.setLogistic(getLogistic(c));
        fis.setRelPrice(getRelPrice(c));
        fis.setSpotPrice(getSpotPrice(c));
        fis.setSupplierRaiting(getSupplierRaiting(c));
        fis.setSupplierShare(getSupplierShare(c));
        
        
        double[] Inputs = fis.getInputValues();
        c.setRaiting_inputs(Inputs);
        return fis.eval(); //To change body of generated methods, choose Tools | Templates.
    }
    
}
