/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package smmum_alpha;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.nio.file.FileSystems;
import java.nio.file.Files;
import java.nio.file.Path;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.Map;
import java.util.Set;
import java.util.function.Function;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import org.apache.commons.lang.math.NumberUtils;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.CellStyle;
import org.apache.poi.ss.usermodel.DataFormat;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.ss.usermodel.Workbook;
import org.apache.poi.xssf.usermodel.XSSFCell;
import org.apache.poi.xssf.usermodel.XSSFRow;
import org.apache.poi.xssf.usermodel.XSSFSheet;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;

/**
 *
 * @author z
 */
public class ExcelLoader<T> {
    
    private String file_path;
    private static final int VERTICAL = 1;
    private static final int HORIZONTAL = 0;
    private int Digits = 3;
    private int HeaderAlligement = HORIZONTAL;
    
    
    public void set_vertical_header(){
        HeaderAlligement = VERTICAL;
    }
    
    public ExcelLoader(String file_path) {
        this.file_path = file_path;
    }
    
    // <editor-fold defaultstate="collapsed" desc="Write to Excel Array with LinkedHashMap"> 
    // записывает в Excel на указанный лист данные по каждому объекту из массива (ОБЫЗАНЫ ИМЕТЬ ГЕТТЕР LinkedHashMap того, что надо записать!!!)
    public void writeIntoExcel(ArrayList<T> objs, Function<T,LinkedHashMap> func, String sheet_name)throws FileNotFoundException, IOException{      
 
        Path p = FileSystems.getDefault().getPath(this.file_path);

        if (p != null){
            // если файл не существует, то создать и записать
            if (!Files.exists(p)) {
                Files.createFile(p);
                try (BufferedOutputStream fos = new BufferedOutputStream(new FileOutputStream(new File(p.toString())))) {
                    Workbook workbook = new XSSFWorkbook();
                    Sheet sheet = workbook.createSheet(sheet_name);

                    createSheetHat(sheet, func.apply(objs.get(0)).keySet());     // создает шапку таблицы
                    writeInto(objs, func, sheet, sheet.getLastRowNum()+1);     // само заполнение
//getPhysicalNumberOfRows: удалять через функцию удаления строк!!!! если записи были удалены через delete, то все равно считает заполннными строками

                    workbook.write(fos);
                    workbook.close();
                }
                return;
            }

            // если уже существует, то просто дозаписываем данные в конец
            try (BufferedInputStream fis = new BufferedInputStream(new FileInputStream(new File(p.toString())))) {

                Workbook workbook = new XSSFWorkbook(fis);
                Sheet sheet = workbook.getSheet(sheet_name);
                if (sheet == null){
                    sheet = workbook.createSheet(sheet_name);
                    createSheetHat(sheet, func.apply(objs.get(0)).keySet());
                }
                int rowCount = sheet.getLastRowNum();

                writeInto(objs, func, sheet, rowCount+1);

                try (BufferedOutputStream fio = new BufferedOutputStream(new FileOutputStream(p.toString()))) {
                    workbook.write(fio);
                }
            }
            catch (java.io.FileNotFoundException ex){
                JOptionPane.showMessageDialog(new JPanel(), "Файл открыт!\nДля возможности записи, пожалуйста, закройте файл и повторите попытку.", "Исключение!",
                    JOptionPane.ERROR_MESSAGE);
            }
        }
        else{
            System.out.println("\n\n\n\n\n\n\np is NUUUUUUUUUUUUUUUUUUUUUUUUUL");
        }
    }
    

    private void createSheetHat(Sheet sheet, Set<?> keys){      
        Row row = sheet.createRow(0); 
        CellStyle headerVertStyle = sheet.getWorkbook().createCellStyle();
        headerVertStyle.setRotation((short) 90.0);
        Object[] iter = keys.toArray();
        for (int i=0; i < iter.length; i++){
            Cell cc = row.createCell(i);
            cc.setCellValue(String.valueOf(iter[i]));
            if(this.HeaderAlligement == VERTICAL){
                cc.setCellStyle(headerVertStyle);
            }
            sheet.autoSizeColumn(i);
        }
    }
    
    // вспомогательная функция для writeIntoExcel (чтобы не было нагромождения кода)
    private void writeInto(ArrayList<T> objs, Function<T,LinkedHashMap> func, Sheet sheet, int start){

        DataFormat format1 = sheet.getWorkbook().createDataFormat();
        CellStyle floatStyle = sheet.getWorkbook().createCellStyle();
        floatStyle.setDataFormat(format1.getFormat("#,##0.000"));
        
        DataFormat format2 = sheet.getWorkbook().createDataFormat();
        CellStyle intStyle = sheet.getWorkbook().createCellStyle();
        intStyle.setDataFormat(format2.getFormat("0"));
        
        for (int i=0; i < objs.size(); i++) {
            // Нумерация начинается со start
            Row row = sheet.createRow(start+i); 

            // Мы запишем инфу из полей Контракта в столбцы
            LinkedHashMap<String, Object> info = func.apply(objs.get(i));

            info = applyInflation(info);
            
            Object[] iter = info.values().toArray();
            for (int j=0; j < iter.length; j++){
                Cell cc = row.createCell(j);

                if (NumberUtils.isNumber(String.valueOf(iter[j]))){
                    if (NumberUtils.isDigits(String.valueOf(iter[j]))){
                        //cc.setCellValue(String.valueOf(iter[j]));
                        cc.setCellValue(Double.valueOf(String.valueOf(iter[j])));
                        cc.setCellStyle(intStyle);
                    }
                    else{
                        cc.setCellValue((double) iter[j]);
                        cc.setCellStyle(floatStyle);
                    }
                }
                else{
                    cc.setCellValue(String.valueOf(iter[j]));
                }
            }
        }
        
    }
    
        // вспомогательная функция для writeIntoExcel(LinkedHashMap<String, ?> mapa, String sheet_name)(чтобы не было нагромождения кода)
    public void writeIntoExcel(LinkedHashMap func, String sheet_name)throws FileNotFoundException, IOException{
        Path p = FileSystems.getDefault().getPath(this.file_path);
        if (p != null){
            // если файл не существует, то создать и записать
            if (!Files.exists(p)) {
                Files.createFile(p);
                try (BufferedOutputStream fos = new BufferedOutputStream(new FileOutputStream(new File(p.toString())))) {
                    Workbook workbook = new XSSFWorkbook();
                    Sheet sheet = workbook.createSheet(sheet_name);
                    createSheetHat(sheet, func.keySet());     // создает шапку таблицы
                    writeInto(func, sheet, sheet.getLastRowNum()+1);     // само заполнение
       //getPhysicalNumberOfRows: удалять через функцию удаления строк!!!! если записи были удалены через delete, то все равно считает заполннными строками
                    workbook.write(fos);
                    workbook.close();
                }
                return;
            }
            // если уже существует, то просто дозаписываем данные в конец
            try (BufferedInputStream fis = new BufferedInputStream(new FileInputStream(new File(p.toString())))) {
                Workbook workbook = new XSSFWorkbook(fis);
                Sheet sheet = workbook.getSheet(sheet_name);
                if (sheet == null){
                    sheet = workbook.createSheet(sheet_name);
                    createSheetHat(sheet, func.keySet());
                }
                int rowCount = sheet.getLastRowNum();
                writeInto(func, sheet, rowCount+1);
                try (BufferedOutputStream fio = new BufferedOutputStream(new FileOutputStream(p.toString()))) {
                    workbook.write(fio);
                }
            }
            catch (java.io.FileNotFoundException ex){
                JOptionPane.showMessageDialog(new JPanel(), "Файл открыт!\nДля возможности записи, пожалуйста, закройте файл и повторите попытку.", "Исключение!",
                    JOptionPane.ERROR_MESSAGE);
            }
        }
        else{
            System.out.println("\n\n\n\n\n\n\np is NUUUUUUUUUUUUUUUUUUUUUUUUUL");
        }
    }
    
    private double[] inflation(double[] array){
        // apply inflation function here
        double[] inf_array = new double[Time.lastTime];
        for (int i = 0; i < Time.lastTime; i++) {
          inf_array[i] =   array[i]*Math.pow(1+World.INFLATION_RATE,i);
        }
        // раскомментировать след.строку
        return inf_array;
    }
    
    public LinkedHashMap<String, Object> applyInflation(LinkedHashMap<String, Object> table){
        Object[] iter = table.values().toArray();
        
        // итерируемся по парам из мапы
        for (Map.Entry<String, Object> table_entry : table.entrySet()){
            // проверяем, содержит ли подстроки
            String key = table_entry.getKey().toLowerCase();
            String kesS = table_entry.getKey();
            if ((key.contains("price") || key.contains("цена") || key.contains("цены")) && !table_entry.getValue().getClass().equals(Double.class)){
                
                // если true, то применяем функцию inflation и заменяем в мапе
                double[] buf = (double[]) table_entry.getValue();
                table.replace(kesS, inflation(buf));

            }
        }
        
        return table;
    }
    
    private void writeInto(LinkedHashMap func, Sheet sheet, int start){
        DataFormat format = sheet.getWorkbook().createDataFormat();
        CellStyle floatStyle = sheet.getWorkbook().createCellStyle();
        floatStyle.setDataFormat(format.getFormat("#,##0.000"));
        LinkedHashMap<String, Object> info = func;
        
        info = applyInflation(info);
        
        CellStyle intStyle = sheet.getWorkbook().createCellStyle();
        intStyle.setDataFormat(format.getFormat("0"));
        // создаем столько строк, сколько лет
        for (int i=0; i < Time.years.length; i++) {
            // Нумерация начинается со start
            Row row = sheet.createRow(start+i);
            Object[] iter = info.values().toArray();
            for (int j=0; j < iter.length; j++){
                Cell cc = row.createCell(j);
                if (iter[j] instanceof int[]){
                    cc.setCellValue( Double.valueOf(String.valueOf( ( (int[])iter[j] )[i] )));
                    cc.setCellStyle(intStyle);
                }
                else if (iter[j] instanceof double[]){
                    cc.setCellValue( ( (double[])iter[j] )[i] );
                    cc.setCellStyle(floatStyle);
                }
                else if (iter[j] instanceof String[]){
                    cc.setCellValue(String.valueOf( ((String[])iter[j])[i] ));
                }
                else{
                    cc.setCellValue("Error");
                }
            }
        }
    }
    
    // </editor-fold>
    
    // <editor-fold defaultstate="collapsed" desc="Write to Excel Array from Statistic (Object is arrays of primitives type!!!)"> 
    
    public void writeIntoExcel(T obj, Function<T,LinkedHashMap> func, String sheet_name)throws FileNotFoundException, IOException{      
 
        Path p = FileSystems.getDefault().getPath(this.file_path);

        if (p != null){
            // если файл не существует, то создать и записать
            if (!Files.exists(p)) {
                Files.createFile(p);
                try (BufferedOutputStream fos = new BufferedOutputStream(new FileOutputStream(new File(p.toString())))) {
                    Workbook workbook = new XSSFWorkbook();
                    Sheet sheet = workbook.createSheet(sheet_name);

                    createSheetHat(sheet, func.apply(obj).keySet());     // создает шапку таблицы
                    writeInto(obj, func, sheet, sheet.getLastRowNum()+1);     // само заполнение
       //getPhysicalNumberOfRows: удалять через функцию удаления строк!!!! если записи были удалены через delete, то все равно считает заполннными строками

                    workbook.write(fos);
                    workbook.close();
                }
                return;
            }

            // если уже существует, то просто дозаписываем данные в конец
            try (BufferedInputStream fis = new BufferedInputStream(new FileInputStream(new File(p.toString())))) {

                Workbook workbook = new XSSFWorkbook(fis);
                Sheet sheet = workbook.getSheet(sheet_name);
                if (sheet == null){
                    sheet = workbook.createSheet(sheet_name);
                    createSheetHat(sheet, func.apply(obj).keySet());  
                }
                int rowCount = sheet.getLastRowNum();

                writeInto(obj, func, sheet, rowCount+1);

                try (BufferedOutputStream fio = new BufferedOutputStream(new FileOutputStream(p.toString()))) {
                    workbook.write(fio);
                }
            }
            catch (java.io.FileNotFoundException ex){
                JOptionPane.showMessageDialog(new JPanel(), "Файл открыт!\nДля возможности записи, пожалуйста, закройте файл и повторите попытку.", "Исключение!",
                    JOptionPane.ERROR_MESSAGE);
            }
        }
        else{
            System.out.println("\n\n\n\n\n\n\np is NUUUUUUUUUUUUUUUUUUUUUUUUUL");
        }
    }
    
 // вспомогательная функция для writeIntoExcel (чтобы не было нагромождения кода)
    private void writeInto(T obj, Function<T,LinkedHashMap> func, Sheet sheet, int start){

        DataFormat format1 = sheet.getWorkbook().createDataFormat();
        CellStyle floatStyle = sheet.getWorkbook().createCellStyle();
        floatStyle.setDataFormat(format1.getFormat("#,##0.000"));
        
        DataFormat format2 = sheet.getWorkbook().createDataFormat();
        CellStyle intStyle = sheet.getWorkbook().createCellStyle();
        intStyle.setDataFormat(format2.getFormat("0"));

        LinkedHashMap<String, Object> info = func.apply(obj);
        info = applyInflation(info);
        // создаем столько строк, сколько лет
        for (int i=0; i < Time.years.length; i++) {
            // Нумерация начинается со start
            Row row = sheet.createRow(start+i); 

            Object[] iter = info.values().toArray();
            for (int j=0; j < iter.length; j++){
                Cell cc = row.createCell(j);

                if (iter[j] instanceof int[]){
                    cc.setCellValue( ( (int[])iter[j] )[i] );
                    cc.setCellStyle(intStyle);
                }
                else if (iter[j] instanceof double[]){
                    cc.setCellValue( ( (double[])iter[j] )[i] );
                    cc.setCellStyle(floatStyle);
                }
                else if (iter[j] instanceof String[]){
                    cc.setCellValue(String.valueOf( ((String[])iter[j])[i] ));
                }
                else{
                    cc.setCellValue("Error");
                }
            }
        }
        
    }
    
    
    // </editor-fold>
    
    // <editor-fold defaultstate="collapsed" desc="Read from Excel tables to HashMap; here for Agennts' needs"> 
    // считыванние строки по индексу (инициализая книги внутри); если ячейка пустая, то заносим default
    public void readRowFromExcel(String sheet_name, int ind, Object ... default_value) throws IOException{
        XSSFWorkbook book = new XSSFWorkbook(new FileInputStream(this.file_path));
        XSSFSheet sheet = book.getSheet(sheet_name);  // возьмем лист sheet_name
        int rowCount = sheet.getPhysicalNumberOfRows();
        
        XSSFRow row = sheet.getRow(ind);
        XSSFRow hat = sheet.getRow(0);
        
        for (int j=0; j < hat.getLastCellNum(); j++){
            switch (row.getCell(j).getCellType()) {
                case XSSFCell.CELL_TYPE_BLANK:
                    System.out.println(hat.getCell(j)+" :" + default_value[0]);
                    break;
                case XSSFCell.CELL_TYPE_STRING:
                    String name = row.getCell(j).getStringCellValue();
                    System.out.println(hat.getCell(j)+" : " + name);
                    break;
                case XSSFCell.CELL_TYPE_NUMERIC:
                    double value = row.getCell(j).getNumericCellValue();
                    System.out.println(hat.getCell(j)+" :" + value);
                    break;
                default:
                    break;
            }
 
        }

        book.close();
    }
    
    // считыванние данных таблицы (ПО СТОЛБЦАМ) с ОДНОГО ЛИСТА (инициализация книги внутри); если ячейка пустая, то заносим default
    public HashMap<String, HashMap<String, Double>> readSheetFromExcel(String sheet_name, Object ... default_value) throws IOException{
        
        HashMap<String, HashMap<String, Double>> res_table = new HashMap<>();
        
        // Открываем книгу
        XSSFWorkbook book = new XSSFWorkbook(new FileInputStream(this.file_path));
        XSSFSheet sheet = book.getSheet(sheet_name);  // возьмем лист sheet_name!!!
        int rowCount = sheet.getPhysicalNumberOfRows();
        
        // считываем шапку
        XSSFRow hat = sheet.getRow(0);
        
        // без учета шапки счиытваем все строки и заносим в мапу: <hat.getCell(j), <row.getCell(0), row.getCell(j)>>
        for (int ind = 1; ind < rowCount; ind++){
            
            XSSFRow row = sheet.getRow(ind); 
            String countryRow = row.getCell(0).getStringCellValue();  // назв-е страны по строке

            for (int j=1; j < hat.getLastCellNum(); j++){
                HashMap<String, Double> buf = new HashMap<>();
                                
                switch (row.getCell(j).getCellType()) {
                    case XSSFCell.CELL_TYPE_BLANK:
                        buf.put(countryRow, (double) default_value[0]);
                        res_table.put(hat.getCell(j).getStringCellValue(), buf);
                        //System.out.println(hat.getCell(j)+" :" + default_value[0]);
                        break;
                    case XSSFCell.CELL_TYPE_STRING:
                        //String name = row.getCell(j).getStringCellValue();
                        buf.put(countryRow, Double.valueOf(row.getCell(j).getStringCellValue()) );
                        res_table.put(hat.getCell(j).getStringCellValue(), buf);
                        //System.out.println(hat.getCell(j)+" : " + name);
                        break;
                    case XSSFCell.CELL_TYPE_NUMERIC:
                        //double value = row.getCell(j).getNumericCellValue();
                        buf.put(countryRow, row.getCell(j).getNumericCellValue() );
                        res_table.put(hat.getCell(j).getStringCellValue(), buf);
                        //System.out.println(hat.getCell(j)+" :" + value);
                        break;
                    default:
                        break;
                }
            }
        }

        book.close();
        return res_table;
    }
    
    // то же самое, что и выше, но считает по индексу
    public HashMap<String, HashMap<String, Double>> readSheetFromExcel(int sheet_idx, Object ... default_value) throws IOException{
        
        HashMap<String, HashMap<String, Double>> res_table = new HashMap<>();
        
        // Открываем книгу
        XSSFWorkbook book = new XSSFWorkbook(new FileInputStream(this.file_path));
        XSSFSheet sheet = book.getSheetAt(sheet_idx);  // возьмем лист sheet_name!!!
        int rowCount = sheet.getPhysicalNumberOfRows();
        
        // считываем шапку
        XSSFRow hat = sheet.getRow(0);
        
        // без учета шапки счиытваем все строки и заносим в мапу: <hat.getCell(j), <row.getCell(0), row.getCell(j)>>
        for (int ind = 1; ind < rowCount; ind++){
            
            XSSFRow row = sheet.getRow(ind); 
            String countryRow = row.getCell(0).getStringCellValue();  // назв-е страны по строке

            for (int j=1; j < hat.getLastCellNum(); j++){
                HashMap<String, Double> buf;
                if (res_table.containsKey(countryRow)){
                    buf = res_table.get(countryRow);
                }
                else{
                    buf = new HashMap<>();
                }
                                
                switch (row.getCell(j).getCellType()) {
                    case XSSFCell.CELL_TYPE_BLANK:
                        buf.put(hat.getCell(j).getStringCellValue(), (double) default_value[0]);
                        res_table.put(countryRow, buf);
                        //System.out.println(hat.getCell(j)+" :" + default_value[0]);
                        break;
                    case XSSFCell.CELL_TYPE_STRING:
                        //String name = row.getCell(j).getStringCellValue();
                        buf.put(hat.getCell(j).getStringCellValue(), Double.valueOf(row.getCell(j).getStringCellValue()) );
                        res_table.put(countryRow, buf);
                        //System.out.println(hat.getCell(j)+" : " + name);
                        break;
                    case XSSFCell.CELL_TYPE_NUMERIC:
                        //double value = row.getCell(j).getNumericCellValue();
                        buf.put(hat.getCell(j).getStringCellValue(), row.getCell(j).getNumericCellValue() );
                        res_table.put(countryRow, buf);
                        //System.out.println(hat.getCell(j)+" :" + value);
                        break;
                    default:
                        break;
                }
            }
        }

        book.close();
        return res_table;
    }
    
   // считыванние данных таблицы (ПО СТОЛБЦАМ) со ВСЕХ ЛИСТОВ книги (инициализация книги внутри); если ячейка пустая, то заносим default
    // например, структура: <product, <country1, <country2, relate>>>
    public HashMap<String, HashMap<String, HashMap<String, Double>>> readBookFromExcel(Object ... default_value) throws IOException{
        
       HashMap<String, HashMap<String, HashMap<String, Double>>> res_table = new HashMap<>();
        
        // Открываем книгу
        XSSFWorkbook book = new XSSFWorkbook(new FileInputStream(this.file_path));
        int sheetsCount = book.getNumberOfSheets();
        
        for (int s = 0; s < sheetsCount; s++){
            
            XSSFSheet sheet = book.getSheetAt(s);  // возьмем лист по индексу s
            String sheet_name = sheet.getSheetName(); // имя листа для первого ключа
            
            res_table.put(sheet_name, readSheet(sheet, default_value));     // и заполняем
        }

        book.close();
        return res_table;
    }
     
    // считыванние данных таблицы (ПО СТОЛБЦАМ) с ОДНОГО ЛИСТА (БЕЗ инициализации); если ячейка пустая, то заносим default
    // вспомогательная к readRowsFromExcel(Object ... default_value)
    private HashMap<String, HashMap<String, Double>> readSheet(XSSFSheet sheet, Object ... default_value) throws IOException{
        
        HashMap<String, HashMap<String, Double>> res_table = new HashMap<>();

        // смотрим объем
        int rowCount = sheet.getPhysicalNumberOfRows();
        
        // считываем шапку
        XSSFRow hat = sheet.getRow(0);
        
        // без учета шапки счиытваем все строки и заносим в мапу: <hat.getCell(j), <row.getCell(0), row.getCell(j)>>
        for (int ind = 1; ind < rowCount; ind++){
            
            XSSFRow row = sheet.getRow(ind); 
            String countryRow = row.getCell(0).getStringCellValue();  // назв-е страны по строке
            
            for (int j=1; j < hat.getLastCellNum(); j++){
                HashMap<String, Double> buf;
                String countryColumn = hat.getCell(j).getStringCellValue();
                if (res_table.containsKey(countryColumn)){
                    buf = res_table.get(countryColumn);
                }
                else{
                    buf = new HashMap<>();
                }
                                
                switch (row.getCell(j).getCellType()) {
                    case XSSFCell.CELL_TYPE_BLANK:
                        buf.put(countryRow, (Double) default_value[0]);
                        res_table.put(countryColumn, buf);
                        //System.out.println(hat.getCell(j)+" :" + default_value[0]);
                        break;
                    case XSSFCell.CELL_TYPE_STRING:
                        //String name = row.getCell(j).getStringCellValue();
                        buf.put(countryRow, Double.valueOf(row.getCell(j).getStringCellValue()) );
                        res_table.put(countryColumn, buf);
                        //System.out.println(hat.getCell(j)+" : " + name);
                        break;
                    case XSSFCell.CELL_TYPE_NUMERIC:
                        //double value = row.getCell(j).getNumericCellValue();
                        buf.put(countryRow, row.getCell(j).getNumericCellValue() );
                        res_table.put(countryColumn, buf);
                        //System.out.println(hat.getCell(j)+" :" + value);
                        break;
                    default:
                        break;
                }
            }
        }

        return res_table;
    }
        
     // </editor-fold>
    
    public void setFilePath(String new_path){
        this.file_path = new_path;
    }

    public void writeReport(LinkedHashMap<String, Object> report_info, String SheetName) throws IOException {
        Path p = FileSystems.getDefault().getPath(this.file_path);
        Files.createFile(p);
        try (BufferedOutputStream fos = new BufferedOutputStream(new FileOutputStream(new File(p.toString())))) {
            Workbook workbook = new XSSFWorkbook();
            Sheet sheet = workbook.createSheet(SheetName);
            DataFormat format = workbook.createDataFormat();
            //createSheetHat(sheet, report_info.keySet());     // создает шапку таблицы
            Set<String> keys = report_info.keySet();
            Row row = sheet.createRow(0); 
            CellStyle headerVertStyle = workbook.createCellStyle();
            headerVertStyle.setRotation((short) 90.0);
            Object[] iter = keys.toArray();
            for (int i=0; i < iter.length; i++){
                Cell cc = row.createCell(i);
                cc.setCellValue(String.valueOf(iter[i]));
                if(this.HeaderAlligement == VERTICAL){
                    cc.setCellStyle(headerVertStyle);
                }
                
            }

           // writeInto(func, sheet, sheet.getLastRowNum()+1);     // само заполнение
            
            CellStyle intStyle = workbook.createCellStyle();
            intStyle.setDataFormat(format.getFormat("0"));
            CellStyle floatStyle = workbook.createCellStyle();
            floatStyle.setDataFormat(format.getFormat("#,##0.000"));
            int start = sheet.getLastRowNum()+1;
            for (int i=0; i < Time.years.length; i++) {
                // Нумерация начинается со start
                row = sheet.createRow(start+i);
                iter = report_info.values().toArray();
                for (int j=0; j < iter.length; j++){
                    Cell cc = row.createCell(j);
                    if (iter[j] instanceof int[]){
                        cc.setCellValue( Double.valueOf(String.valueOf( ( (int[])iter[j] )[i] )));
                        cc.setCellStyle(intStyle);
                    }
                    else if (iter[j] instanceof double[]){
                        cc.setCellValue( ( (double[])iter[j] )[i] );
                        cc.setCellStyle(floatStyle);
                    }
                    else if (iter[j] instanceof String[]){
                        cc.setCellValue(String.valueOf( ((String[])iter[j])[i] ));
                    }
                    else{
                        cc.setCellValue("Error");
                    }
                }
                sheet.autoSizeColumn(i);
            }
            workbook.write(fos);
            workbook.close();
        }
    }

}
