/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package smmum_alpha;

import DMath.FuzzyPkDiscount;
import com.fuzzylite.Engine;

/**
 *
 * @author Dmitry
 */
class MoxDiscountFuzzyCalculator extends FuzzyCalculator {
    MoxSupplier MX;
    RemixSupplier RX;
    MoxDiscountFuzzyCalculator(MoxSupplier MX) {
        this.MX = MX;
    }
    public MoxDiscountFuzzyCalculator(RemixSupplier RX) {
        this.RX = RX;
    }
    @Override
    public double getCostPrice(Contract Cons) {
        switch (Cons.product){
            case Contract.P_MOX: return Cons.price/MX.cost; 
            case Contract.P_REMIX: return Cons.price/RX.cost; 
            default: throw new Error("Not Mox or Remix");
        }    
    }
    
    
     double calc_discount(Contract c){
         switch (c.product){
             case Contract.P_MOX: return calc_mox_discount(c);
             case Contract.P_REMIX: return calc_remix_discount(c);
             default: throw new Error("Not Mox or Remix");
         }
         
     }
    
    double calc_mox_discount(Contract c){

        Engine engine = DMath.FuzzyStore.getEngine("discount",Contract.P_MOX, MX.getRegion().getBrain());
        FuzzyPkDiscount fis = new DMath.FuzzyPkDiscount(engine);
        fis.setBuyer_raiting(getBuyerRaiting(c));
        fis.setLogistic(getLogistic(c));
        fis.setCost_price(getCostPrice(c));
        fis.setSpot_price(getSpotPrice(c));
        fis.setPrice_dynamic(getPriceDynamic(c));
        fis.setSupply_demand(getDemandSupply(c));
        
        double discount = fis.eval();
        
        return discount; 
    }

    private double calc_remix_discount(Contract c) {
        Engine engine = DMath.FuzzyStore.getEngine("discount",Contract.P_MOX, RX.getRegion().getBrain());
        FuzzyPkDiscount fis = new DMath.FuzzyPkDiscount(engine);
        fis.setBuyer_raiting(getBuyerRaiting(c));
        fis.setLogistic(getLogistic(c));
        fis.setCost_price(getCostPrice(c));
        fis.setSpot_price(getSpotPrice(c));
        fis.setPrice_dynamic(getPriceDynamic(c));
        fis.setSupply_demand(getDemandSupply(c));
        double discount = fis.eval();
        
        return discount; 
    }
}
