/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package smmum_alpha;

import DMath.FuzzyMarge;
import com.fuzzylite.Engine;
import java.util.ArrayList;

/**
 *
 * @author Dmitry
 */
public class MoxMargeFuzzyCalculator extends FuzzyCalculator{
    MoxSupplier MX;
    RemixSupplier RX;
    public MoxMargeFuzzyCalculator(MoxSupplier MX) {
        this.MX = MX;
    }
    
    public MoxMargeFuzzyCalculator(RemixSupplier RX) {
        this.RX = RX;
    }
    
    @Override
    public double getRelPrice(Contract c) {
        switch (c.product){
            case Contract.P_MOX: return MX.cost/World.spotMOXprice[DMath.Arithmetic.indexOf(Time.years, c.year)];
            case Contract.P_REMIX: return RX.cost/World.spotREMIXprice[DMath.Arithmetic.indexOf(Time.years, c.year)];
            default: throw new Error("Not Mox or Remix");
        }
    }
    
    double calc_marge(Contract c){
        switch (c.product){
             case Contract.P_MOX: return calc_mox_marge(c);
             case Contract.P_REMIX: return calc_remix_marge(c);
             default: throw new Error("Not Mox or Remix");
         }
    }
    
    
    double calc_mox_marge(Contract c){

        Engine engine_pk = DMath.FuzzyStore.getEngine("marge",Contract.P_MOX, MX.getRegion().getBrain());
        FuzzyMarge pk_fis = new DMath.FuzzyMarge(engine_pk);
        pk_fis.setCost_rank(0);
        pk_fis.setRel_price(getRelPrice(c));
        pk_fis.setLoading(getLoading(c));
        pk_fis.setBuyer_raiting(getBuyerRaiting(c));
        pk_fis.setPrice_dynamics(getPriceDynamic(c));
        pk_fis.setSupply_demand(getDemandSupply(c));
        pk_fis.setExpectense(getExpectence(c));
        
        double marge = pk_fis.eval();
        
        return marge; 
    }
    
    private double getLoading(Contract c) {
        switch (c.product){   
        case Contract.P_MOX:{
            ArrayList<Agreement> aa = MX.sales.get(c.year);
            double loading = 0;
            for (Agreement agreement : aa) {
                loading = loading + agreement.volume;
            }

            return loading/(MX.capacity/Time.years.length);
            }
        case Contract.P_REMIX:{
            ArrayList<Agreement> aa = RX.sales.get(c.year);
            double loading = 0;
            for (Agreement agreement : aa) {
                loading = loading + agreement.volume;
            }

            return loading/(RX.capacity/Time.years.length);
            }
         default: throw new Error("Not Mox or Remix");
        }
    }

    private double calc_remix_marge(Contract c) {
        Engine engine = DMath.FuzzyStore.getEngine("marge",Contract.P_MOX, RX.getRegion().getBrain());
        FuzzyMarge fis = new DMath.FuzzyMarge(engine);
        fis.setCost_rank(0);
        fis.setRel_price(getRelPrice(c));
        fis.setLoading(getLoading(c));
        fis.setBuyer_raiting(getBuyerRaiting(c));
        fis.setPrice_dynamics(getPriceDynamic(c));
        fis.setSupply_demand(getDemandSupply(c));
        fis.setExpectense(getExpectence(c));
        fis.setCross_price_dynamics(getCrossPriceDynamic(c));
        
        double marge = fis.eval();
        
        return marge;
    }
}
