/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package smmum_alpha;

import DMath.FuzzyRaiting;
import com.fuzzylite.Engine;

/**
 *
 * @author Dmitry
 */
public class MoxRaitingFuzzyCalculator extends FuzzyCalculator{
    
    Operator operator;

    public MoxRaitingFuzzyCalculator(Operator operator) {
        this.operator = operator;
    }
    
    double calc_prioritet(Contract c){
        switch(c.product){
            case Contract.P_MOX: return calc_mox_prioritet(c);
            case Contract.P_REMIX: return calc_remix_prioritet(c);
            default: throw new Error("Not Mox or Remix");
        }
    }
    
    double calc_mox_prioritet(Contract c) {
        Engine engine = DMath.FuzzyStore.getEngine("contr",c.product, operator.getRegion().getBrain());
        FuzzyRaiting fis = new DMath.FuzzyRaiting(engine);
        fis.setExpectense(getExpectence(c));
        fis.setLogistic(getLogistic(c));
        fis.setRelPrice(getRelPrice(c));
        fis.setSpotPrice(getSpotPrice(c));
        fis.setSupplierRaiting(getSupplierRaiting(c));
        fis.setSupplierShare(getSupplierShare(c));
        
        
        double[] Inputs = fis.getInputValues();
        c.setRaiting_inputs(Inputs);
        return fis.eval(); 
    }

    @Override
    public double getRelPrice(Contract c) {
        switch (c.product){
            case Contract.P_REMIX: {
                return 0.5;
            }    
            case Contract.P_MOX: return super.getRelPrice(c);
            default: throw new Error("Not Mox or Remix");
        }
    }
    
    private double calc_remix_prioritet(Contract c) {
        Engine engine = DMath.FuzzyStore.getEngine("contr",Contract.P_MOX, operator.getRegion().getBrain());
        FuzzyRaiting fis = new DMath.FuzzyRaiting(engine);
        fis.setExpectense(getExpectence(c));
        fis.setLogistic(getLogistic(c));
        fis.setRelPrice(getRelPrice(c));
        fis.setSpotPrice(getSpotPrice(c));
        fis.setSupplierRaiting(getSupplierRaiting(c));
        fis.setSupplierShare(getSupplierShare(c));
        
        
        double[] Inputs = fis.getInputValues();
        c.setRaiting_inputs(Inputs);
        return fis.eval(); 
    }
}
