/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package smmum_alpha;

import DMath.FuzzyPKMarge;
import DMath.FuzzyPkDiscount;
import com.fuzzylite.Engine;
import java.util.Collections;
import java.util.HashMap;

/**
 *
 * @author Dima
 */
public class PKDiscountFuzzyCalculator extends FuzzyCalculator{
    Mining mining;

    public PKDiscountFuzzyCalculator(Mining mining) {
        this.mining = mining;
    }
    public double getLogistic(Contract c){
        Agent my_agent = mining.getAgent();
        HashMap<String, Double> aa = my_agent.getLogistics(Contract.P_PK, c.year);
        double T = Collections.max(aa.values());
        if (T == 0) return 2.5;
        return aa.get(c.get_buyer().getAgent().getName())/T*5;
    }

    @Override
    public double getSpotPrice(Contract c) {
       return c.price/World.spotPKprice[Time.iTime];
    }
    
    @Override
    public double getCostPrice(Contract Cons) {
        return Cons.price/mining.cost;     
    }
    
    public double getSCostPrice(ContractSWUPK Cons) {
        return Cons.pk_price/mining.cost;     
    }
    
    double calc_discount(Contract c){

        Engine engine_pk = DMath.FuzzyStore.getEngine("discount",Contract.P_PK, mining.getRegion().getBrain());
        FuzzyPkDiscount pk_fis = new DMath.FuzzyPkDiscount(engine_pk);
        pk_fis.setBuyer_raiting(getBuyerRaiting(c));
        pk_fis.setLogistic(getLogistic(c));
        if (c.getClass().equals(Contract.class))
            pk_fis.setCost_price(getCostPrice(c));
        else
            pk_fis.setCost_price(getSCostPrice((ContractSWUPK) c));
        pk_fis.setSpot_price(getSpotPrice(c));
        pk_fis.setSupply_demand(getDemandSupply(c));
        
        double discount = pk_fis.eval();
        
        return discount; 
    }
}
