/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package smmum_alpha;

import DMath.FuzzyPKMarge;
import com.fuzzylite.Engine;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.stream.Stream;


/**
 *
 * @author Dmitry
 */
public class PKMargeFuzzyCalculator extends FuzzyCalculator{
    
    Mining mining;

    public PKMargeFuzzyCalculator(Mining mining) {
        this.mining = mining;
    }

    @Override
    public double getDemandSupply(Contract c) {
        int ff = DMath.Arithmetic.indexOf(Time.years, c.year);
        double demand = World.total_pk_demand[ff];
        double supply = World.total_pk_supply[ff];
        return demand/supply;
    }

    @Override
    public double getRelPrice(Contract c) {
        if (Time.iTime >1){
            int m = DMath.Arithmetic.indexOf(Time.years, c.year);
            try {
                return c.get_seller().stats.pk_price[m]/World.spotPKprice[m];
            }
            catch(java.lang.NullPointerException err) {
                System.err.println("WHY!!!!!");
                throw err;
            }
        }
        else
            return 1;
    }
    public double getRelPrice(ContractSWUPK c) {
        if (Time.iTime >1){
            int m = DMath.Arithmetic.indexOf(Time.years, c.year);
            try {
                return c.getPk_seller().stats.pk_price[m]/World.spotPKprice[m];
            }
            catch(java.lang.NullPointerException err) {
                System.err.println("WHY!!!!!");
                throw err;
            }
        }
        else
            return 1;
    }
    
    @Override
    public double getSpotPrice(Contract c){
        // Если у меня уже есть заключенные  на  этот год договоры- сравниваю со спотом,
        // Если нет то ставлю 1
        ArrayList<Agreement> aa = mining.sales.get(c.year);
        
        if (aa.isEmpty()){
            return 1;
        }
        double revenue = 0;
        double volume = 0;
        for (Agreement agreement : aa) {
            revenue = agreement.price*agreement.eup_volume + revenue;
            volume = volume + agreement.volume;
        }
        return revenue/volume;
    }
    double getLoading(Contract c){
        ArrayList<Agreement> aa = mining.sales.get(c.year);
        double loading = 0;
        for (Agreement agreement : aa) {
            loading = loading + agreement.volume;
        }
        
        return loading/(mining.capacity/Time.years.length);
    }

    @Override
    public double getCostRank(Contract Cons) {
        ArrayList<Mining> all_actors = World.tbulletin.my_minings;
        double[] all_costs = all_actors.stream().mapToDouble(a -> a.cost).toArray();
        int m = DMath.Arithmetic.max(all_costs);
        return mining.cost/all_costs[m];
    }

    @Override
    public double getCrossPriceDynamic(Contract Cons) {
        if (Time.iTime == 0){
            return 0;
        }
        else{
            return (World.spotSWUprice[Time.iTime]-World.spotSWUprice[Time.iTime-1])/World.spotSWUprice[Time.iTime-1];
        }
    }
    
    
    double calc_marge(Contract c){

        Engine engine_pk = DMath.FuzzyStore.getEngine("marge",Contract.P_PK, mining.getRegion().getBrain());
        FuzzyPKMarge pk_fis = new DMath.FuzzyPKMarge(engine_pk);
        pk_fis.setCost_rank(getCostRank(c));
        if (c.getClass().equals(ContractSWUPK.class))
            pk_fis.setRel_price(getRelPrice((ContractSWUPK ) c));
        else
            pk_fis.setRel_price(getRelPrice(c));
        pk_fis.setLoading(getLoading(c));
        pk_fis.setBuyer_raiting(getBuyerRaiting(c));
        pk_fis.setPrice_dynamics(getPriceDynamic(c));
        pk_fis.setSupply_demand(getDemandSupply(c));
        pk_fis.setCross_price_dynamics(getCrossPriceDynamic(c));
     //   pk_fis.setExpectense(getExpectence(c));
        
        double marge = pk_fis.eval();
        
        return marge; 
    }
    
}
