/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package smmum_alpha;

import DMath.Arithmetic;
import DMath.FuzzyPkRaiting;
import com.fuzzylite.Engine;
import java.util.ArrayList;

/**
 *
 * @author Dmitry
 */
class PKRaitingFuzzyCalculator extends FuzzyCalculator{
    Actor buyer;

    PKRaitingFuzzyCalculator(Actor aThis) {
        buyer = aThis;
    }
    
     public double getPKDemandSupply(Contract c){
        int ff = DMath.Arithmetic.indexOf(Time.years, c.year);
        double pk_demand = World.total_pk_demand[ff];
        double pk_supply = World.total_pk_supply[ff];
        double TC = World.tbulletin.trader.capacity;
        return pk_demand/(pk_supply - TC);
    }
     
    public double getRelPkPrice(Contract c){
        ArrayList<Contract> cons = (ArrayList<Contract>) c.getBrothers().clone();
        cons.add(c);
        double[] prices = new double[cons.size()];
        int i = 0;
        for (Contract con : cons) {
            prices[i] = con.price;
            i++;
        }
        int M = Arithmetic.max(prices);
        return c.price/prices[M];
    }
    
    public double getSpotPrice(Contract c){
        return c.price/World.spotPKprice[Time.iTime];
    }

    
    public double getSupplierRaiting(Contract c, Actor actor){
        Agent agent = buyer.getAgent();
        return agent.getRelation(actor.getAgent().getName(),Time.yTime);
    }
    
    double calc_prioritet(Contract c){
    
        Engine engine_pk = DMath.FuzzyStore.getEngine("contr",Contract.P_PK, buyer.getRegion().getBrain());
        FuzzyPkRaiting pk_fis = new DMath.FuzzyPkRaiting(engine_pk);
        pk_fis.setCost_price(getCost_price(c));
        pk_fis.setSpotPrice(getSpotPrice(c));
        pk_fis.setRelPrice(getRelPkPrice(c));
        pk_fis.setSupplierRaiting(getSupplierRaiting(c, c.get_seller()));
        pk_fis.setDemand_supply(getPKDemandSupply(c));
        
        double pk_raiting = pk_fis.eval();
        
        return pk_raiting; 
    }
}
