/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package smmum_alpha;

import java.text.ParsePosition;
import java.text.SimpleDateFormat;
import java.time.LocalDate;
import java.time.ZoneId;
import java.util.ArrayList;
import java.util.Date;

/**
 *
 * @author Dmitry
 */
public class Reactor {



    
        int id;
        String name;
        String Rclass;
        String Rtype;
        double burnup;
        double termal_capacity;
        double electrical_capacity;
        double enrichment;
        double life_time = 60;
        double kpd;
        double first_load;
        double eaf = 0.8;
        double[] eafs = new double[Time.years.length];
        
        int[] status = new int[Time.years.length];
        LocalDate commercial;
        LocalDate construction;
        LocalDate shutdown = LocalDate.of(2085, 5, 27);
        
        Region region;
        Country country;
        
        double fuel_needs;
        double load_factor;
        int current_status;
        boolean ru_design;
        int type;
        double[] needs;
        static final double DAY_OF_YEAR = 365;
        
    public Reactor() {
    }
    public Reactor(String name) {
        this.name = name;
    }
    public Reactor(int id, String name, String Rclass, double burnup, double termal_capacity, double electrical_capacity, double enrichment, double kpd, double first_load, LocalDate commercial, LocalDate construction, Region region,  double load_factor, int current_status, boolean ru_design) {
        this.id = id;
        this.name = name;
        this.Rclass = Rclass;
        this.burnup = burnup;
        this.termal_capacity = termal_capacity;
        this.electrical_capacity = electrical_capacity;
        this.enrichment = enrichment;
        this.kpd = kpd;
        this.first_load = first_load;
        this.commercial = commercial;
        this.construction = construction;
        this.region = region;
        
        this.load_factor = load_factor;
        this.current_status = status[0];
        this.ru_design = ru_design;
        
        init_status();
    }
    
    public Reactor(int id, String name, String Rclass, double burnup, double termal_capacity, double electrical_capacity, double enrichment, double kpd, double first_load, LocalDate commercial, LocalDate construction, Region region, Country country, double load_factor, int current_status, boolean ru_design) {
        this.id = id;
        this.name = name;
        this.Rclass = Rclass;
        this.burnup = burnup;
        this.termal_capacity = termal_capacity;
        this.electrical_capacity = electrical_capacity;
        this.enrichment = enrichment;
        this.kpd = kpd;
        this.first_load = first_load;
        this.commercial = commercial;
        this.construction = construction;
        this.region = region;
        this.country = country;
        
        this.load_factor = load_factor;
        this.current_status = status[0];
        this.ru_design = ru_design;
        
        init_status();
    }
    
    public Reactor(int id, String name, String Rclass, double burnup, double termal_capacity, 
            double electrical_capacity, double enrichment, double kpd, double first_load,
            LocalDate commercial, LocalDate construction, LocalDate shutdown, Region region, Country country, double load_factor, int current_status, boolean ru_design) {
        this.id = id;
        this.name = name;
        this.Rclass = Rclass;
        this.burnup = burnup;
        this.termal_capacity = termal_capacity;
        this.electrical_capacity = electrical_capacity;
        this.enrichment = enrichment;
        this.kpd = kpd;
        this.first_load = first_load;
        this.commercial = commercial;
        this.construction = construction;
        this.shutdown = shutdown;
        this.region = region;
        this.country = country;
        
        this.load_factor = load_factor;
        this.current_status = status[0];
        this.ru_design = ru_design;
        
        init_status();
    }
    
    private double calc_fuel_needs() {
        if (current_status != 1){
            return 0;
        }
        double need;
        // int t = Time.iTime;
        need = termal_capacity/1000/burnup*load_factor*DAY_OF_YEAR;
        
        return need;
    }
    
    private double calc_fuel_needs(int year){
        ArrayList allyears = new ArrayList();
        for (int z : Time.years) {
            allyears.add(z);
        }
            int n = allyears.indexOf(year);
        if (status[n] == 1){
            return termal_capacity/1000/burnup*load_factor*DAY_OF_YEAR;
        }else{
            return 0;
        }    
    }
    
    private void init_status(){
        for (int i=0; i < this.status.length; i++){
            if ((Time.years[i] < this.commercial.getYear()) || (this.shutdown.getYear() < Time.years[i])){
                this.status[i] = 0;
            }
            else{
                this.status[i] = 1;
            }
        }
    }
    
    void init_need() {
        double need;
        int[] ii = Time.years;
        needs = new double[ii.length];
        int n = 0;
        for (int i : ii) {
            need = calc_fuel_needs(i);
            needs[n] = need;
            n++;
        }
        this.fuel_needs = needs[0];
    }
    
    public void set_type(int t){
        this.type = t;
    }
    
    public void setEafs(double[] e){
        this.eafs = e;
    }
    
    public void setEafs(double e, int pos){
        this.eafs[pos] = e;
    }
    
    public void setCountry(Country c){
        this.country = c;
    }
    
    public void setRegion(Region c){
        this.region = c;
    }
    
    public void setCommercial(String date){
        SimpleDateFormat simpleFormatter = new SimpleDateFormat("dd/MM/yyyy");
        Date dd = simpleFormatter.parse(date, new ParsePosition(0));
        this.commercial = dd.toInstant().atZone(ZoneId.systemDefault()).toLocalDate();
    }
    
    public void setFirstLoad(double fl){
        this.first_load = fl;
    }
    
    public void setLoadFactor(double lf){
        this.load_factor = lf;
    }
    
    void restore_need(){
        if( Time.iTime < Time.lastTime-1){
            this.fuel_needs = needs[Time.iTime+1];
            this.current_status = status[Time.iTime+1];
        }
    }
    
    void satisfy_needs(double v){
        this.fuel_needs = this.fuel_needs - v;
    }
    
    static double recalc_mox(double need) {
        
        /**
            * @deprecated "Not matan formula is ready yet. My Inglish is intends to be bad"
        */
        return need;
    }
       
    static double recalc_remix(double need, Reactor r) {
        return need;
    }
    
    public String getName(){
        return this.name;
    } 
    
    public Region getRegion(){
        return this.region;
    }
    
    public Country getCountry(){
        return this.country;
    }
    
    public LocalDate getCommercial(){
        return this.commercial;
    }
    
    public double getFirstLoad(){
        return this.first_load;
    }
    
    public double getLoadFactor(){
        return this.load_factor;
    }
    
    public String getRclass(){
        return this.Rclass;
    }
    
    public double getKpd(){
        return this.kpd;
    }
    
    public double getEaf(){
        return this.eaf;
    }
    
    public double[] getEafs(){
        return this.eafs;
    }
    
    public double getBurnup(){
        return this.burnup;
    }
    
    public double getElectricalCapacity(){
        return this.electrical_capacity;
    }
    
    public double getTermalCapacity(){
        return this.termal_capacity;
    }
    
    public int getType(){
        return this.type;
    }

    public double getNeeds(int year) {
        return needs[DMath.Arithmetic.indexOf(Time.years, year)];
    }
    
    
    
    public void setName(String name){
        this.name = name;
    }
    
    public void setRclass(String Rclass){
        this.Rclass = Rclass;
    }
        
    public void setKpd(double kpd){
        this.kpd = kpd;
    }
        
    public void setBurnup(double burnup){
        this.burnup = burnup;
    }
    
    public void setElectricalCapacity(double cap){
        this.electrical_capacity = cap;
    }
    
    public void setTermalCapacity(double cap){
        this.termal_capacity = cap;
    }

    double calc_energy() {
        return electrical_capacity*eaf*365*24;
    }
    
    void set_trade_schema(int type){
        this.type = type;
    }
}
