/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package smmum_alpha;

import java.sql.ResultSet;
import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author Dmitry
 */
public class Region {
        //static final String bd_path = "D:\\МИФИ\\Харитонов\\Техснаб_2018\\TS_Base_v_0_4_5.accdb";
        String bd_path;
        String name;
        Object MeanPrices;

        int max_iteration = 3;
        public static int BAmerica = 1;
        public static int BEurope = 2;
        public static int BAsia = 3;
        int Brain;
        ArrayList<Country> countries;
        int id;

    public Region(String name, int id, int brain) {
        this.name = name;
        this.id = id;
        countries = new ArrayList();
        fillCountries(name);
        Brain = brain;
    }
    public Region(String name, int id, int brain, String DB_path) {
        this.name = name;
        this.id = id;
        bd_path = DB_path;
        countries = new ArrayList();
        fillCountries(name);
        Brain = brain;
    }
    public Region(String name, int id, boolean un) {
        this.name = name;
        this.id = id;
        countries = new ArrayList();
    }

    public int getId() {
        return id;
    }
    
    public int getBrain(){
    
        return BAsia;
    }
    
    public String getName(){
        return this.name;
    }
    public ArrayList<Country> getCountries(){
        return this.countries;
    }

    void addCountry(Country с) {
        countries.add(с);
    }

    public void setBd_path(String bd_path) {
        this.bd_path = bd_path;
    }
    
    private void fillCountries(String name){
              
        String sql_str = "SELECT countries.[id], countries.[country_name], countries.[subregion], countries.[region], countries.[region_id]\n" +
                        "FROM countries\n" +
                        "WHERE (((countries.[subregion])=\""+name+"\"));";
        
        try {
            System.out.println("\t\tGoooooood");
            DBDataLoader provider = new DBDataLoader(this.bd_path);
            ResultSet rsmain = provider.eval(sql_str);

            rsmain.beforeFirst();
            while(rsmain.next()){
                Country coun = new Country(rsmain.getInt("countries.id"), rsmain.getString("countries.country_name").trim(), name);
                coun.setVolumes(getCountryParams(rsmain.getInt("countries.id")));
                if (coun.volume40 >0){
                    coun.current_cost = 40;
                }
                else{
                    if(coun.volume80 >0){
                        coun.current_cost = 80;
                    }else{
                        if(coun.volume130 >0){
                            coun.current_cost = 130;
                        } else{
                            coun.current_cost = 260;
                        }
                    }
                }
                this.countries.add(coun);    //rsmain.getString("countries.subregion").trim()
            }
            provider.close_conn();
        }
        catch(Exception ex){
           System.out.print("Connection failed.\n");
           ex.printStackTrace();
           Logger.getLogger(Reactor.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    private double[] getCountryParams(int id){
              
        String sql_str = "SELECT country_uranium.[id], country_uranium.[Country_id], country_uranium.[resources _40], country_uranium.[resources _80], country_uranium.[resources _130], country_uranium.[resources _260]\n" +
                            "FROM country_uranium\n" +
                        "WHERE ((country_uranium.[Country_id] = "+String.valueOf(id)+"))";
        double[] volumes = {0,0,0,0};
        
        try {
            //System.out.println("\t\tGoooooood");
            DBDataLoader provider = new DBDataLoader(this.bd_path);
            ResultSet rsmain = provider.eval(sql_str);

            rsmain.beforeFirst();
           
            while(rsmain.next()){
                volumes[0] = rsmain.getInt("country_uranium.resources _40");
                volumes[1] = rsmain.getInt("country_uranium.resources _80");
                volumes[2] = rsmain.getInt("country_uranium.resources _130");
                volumes[3] = rsmain.getInt("country_uranium.resources _260");

            }
            provider.close_conn();
        }
        catch(Exception ex){
           System.out.print("Connection failed.\nBAAAAAAAAAAAAAAAAAAAAAAAAAD");
           ex.printStackTrace();
           Logger.getLogger(Reactor.class.getName()).log(Level.SEVERE, null, ex);
        }
        
        return volumes;
    }
    
    
    LinkedHashMap<String, Object> assembleSet(){
        double[] current_cost_v = new double[Time.years.length];
        double[] volume40_v = new double[Time.years.length];
        double[] volume80_v = new double[Time.years.length];
        double[] volume130_v = new double[Time.years.length];
        double[] volume260_v = new double[Time.years.length];
         double[] extracted = new double[Time.years.length];

         for (int i = 0; i < Time.lastTime; i++) {
            for (Country country : countries){
                 current_cost_v[i] = country.current_cost_v[i] + current_cost_v[i];
                 volume40_v[i] = country.volume40_v[i] + volume40_v[i];
                 volume80_v[i] = country.volume80_v[i] + volume80_v[i];
                 volume130_v[i] = country.volume130_v[i] + volume130_v[i];
                 volume260_v[i] = country.volume260_v[i] + volume260_v[i];
                 extracted[i] = country.extracted[i] + extracted[i];
            }
            current_cost_v[i] = current_cost_v[i]/countries.size();
        }
        LinkedHashMap<String, Object> Eimport = new LinkedHashMap<>();
        Eimport.put("Года", Time.years);
        Eimport.put("current cost", current_cost_v);
        Eimport.put("volume40", volume40_v);
        Eimport.put("volume80", volume80_v);
        Eimport.put("volume130", volume130_v);
        Eimport.put("volume260", volume260_v);
        Eimport.put("extracted", extracted);
        return Eimport;
    }
}
