/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package smmum_alpha;

import java.io.IOException;
import java.time.LocalDate;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author Dima
 */
public class Scenario {
    static final double DEFAULT_RELATIONS = 5.0; 
    static final double DEFAULT_ONE_REGION_RELATIONS = 9.0; 
    static final double DEFAULT_SELF_RELATIONS = 10.0; 
    static final double DEFAULT_QUOTAS = Double.POSITIVE_INFINITY; 
    static final double DEFAULT_LOGISTIC = 0.0; 
    private String AGENT_FOULDER = "./";
    /*
    private HashMap<String, HashMap<String, HashMap<Integer,Double>>> readed_rel = new HashMap<>();
    private HashMap<String,HashMap<Short, HashMap<Integer, HashMap<String,Double>>>> readed_log = new HashMap<>();
    private HashMap<String,HashMap<Short, HashMap<String, HashMap<Integer,Double>>>> readed_quota = new HashMap<>();
    */
    private String EXCEL_RELATIONS_PATH = AGENT_FOULDER + "polit_relation.xlsx"; 
    private String EXCEL_QUOTAS_PATH = AGENT_FOULDER + "quotas.xlsx";
    private String EXCEL_LOGISTICS_PATH = AGENT_FOULDER + "logistic.xlsx"; 
    String bd_path = ".\\TS_Base_v_0_5_4.accdb";
    DemoModule module;
    protected HashMap<Integer, Country> my_countries = new HashMap<>();
    
    public Scenario(){
        
    }

    public void setAGENT_FOULDER(String AGENT_FOULDER) {
        this.AGENT_FOULDER = AGENT_FOULDER;
        
        setEXCEL_RELATIONS_PATH(AGENT_FOULDER + "polit_relation.xlsx");
        setEXCEL_QUOTAS_PATH(AGENT_FOULDER + "quotas.xlsx");
        setEXCEL_LOGISTICS_PATH(AGENT_FOULDER + "logistic.xlsx");
    }

    public void setEXCEL_RELATIONS_PATH(String EXCEL_RELATIONS_PATH) {
        this.EXCEL_RELATIONS_PATH = EXCEL_RELATIONS_PATH;
    }

    public void setEXCEL_QUOTAS_PATH(String EXCEL_QUOTAS_PATH) {
        this.EXCEL_QUOTAS_PATH = EXCEL_QUOTAS_PATH;
    }

    public void setEXCEL_LOGISTICS_PATH(String EXCEL_LOGISTICS_PATH) {
        this.EXCEL_LOGISTICS_PATH = EXCEL_LOGISTICS_PATH;
    }
    
    Scenario(DemoModule aThis) {
        module = aThis;
    }
   
    public void setBd_path(String bd_path) {
        this.bd_path = bd_path;
    }
    public void setup(){
        ContractChain.clear();
        ArchiveChain.clear();
        //Time.set_iTime(1);
        Time.set_yTime(2018);
        Time.set_lastTime(5);
        Time.set_years_size();
        
        create_regions();
        create_agents();
        create_operators();
        crate_minings();
        create_enrichments();
        create_mox_supplier();
       // World.setStart();
        
        
        
    }
    
    public void create_regions() {
        Region gondor = new Region("Gondor", 4, true);
        gondor.getCountries().forEach(coun -> this.my_countries.put(coun.getId(), coun));
        Region valinor = new Region("Valinor", 3, true);
        valinor.getCountries().forEach(coun -> this.my_countries.put(coun.getId(), coun));
        Region mordor = new Region("Mordor", 2, true);
        mordor.getCountries().forEach(coun -> this.my_countries.put(coun.getId(), coun));
        ArrayList<Region> my_regions = new ArrayList<>();
        my_regions.add(gondor);
        my_regions.add(valinor);
        my_regions.add(mordor);
        
        module.setMy_regions(my_regions);
    }
    
    public void create_agents() {
        Agent a1 = new Agent("Agent1");
        Agent a2 = new Agent("Agent2");
        Agent a3 = new Agent("Agent3");
        Agent a4 = new Agent("Agent4");
        ArrayList<Agent> my_agents = new ArrayList<>();
        my_agents.add(a1);
        my_agents.add(a2);
        my_agents.add(a3);
        my_agents.add(a4);
        ArrayList<String> agent_names = new ArrayList(my_agents.size());
            for (int i=0; i < my_agents.size(); i++){
                agent_names.add(i, my_agents.get(i).getName());
            }
        my_agents.forEach((t) -> {t.initLogistics(agent_names);});
        my_agents.forEach((t) -> {t.initQuotas(agent_names);});
        my_agents.forEach((t) -> {t.initRelations(agent_names);});
        module.setMy_agents(my_agents);
    }
    
    void create_operators() {
        double[] supply = new double[1];
        supply[0] = 0;
        ArrayList reactor_list = new ArrayList();
        LocalDate construction = LocalDate.of(1988, 6, 22);
        LocalDate commercial = LocalDate.of(2017, 5, 27);
        
        Reactor reactor1 = new Reactor(1, "R1", "VVER_1000", 40, 3200, 1056, 0.03, 
                0.33, 0,commercial, construction, (Region) module.my_regions.get(2), 
                this.my_countries.get(2), 0.75, 1, true);
        reactor1.type = 2;
        reactor_list.add(reactor1);
        
        Reactor reactor2 = new Reactor(2, "R2", "VVER_1000", 40, 4000, 1320, 0.05, 
                0.33, 0,commercial, construction, (Region) module.my_regions.get(2),
                this.my_countries.get(2), 0.75, 1, true);
        reactor2.type = 2;
        reactor_list.add(reactor2);
        
        Reactor reactor3 = new Reactor(1, "R3", "VVER_1000", 40, 3200, 1056, 0.03, 
                0.33, 0,commercial, construction, (Region) module.my_regions.get(2), 
                this.my_countries.get(2), 0.75, 1, true);
        reactor3.type = 2;
        reactor_list.add(reactor3);
        
        
        Operator oper1;
        oper1 = new Operator(reactor_list, supply, 3 , 0);
        oper1.set_actor_params(0, "Minas-Tirit",(Region) module.my_regions.get(1), (Agent) module.my_agents.get(0));
        ArrayList<Operator> my_operators = new ArrayList<>();
        oper1.setThreshold(5);
        my_operators.add(oper1);
        
        my_operators.forEach((Operator oper) -> oper.init_fuel_needs());
        
        module.setMy_operators(my_operators);
        module.setMy_reactors(reactor_list);
    }
    
    
    
    void crate_minings() {
       ArrayList<Mining> my_minings = new ArrayList<>();
        double[] a1 = {1500,1450,1450,1450,1450 };
        double[] c1 = {30,35,35,35,35};
        Mining mining1 = new Mining(a1, c1, a1[0], c1[0]);
        mining1.set_actor_params(0, "Aglarond", (Region) module.my_regions.get(1), module.my_agents.get(1));
        my_minings.add(mining1);
        
        double[] a2 = {1400,1600,1600,1600,1600};
        double[] c2 = {25,45,45,45,45};
        Mining mining2 = new Mining(a2, c2, a1[0], c1[0]);
        mining2.set_actor_params(1, "Nurnen", (Region) module.my_regions.get(2), module.my_agents.get(2));
        my_minings.add(mining2);
        
        module.setMy_minings(my_minings);
    }
    void create_trader(){
        Trader trader = new Trader();
        module.my_minings.add(trader);
        module.trader = trader;
        trader.pbase = Producer.PBASE_PRICE;
        trader.threshold = 8;
        
    }
    void create_enrichments() {
        double[] a1 = {1400,1600,1600,1600,1600};
        double[] c1 = {30,35,35,35,35};
        Enrichment enr1 = new Enrichment(a1[0], c1[0], a1, c1);
        enr1.set_actor_params(0, "Orodruin", (Region) module.my_regions.get(2), module.my_agents.get(2));
        ArrayList<Enrichment> my_enrichments = new ArrayList<>();
        my_enrichments.add(enr1);
        
        double[] a2 = {1400,1600,1600,1600,1600};
        double[] c2 = {30,35,35,35,35};
        Enrichment enr2 = new Enrichment(a2[0], c2[0], a2, c2);
        enr2.set_actor_params(1, "Baalor", (Region) module.my_regions.get(2), module.my_agents.get(3));
        my_enrichments.add(enr2);
        
        module.setMy_enrichments(my_enrichments);
    }
    
    void create_mox_supplier() {
        double[] a1 = {2000,3000,2500,3000,3500};
        double[] c1 = {30,35,35,35,30};
        MoxSupplier mox1 = new MoxSupplier(a1[0], c1[0], a1, c1);
        mox1.set_actor_params(0, "Morannon", (Region) module.my_regions.get(2), module.my_agents.get(3));
        ArrayList<MoxSupplier> my_mox_suppliers = new ArrayList<>();
        my_mox_suppliers.add(mox1);
        module.setMy_mox_suppliers(my_mox_suppliers);
    }

    // TODO: убрать? Кажется, он нигде уже не используется
    public void create_countries() {
        ArrayList<Country> countries = new ArrayList<>();
       int i = 0;
        for (Region my_region : module.my_regions) {
            countries.add(new Country(  i, my_region.getName(), my_region.getName()));
            my_region.addCountry(countries.get(i));
            i++;
        }
        
        for (int j=0; j < countries.size(); j++){
            this.my_countries.put(j, countries.get(j));
        }
        //module.setMy_countries(my_countries);
    }
    
    public HashMap<Integer, Country> getCountries(){
        return this.my_countries;
    }
    /*
    public HashMap<String, HashMap<String, HashMap<Integer,Double>>> getReadedRel(){
        return this.readed_rel;
    }
    
    public HashMap<String,HashMap<Short, HashMap<Integer, HashMap<String,Double>>>> getReadedLog(){
        return this.readed_log;
    }
    
    public HashMap<String,HashMap<Short, HashMap<String, HashMap<Integer,Double>>>> getReadedQuota(){
        return this.readed_quota;
    }*/
    
    //<editor-fold defaultstate="collapsed" desc="readAndFillAgentsParamsByRegions">   
    public void readAndFillAgentsParamsByRegions(ArrayList<Agent> my_agents){
        // read from ExcelByRegions and filling agents 

        // для удобства - мапы, отображающие продукты
        HashMap<String, Short> products = new HashMap<>();
        products.put("ОУП", Contract.P_OUP);
        products.put("ПК", Contract.P_PK);
        products.put("ЕРР", Contract.P_SWU);
        products.put("МОКС", Contract.P_MOX);
        products.put("РЕМИКС", Contract.P_REMIX);
        
        readAndFillAgentsRelationsByRegions(my_agents, EXCEL_RELATIONS_PATH);
        readAndFillAgentsQuotasByRegions(my_agents, products, EXCEL_QUOTAS_PATH);
        readAndFillAgentsLogisticsByRegions(my_agents, products, EXCEL_LOGISTICS_PATH);
        
    }
    
    private void readAndFillAgentsRelationsByRegions(ArrayList<Agent> my_agents, String path){
        // read from ExcelByRegions and filling agents' relations 
        
        ExcelLoader<Agent> el = new ExcelLoader<>(path);
        HashMap<String, HashMap<String, Double>> mapa = new HashMap<>();
        try {
            mapa = el.readSheetFromExcel(0);
        } catch (IOException ex) {
            Logger.getLogger(Scenario.class.getName()).log(Level.SEVERE, null, ex);
        }
        
        for (int i=0; i < my_agents.size(); i++){
            Agent ag1 = my_agents.get(i);
            String reg_name1 = ag1.getRegion().getName();
            
            for (int j=0; j < my_agents.size(); j++){
                Agent ag2 = my_agents.get(j);
                String reg_name2 = ag2.getRegion().getName();
                
                for (int k=0; k < Time.years.length; k++){
                    if (reg_name1.equals(reg_name2)){
                        ag1.setRelation(ag2.getName(), Time.years[k], DEFAULT_ONE_REGION_RELATIONS);    
                    }
                    else{
                       // System.err.println(ag2.getName() + " " + Time.years[k] + " " + mapa.get(reg_name1).get(reg_name2) + " " +reg_name1 + " "+ reg_name2);
                        
                        ag1.setRelation(ag2.getName(), Time.years[k], mapa.get(reg_name1).get(reg_name2));    
                    }
                    
                    ag1.setRelation(ag1.getName(), Time.years[k], DEFAULT_SELF_RELATIONS);    
                }
            }    
            ag1.setReadedRelations(ag1.getRelations()); // это заполнение полей прочитанных мапов только что прочитанными соотв. мапами
        }

    }
    
    private void readAndFillAgentsQuotasByRegions(ArrayList<Agent> my_agents, HashMap<String, Short> products, String path){
        // read from ExcelByRegions and filling agents' relations 
        
        ExcelLoader<Agent> el = new ExcelLoader<>(path);
        HashMap<String, HashMap<String, HashMap<String, Double>>> mapa = new HashMap<>();
        try {
            mapa = el.readBookFromExcel(Agent.DEFAULT_QUOTAS);
        } catch (IOException ex) {
            Logger.getLogger(Scenario.class.getName()).log(Level.SEVERE, null, ex);
        }
        
        for (Map.Entry<String, Short> entry : products.entrySet()){
            for (int i=0; i < my_agents.size(); i++){
                Agent ag1 = my_agents.get(i);
                String reg_name1 = ag1.getRegion().getName();

                for (int j=0; j < my_agents.size(); j++){
                    Agent ag2 = my_agents.get(j);
                    String reg_name2 = ag2.getRegion().getName();

                    for (int k=0; k < Time.years.length; k++){
                        //System.err.println(ag2.getName() + " " + Time.years[k] + " " + mapa.get(entry.getKey()).get(reg_name1).get(reg_name2) + " " +reg_name1 + " "+ reg_name2);
                        ag1.setQuota(entry.getValue(), ag2.getName(), Time.years[k], mapa.get(entry.getKey()).get(reg_name1).get(reg_name2));    
                    }
                }
                ag1.setReadedQuotas(ag1.getQuotas1()); // это заполнение полей прочитанных мапов только что прочитанными соотв. мапами
            }
        }
    }
    
    private void readAndFillAgentsLogisticsByRegions(ArrayList<Agent> my_agents, HashMap<String, Short> products, String path){
        // read from ExcelByRegions and filling agents' relations 
        
        ExcelLoader<Agent> el = new ExcelLoader<>(path);
        HashMap<String, HashMap<String, HashMap<String, Double>>> mapa = new HashMap<>();
        try {
            mapa = el.readBookFromExcel(Agent.DEFAULT_LOGISTIC);
        } catch (IOException ex) {
            Logger.getLogger(Scenario.class.getName()).log(Level.SEVERE, null, ex);
        }
        
        for (Map.Entry<String, Short> entry : products.entrySet()){
            for (int i=0; i < my_agents.size(); i++){
                Agent ag1 = my_agents.get(i);
                String reg_name1 = ag1.getRegion().getName();

                for (int j=0; j < my_agents.size(); j++){
                    Agent ag2 = my_agents.get(j);
                    String reg_name2 = ag2.getRegion().getName();

                    for (int k=0; k < Time.years.length; k++){
                        ag1.setLogistic(entry.getValue(), ag2.getName(), Time.years[k], mapa.get(entry.getKey()).get(reg_name1).get(reg_name2));    
                    }
                }
                ag1.setReadedLogistics(ag1.getLogistics1()); // это заполнение полей прочитанных мапов только что прочитанными соотв. мапами
            }
        }
    }
    
    //</editor-fold>
    
    //<editor-fold defaultstate="collapsed" desc="readAndFillAgentsParamsByAgents">   
    public void readAndFillAgentsParamsByAgents(ArrayList<Agent> my_agents){
        // read from ExcelByAgents and filling agents 
                
        // для удобства - мапы, отображающие продукты и позиции агентов
        HashMap<String, Integer> agentsMap = new HashMap<>();
        for (int i=0; i < my_agents.size(); i++){
            agentsMap.put(my_agents.get(i).getName(), i);            
        }

        HashMap<String, Short> products = new HashMap<>();
        products.put("ОУП", Contract.P_OUP);
        products.put("ПК", Contract.P_PK);
        products.put("ЕРР", Contract.P_SWU);
        products.put("МОКС", Contract.P_MOX);
        
        // само заполнение
        readAndFillAgentsRelationsByAgents(my_agents, agentsMap, EXCEL_RELATIONS_PATH);
        readAndFillAgentsQuotasByAgents(my_agents, agentsMap, products, EXCEL_QUOTAS_PATH);
        readAndFillAgentsLogisticsByAgents(my_agents, agentsMap, products, EXCEL_LOGISTICS_PATH);
        
        
    }
    
    private void readAndFillAgentsRelationsByAgents(ArrayList<Agent> my_agents, HashMap<String, Integer>agentsMap,  String path){
        ExcelLoader<Agent> el = new ExcelLoader<>(path);
        HashMap<String, HashMap<String, Double>> mapa = new HashMap<>();
        try {
            mapa = el.readSheetFromExcel(0);
        } catch (IOException ex) {
            Logger.getLogger(Scenario.class.getName()).log(Level.SEVERE, null, ex);
        }
        
        for (Map.Entry<String, HashMap<String,Double>> ag1_entry : mapa.entrySet()){

            for (Map.Entry<String,Double> ag2_entry : ag1_entry.getValue().entrySet()){
               for (int i=0; i < Time.years.length; i++){
                    int ag1_pos = agentsMap.get(ag1_entry.getKey());
                    my_agents.get(ag1_pos).setRelation(ag2_entry.getKey(), Time.years[i], ag2_entry.getValue());
                    my_agents.get(ag1_pos).setReadedRelations(my_agents.get(ag1_pos).getRelations()); // это заполнение полей прочитанных мапов только что прочитанными соотв. мапами
                }
            }
        }
    }
    
    private void readAndFillAgentsQuotasByAgents(ArrayList<Agent> my_agents, HashMap<String, Integer>agentsMap, HashMap<String, Short> products, String path){
        ExcelLoader<Agent> el = new ExcelLoader<>(path);
        HashMap<String, HashMap<String, HashMap<String, Double>>> mapa = new HashMap<>();
        try {
            mapa = el.readBookFromExcel();
        } catch (IOException ex) {
            Logger.getLogger(Scenario.class.getName()).log(Level.SEVERE, null, ex);
        }
        
        for (Map.Entry<String, HashMap<String, HashMap<String, Double>>> prod_entry : mapa.entrySet()){
            for (Map.Entry<String, HashMap<String,Double>> ag1_entry : prod_entry.getValue().entrySet()){

                for (Map.Entry<String,Double> ag2_entry : ag1_entry.getValue().entrySet()){
                   for (int j=0; j < Time.years.length; j++){
                        int ag1_pos = agentsMap.get(ag1_entry.getKey());
                        my_agents.get(ag1_pos).setQuota(products.get(products.get(prod_entry.getKey())), ag2_entry.getKey(), Time.years[j], ag2_entry.getValue());
                        my_agents.get(ag1_pos).setReadedQuotas(my_agents.get(ag1_pos).getQuotas1()); // это заполнение полей прочитанных мапов только что прочитанными соотв. мапами
                   }
                }
            }
        }
    }
    
    private void readAndFillAgentsLogisticsByAgents(ArrayList<Agent> my_agents, HashMap<String, Integer>agentsMap, HashMap<String, Short> products, String path){
        ExcelLoader<Agent> el = new ExcelLoader<>(path);
        HashMap<String, HashMap<String, HashMap<String, Double>>> mapa = new HashMap<>();
        try {
            mapa = el.readBookFromExcel();
        } catch (IOException ex) {
            Logger.getLogger(Scenario.class.getName()).log(Level.SEVERE, null, ex);
        }
        
        for (Map.Entry<String, HashMap<String, HashMap<String, Double>>> prod_entry : mapa.entrySet()){
            for (Map.Entry<String, HashMap<String,Double>> ag1_entry : prod_entry.getValue().entrySet()){

                for (Map.Entry<String,Double> ag2_entry : ag1_entry.getValue().entrySet()){
                   for (int j=0; j < Time.years.length; j++){
                        int ag1_pos = agentsMap.get(ag1_entry.getKey());
                        my_agents.get(ag1_pos).setLogistic(products.get(products.get(prod_entry.getKey())), ag2_entry.getKey(), Time.years[j], ag2_entry.getValue());
                        my_agents.get(ag1_pos).setReadedLogistics(my_agents.get(ag1_pos).getLogistics1()); // это заполнение полей прочитанных мапов только что прочитанными соотв. мапами
                   }
                }
            }
        }
    }
    
    void initialize_statistics() {
        for (Actor actor : module.AllActors) {
            actor.initStats();
        }
    }
    
    //</editor-fold>
}
