/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package smmum_alpha;

import java.time.LocalDate;
import java.time.LocalDateTime;
import java.util.ArrayList;

/**
 *
 * @author Dmitry
 */
public class ScenarioLight extends Scenario{

    
    public ScenarioLight(DemoModule aThis) {
        module = aThis;
    }
    
    @Override
    public void setup(){
        ContractChain.clear();
        ArchiveChain.clear();
        //Time.set_iTime(1);
        Time.set_yTime(2018);
        Time.set_lastTime(5);
        Time.set_years_size();
        create_regions();
        //create_countries();
        
        create_operators(); // параллельно заполняются массивы операторов и реакторов
        crate_minings();
        create_enrichments();
        create_mox_supplier();
        
        module.setAllActors();
        
        create_agents();
        
    }
    
    
    @Override
    void create_mox_supplier() {
       // module.my_mox_suppliers = new ArrayList();
        double[] a1 = {2000,3000,2500,3000,3500};
        double[] c1 = {30,35,35,35,30};
        MoxSupplier mox1 = new MoxSupplier(a1[0], c1[0], a1, c1);
        mox1.set_actor_params(0, "Morannon", (Region) module.my_regions.get(0));
        ArrayList<MoxSupplier> my_mox_suppliers = new ArrayList<>();
        my_mox_suppliers.add(mox1);
        module.setMy_mox_suppliers(my_mox_suppliers);
    }

    @Override
    void create_enrichments() {
        double[] a1 = {1400,1600,1600,1600,1600};
        double[] c1 = {30,35,35,35,35};
        Enrichment enr1 = new Enrichment(a1[0], c1[0], a1, c1);
        enr1.set_actor_params(0, "Enrichment", (Region) module.my_regions.get(0));
        ArrayList<Enrichment> my_enrichments = new ArrayList<>();
        my_enrichments.add(enr1);
        module.setMy_enrichments(my_enrichments);
    }

    @Override
    void crate_minings() {
        ArrayList<Mining> my_minings = new ArrayList<>();
        ArrayList<Deposit> deposits = new ArrayList<Deposit>();
        int i = 1;
        for (Region my_region : module.my_regions) {
            ArrayList<Country> cs = my_region.getCountries();
            for (Country country : cs) {
                country.volume40 = i*100;
                country.volume80 = i*300;
                country.volume130 = i*900;
                country.volume260 = i*2700;

                country.Svolume40 = country.volume40;
                country.Svolume80 = country.volume80;
                country.Svolume130 = country.volume130;
                country.Svolume260 = country.volume260;

                country.current_cost = 40;
                i++;
                Deposit d = new Deposit(1, "Amber", country, 1, 3000, LocalDate.of(1988, 6, 22));
                
                deposits.add(d);
            }
        }
        Mining mining1 = new Mining(deposits);
        mining1.pbase = Producer.PBASE_COST;
        mining1.set_actor_params(0, "Поставщик ПК", (Region) module.my_regions.get(0));
        my_minings.add(mining1);
        module.setMy_minings(my_minings);
    }

    @Override
    void create_operators() {
        double[] supply = new double[1];
        supply[0] = 0;
        ArrayList reactor_list = new ArrayList();
        LocalDate construction = LocalDate.of(1988, 6, 22);
        LocalDate commercial = LocalDate.of(2017, 5, 27);
        
        Reactor reactor1 = new Reactor(1, "R1", "Candu", 8, 2180, 720, 0.0071, 
                0.33, 0,commercial, construction, (Region) module.my_regions.get(0), 
                module.my_regions.get(0).countries.get(0), 0.75, 1, true);
        reactor1.type = Contract.PK_Solo;
        reactor_list.add(reactor1);
        
        
        Operator oper1;
        oper1 = new Operator(reactor_list, supply, 3 , 0);
        oper1.set_actor_params(0, "Operator",(Region) module.my_regions.get(0));
        ArrayList<Operator> my_operators = new ArrayList<>();
        oper1.setThreshold(7);
        my_operators.add(oper1);
        
        my_operators.forEach((Operator oper) -> oper.init_fuel_needs());
        
        module.setMy_operators(my_operators);
        module.setMy_reactors(reactor_list);
    }

    @Override
    public void create_agents() {
        ArrayList<String> agent_names = new ArrayList();
        ArrayList<Agent> my_agents = new ArrayList<>();
        module.AllActors.forEach((actor) -> {
            String ag_name = actor.getName();
            Region region = actor.getRegion();
            Agent agent = new Agent(ag_name, region);
            my_agents.add(agent);
            actor.set_agent(agent);
            agent_names.add(ag_name);
        });
        my_agents.forEach((t) -> {t.initLogistics(agent_names);});
        my_agents.forEach((t) -> {t.initQuotas(agent_names);});
        my_agents.forEach((t) -> {t.initRelations(agent_names);});
        module.setMy_agents(my_agents);
    }

    @Override
    public void create_regions() {
        Region region1 = new Region("Амбер", 4, true);

        ArrayList<Region> my_regions = new ArrayList<>();
        my_regions.add(region1);

        
        module.setMy_regions(my_regions);
        create_countries();
    }
    
    @Override
    public void create_countries() {
        ArrayList<Country> countries = new ArrayList<>();
        int i = 0;
        for (Region my_region : module.my_regions) {
            countries.add(new Country(  i+1, my_region.getName(), my_region.getName()));
            my_region.addCountry(countries.get(i));
            i++;
        }
        
        for (int j=0; j < countries.size(); j++){
            this.my_countries.put(j, countries.get(j));
        }
        //module.setMy_countries(my_countries);
    }
    
}
