/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package smmum_alpha;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.time.LocalDate;
import java.time.*;
import java.time.Month;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.logging.Level;
import java.util.logging.Logger;
import java.util.stream.Stream;
import org.apache.commons.lang.StringUtils;

/**
 *
 * @author z
 */
public class ScenarioTest extends Scenario{
    
    //String bd_path = ".\\TS_Base_v_0_5_4.accdb";
    //static final String bd_path = "D:\\МИФИ\\Харитонов\\Техснаб_2018\\TS_Base_v_0_4_5.accdb"; 
    static final LocalDate DEFAULT_CONSTRUCTION = LocalDate.of(2020, 6, 22);        // TODO: убрать, как только в базе заполнят пропуски
    static final LocalDate DEFAULT_COMMERCIAL = LocalDate.of(2025, 5, 27);          // TODO: и это тоже
    static final LocalDate DEFAULT_SHUTDOWN = LocalDate.of(2085, 5, 27);
    static final LocalDate NEVER = LocalDate.of(2085, 1, 1);
    static final int IAEA_MINING = 1;
    static final int TENEX_MINING = 2;
    static int mining_type = IAEA_MINING;
    static boolean PLANNED_OF = false;
    static int MIN_LIFETIME = 0;
    ScenarioTest(DemoModule aThis) {
        super(aThis);
        //bd_path = ".\\TS_Base_v_0_5_4.accdb";
    }

    @Override
    public void setup(){
        ContractChain.clear();
        ArchiveChain.clear();
        //Time.set_iTime(1);
//        Time.set_yTime(Time.GUI_START_TIME);
//        Time.set_lastTime(Time.GUI_FINISH_TIME);
//        Time.set_years_size();
        create_regions();
        //create_countries();
        
        create_operators(); // параллельно заполняются массивы операторов и реакторов
        crate_minings();
        create_enrichments();
        create_mox_supplier();
        create_remix_supplier();
        create_trader();
        module.setAllActors();
        
        create_agents();
    }
    
    //<editor-fold defaultstate="collapsed" desc=" code for Country class and array (optional) ">
//    
//    
//    private class Country{
//        int id;
//        String name;
//        int region_id;
//
//        public Country(int id, String name, int region_id) {
//            this.id = id;
//            this.name = name;
//            this.region_id = region_id;
//        }
//
//    }
//    

    //</editor-fold>
    
    private int find_region_id_by_place(int place_id){
        String sql_str = "SELECT * FROM countries\n" +
                        "WHERE (((countries.id) = "+String.valueOf(place_id)+"))";
        int region_id = -1;  
        
        try {   
            DBDataLoader provider = new DBDataLoader(this.bd_path);
            ResultSet rsmain = provider.eval(sql_str);
            
            rsmain.first();
            region_id = rsmain.getInt("countries.region_id");
            
            provider.close_conn();

        } catch (SQLException ex) {
            Logger.getLogger(Reactor.class.getName()).log(Level.SEVERE, null, ex);
            return 15;       // TODO: сейчас если не находится регион (по запросу по id нет записей), то автозамена на id региона NO_DATA
        }
         catch (java.lang.NullPointerException ex){
             System.out.println("\t\tЧто-то сломалось");
        }  

//        if (region_id < 0){
//            System.out.println("ERROR: region_id == "+String.valueOf(region_id)+"!!!!! Ф-ция find_region_id");
//        }    
        return region_id;
    }
    
    private int find_region_id_by_company(int companies_id){
        //System.out.println(companies_id);
        String sql_str = "SELECT * FROM sites\n" +
                        "WHERE (((sites.operator) = "+String.valueOf(companies_id)+"))";
        int region_id = -1;  
        
        try {   
            DBDataLoader provider = new DBDataLoader(this.bd_path);
            ResultSet rsmain = provider.eval(sql_str);
            
            rsmain.first();
            region_id = find_region_id_by_place(rsmain.getInt("sites.place"));
            
            provider.close_conn();

        }
        catch (SQLException ex) {
            //Logger.getLogger(Reactor.class.getName()).log(Level.SEVERE, null, ex);
            return 15;       // TODO: сейчас если не находится регион (по запросу по id нет записей), то автозамена на id региона NO_DATA
        }
        catch (java.lang.NullPointerException ex){
             System.out.println("\t\tЧто-то сломалось");
        }

//        if (region_id <= 0){
//            System.out.println("ERROR: region_id == "+String.valueOf(region_id)+"!!!!! Ф-ция find_region_id");
//        }
        return region_id;
    }
    
    private int find_country_id_by_company_for_site(int companies_id){
        //System.out.println(companies_id);
        String sql_str = "SELECT * FROM sites\n" +
                        "WHERE (((sites.operator) = "+String.valueOf(companies_id)+"))";
        int country_id = -1;  
        
        try {   
            DBDataLoader provider = new DBDataLoader(this.bd_path);
            ResultSet rsmain = provider.eval(sql_str);
            
            rsmain.first();
            country_id = rsmain.getInt("sites.place");
            
            provider.close_conn();

        }
        catch (SQLException ex) {
            //Logger.getLogger(Reactor.class.getName()).log(Level.SEVERE, null, ex);
            return 1;       // TODO: сейчас если не находится страна (по запросу по id нет записей), то автозамена на id региона NO_DATA
        }
        catch (java.lang.NullPointerException ex){
             System.out.println("\t\tЧто-то сломалось");
        }

//        if (region_id <= 0){
//            System.out.println("ERROR: region_id == "+String.valueOf(region_id)+"!!!!! Ф-ция find_region_id");
//        }
        return country_id;
    }
     
    private int find_country_id_by_site(int site_id){
        //System.out.println(site_id);
        String sql_str = "SELECT * FROM sites\n" +
                        "WHERE (((sites.id) = "+String.valueOf(site_id)+"))";
        int country_id = -1;  
        
        try {   
            DBDataLoader provider = new DBDataLoader(this.bd_path);
            ResultSet rsmain = provider.eval(sql_str);
            
            rsmain.first();
            country_id = rsmain.getInt("sites.place");
            
            provider.close_conn();

        }
        catch (SQLException ex) {
            //Logger.getLogger(Reactor.class.getName()).log(Level.SEVERE, null, ex);
            return 1;       // TODO: сейчас если не находится страна (по запросу по id нет записей), то автозамена на id региона NO_DATA
        }
        catch (java.lang.NullPointerException ex){
             System.out.println("\t\tЧто-то сломалось");
        }

//        if (region_id <= 0){
//            System.out.println("ERROR: region_id == "+String.valueOf(region_id)+"!!!!! Ф-ция find_region_id");
//        }
        return country_id;
    }
    
    private ArrayList<Reactor> units_by_sites(int site, int region_id, int prior_type) {
                
        String sql_str = "SELECT * FROM units\n" +
                        "WHERE (((units.site) = "+String.valueOf(site)+"))\n" +
                        "ORDER BY units.id";
        ArrayList<Reactor> reactor_list = new ArrayList<>();

        try {   
            DBDataLoader provider = new DBDataLoader(this.bd_path);
            ResultSet rsmain = provider.eval(sql_str);
            if(rsmain == null){
                System.out.println("ResultSet null");
            }
            rsmain.beforeFirst();

            while(rsmain.next()){
                String rClass = rsmain.getString("units.class");
                if (! rsmain.wasNull() ){
                  rClass = rClass.trim();  
                }              
                
                LocalDate commercial;
                if (rsmain.getDate("units.commercial_operation") == null){
                    commercial = DEFAULT_COMMERCIAL;
                }
                else{
                    commercial = (rsmain.getDate("units.commercial_operation")).toLocalDate();
                }
                
                LocalDate construction;
                if (rsmain.getDate("units.construction_start") == null){
                    if (commercial.compareTo(LocalDate.now()) > 0)
                        construction = DEFAULT_CONSTRUCTION;
                    else
                        construction = commercial.minusYears(10);
                }
                else{
                    construction = (rsmain.getDate("units.construction_start")).toLocalDate();
                } 
                
                if (PLANNED_OF){
                    if (construction.compareTo(LocalDate.now()) > 0 ){ // Выключаем плановые
                        commercial = NEVER;
                    }
                }    
                LocalDate shutdown;
                if (rsmain.getDate("units.date_shutdown") != null){
                    shutdown = (rsmain.getDate("units.date_shutdown")).toLocalDate();
//                    if (region_id == 5 && shutdown.getYear() > 2026){
//                       shutdown = LocalDate.of(2026, 1, 1);    
//                    }
                }
                else{
                    shutdown = DEFAULT_SHUTDOWN;      // if empty - go to the next row!!!
//                    if (region_id == 5){
//                       shutdown = LocalDate.of(2026, 1, 1);    
//                    }
                }
                if (MIN_LIFETIME >0){
                    if (Period.between(commercial, shutdown).getYears() <MIN_LIFETIME  && shutdown.compareTo(LocalDate.now()) > 0 ){
                        System.out.println("shutdown before"
                               + " adding years: " + shutdown);
                       shutdown = shutdown.plusYears(MIN_LIFETIME - Period.between(commercial, shutdown).getYears());
                        System.out.println("shutdown after "
                               + " adding years: " + shutdown);
                    }
                }
                int country_id = find_country_id_by_site(site);
                Reactor reactor1 = new Reactor(rsmain.getInt("units.id"),
                        rsmain.getString("units.unit_name").trim(),
                        rClass,
                        rsmain.getDouble("units.burn_up"),
                        rsmain.getDouble("units.thermal_capacity"),
                        rsmain.getDouble("units.net_capacity"),
                        rsmain.getDouble("units.enrichment"),
                        0.33, 100,      // kpd, first load
                        commercial,
                        construction,
                        shutdown,
                        this.module.my_regions.get(region_id-1), this.my_countries.get(country_id),
                        0.85, 1, rsmain.getBoolean("units.ru_design"));     // load_factors, current_status, ru_design
                
                String type = rsmain.getString("units.type").trim();
                reactor1.Rtype = type;
                if (type.equals("FBR")){
                    reactor1.set_type(Contract.MOX);
                }
                //else if (site == 198)
                //    reactor1.set_type(Contract.SWU_PK);
//                else if (site == 81)
//                    reactor1.set_type(Contract.REMIX);
                else if (rClass.equals("CANDU") || rClass.equals("PHWR") || (reactor1.enrichment <= 0.0072))
                    reactor1.set_type(Contract.PK_Solo);
                else if (reactor1.ru_design && !type.equals("FBR"))
                        reactor1.set_type(Contract.EUP);
                else{
                    reactor1.set_type(prior_type);
                  // if (country_id == 81)
                  //      reactor1.set_type(Contract.SWU_PK);
                }
    //            rsmain.getString("type");         // TODO: добавить в sql-запрос отображение этого поля 
    //            if (! rsmain.wasNull() ){
    //              type = type.trim();  
    //            }
                reactor_list.add(reactor1);
            }
            provider.close_conn();
            
        } catch (SQLException ex) {
            Logger.getLogger(Reactor.class.getName()).log(Level.SEVERE, null, ex);
        }
         catch(java.lang.NullPointerException ex){
             System.out.println("\t\tЧто-то сломалось");
        }   
        return reactor_list;
    }
    
    private ArrayList<Reactor> create_reactors1(int oper_id, int region_id, int prior_type) {
        // sites("owner_id") -> units("sites")
        String sql_str = "SELECT * FROM sites\n" +
                        "WHERE (((sites.owner_id) = "+String.valueOf(oper_id)+"))\n" +
                        "ORDER BY sites.id";
        ArrayList<Reactor> reactor_list = new ArrayList<>();

        try {   
            DBDataLoader provider = new DBDataLoader(this.bd_path);
            ResultSet rsmain = provider.eval(sql_str);
            if(rsmain == null){
                System.out.println("ResultSet null");
            }
            rsmain.beforeFirst();

            while(rsmain.next()){
                reactor_list.addAll(units_by_sites(rsmain.getInt("sites.id"), region_id, prior_type));
            }
            provider.close_conn();
            
        } catch (SQLException ex) {
            Logger.getLogger(Reactor.class.getName()).log(Level.SEVERE, null, ex);
        }
         catch(java.lang.NullPointerException ex){
             System.out.println("\t\tЧто-то сломалось");
        }   
        return reactor_list;
    }
    
    private ArrayList<Reactor> create_reactors2(int oper_id, int country_id) {
        // only units (by "operator" field)
        String sql_str = "SELECT * FROM units\n" +
                        "WHERE (((units.operator) = "+String.valueOf(oper_id)+"))\n" +
                        "ORDER BY units.id";
        ArrayList<Reactor> reactor_list = new ArrayList<>();

        try {   
            DBDataLoader provider = new DBDataLoader(this.bd_path);
            ResultSet rsmain = provider.eval(sql_str);
            
            rsmain.beforeFirst();

            while(rsmain.next()){
                String rClass = rsmain.getString("units.class");
                if (! rsmain.wasNull() ){
                  rClass = rClass.trim();  
                }              
                
                LocalDate commercial;
                if (rsmain.getDate("units.commercial_operation").equals(null)){
                    commercial = DEFAULT_COMMERCIAL;
                }
                else{
                    commercial = (rsmain.getDate("units.commercial_operation")).toLocalDate();
                }

                LocalDate construction;
                if (rsmain.getDate("units.construction_start").equals(null)){
                    construction = DEFAULT_COMMERCIAL;
                }
                else{
                    construction = (rsmain.getDate("units.construction_start")).toLocalDate();
                }
                int region_id = find_region_id_by_place(country_id);
                Reactor reactor1 = new Reactor(rsmain.getInt("units.id"),
                        rsmain.getString("units.unit_name").trim(),
                        rClass,
                        rsmain.getDouble("units.burn_up"),
                        rsmain.getDouble("units.thermal_capacity"),
                        rsmain.getDouble("units.net_capacity"),
                        rsmain.getDouble("units.enrichment"),
                        0.33, 120,      // kpd, first load
                        commercial,
                        construction,
                        module.my_regions.get(region_id-1), this.my_countries.get(country_id),
                        0.75, 1, true);     // load_factors, current_status, can_mox
                
                String type = rsmain.getString("units.type").trim();
                if (type.equals("FBR")){
                    reactor1.set_type(Contract.MOX);
                }
                else{
                    reactor1.set_type(2);
                }
    //            rsmain.getString("type");         // TODO: добавить в sql-запрос отображение этого поля 
    //            if (! rsmain.wasNull() ){
    //              type = type.trim();  
    //            }
                reactor_list.add(reactor1);
            }
            provider.close_conn();
            
        } catch (SQLException ex) {
            Logger.getLogger(Reactor.class.getName()).log(Level.SEVERE, null, ex);
        }
         catch(java.lang.NullPointerException ex){
             System.out.println("Что-то сломалось");
        }   
        return reactor_list;
    }
    
    private ArrayList<Reactor> fill_reactors(int oper_id, int region_id, int prior_type) {
        return create_reactors1(oper_id, region_id,prior_type);
        //return create_reactors2(oper_id, region_id);
    }
    
    private ArrayList<Integer> find_enrich_id(String table_name){
        
        // запрос на уникальные значения в поле company_id
        String sql_str = "SELECT First("+table_name+".[company_id]) AS [company_id_new], Count("+table_name+".[company_id]) AS Повторы\n" +
                            "FROM "+table_name+"\n" +
                            "GROUP BY "+table_name+".[company_id]\n" +
                            "HAVING (((Count("+table_name+".[company_id]))>=1));";
        
        ArrayList<Integer> all_values = new ArrayList<>();
        try {
            DBDataLoader provider = new DBDataLoader(this.bd_path);
            ResultSet rsmain = provider.eval(sql_str);
            rsmain.beforeFirst();
            while(rsmain.next()){
                all_values.add(rsmain.getInt("company_id_new"));    
            }
            provider.close_conn();
        }
        catch(Exception ex){
           //System.out.print("Connection failed.  "+my_operators.get(my_operators.size()-1).getName()+"  "+String.valueOf(cow)+"\n");
           ex.printStackTrace();
        }
        
        return all_values;
    }
    
    private List<double[]> fill_arrays(String table_name, int comp_id){
        
        String sql_str = "SELECT * FROM "+table_name+"\n" +
                        "WHERE ((("+table_name+".company_id) = "+String.valueOf(comp_id)+"))";
        
        List<List<Double>> buf = new ArrayList<>(2);        // 0:capacity, 1:cost
        for(int i=0; i < 2; i++){
            buf.add(new ArrayList<>());
        }
        int cow = 0;
        try {
            DBDataLoader provider = new DBDataLoader(this.bd_path);
            ResultSet rsmain = provider.eval(sql_str);
            rsmain.beforeFirst();
            while(rsmain.next()){
                if (rsmain.getInt(table_name+".year") >= Time.years[0]){
                    buf.get(0).add(rsmain.getDouble(table_name+".capacity"));    
                    buf.get(1).add(rsmain.getDouble(table_name+".cost")); 
                    cow += 1;
                }
                
            }
            provider.close_conn();
        }
        catch(Exception ex){
           //System.out.print("Connection failed.  "+my_operators.get(my_operators.size()-1).getName()+"  "+String.valueOf(cow)+"\n");
           ex.printStackTrace();
        }
        
        List<double[]> all_values= new ArrayList<>(2);
        for(int i=0; i < 2; i++){
            all_values.add(new double[cow]);
        }
        
        for (int i=0; i < cow; i++){
            all_values.get(0)[i] = buf.get(0).get(i);
            all_values.get(1)[i] = buf.get(1).get(i);
        }
        
        return all_values;
    }
    
    @Override
    public void create_regions() {
        String sql_str = "Select * from regions ORDER BY id";
        ArrayList<Region> my_regions = new ArrayList<>();
        
        try {
            DBDataLoader provider = new DBDataLoader(this.bd_path);
            ResultSet rsmain = provider.eval(sql_str);
//            int i = 0;
//            rsmain.last();
//            Region[] regions = new Region[rsmain.getRow()];
            rsmain.beforeFirst();
            while(rsmain.next()){
//               regions[i] = new Region(rsmain.getString("region_name").trim(), rsmain.getInt("id"));
                Region region = new Region(rsmain.getString("region_name").trim(), rsmain.getInt("id"), rsmain.getInt("brain_type"), bd_path);
                region.setBd_path(bd_path);
                region.getCountries().forEach(coun -> this.my_countries.put(coun.getId(), coun));
                my_regions.add(region);
//               i++;
            }
            provider.close_conn();
        }
        catch(Exception ex){
           System.out.print("\t\tConnection failed.\n");
           ex.printStackTrace();
        }
        
        module.setMy_regions(my_regions);
        
//        create_countries();
    }
    
    @Override
    public void create_operators() {
        double[] supply = new double[1];
        supply[0] = 0;
        
//        String sql_str = "SELECT sites.[id], sites.[npp_name], sites.[status], sites.[place], sites.[owner_id], sites.[operator], sites.[builder]\n" +
//                        "FROM sites\n" +
//                        "ORDER BY sites.[id]";
//        ArrayList<Operator> my_operators = new ArrayList<>();
        
        String sql_str = "SELECT * FROM companies\n" +
                        "ORDER BY id";
        ArrayList<Operator> my_operators = new ArrayList<>();
        ArrayList<Reactor> my_reactors = new ArrayList<>();
        //int cow = 0;
        try {
            DBDataLoader provider = new DBDataLoader(this.bd_path);
            ResultSet rsmain = provider.eval(sql_str);
            
            rsmain.beforeFirst();
            
            while(rsmain.next()){
                // ищем region_id (по companies.id)
                //int region_id = find_country_id_by_company(rsmain.getInt("companies.id")); - TODO: раскомментить, если у оператора в конструкторе будет вместо Региона Страна
                int region_id = find_region_id_by_company(rsmain.getInt("companies.id"));
                
                // создаем Оператора
                ArrayList<Reactor> reactors = fill_reactors(rsmain.getInt("companies.id"), region_id, rsmain.getInt("trade_type"));
                
                if (reactors.isEmpty()){
                    continue;
                }
                else{
                    Operator oper1 = new Operator(reactors,
                                    supply, 3, 0 );     // TODO: изменить в соответствие с названиями полей из базы
                    // устанавливанем параметры оператору
                    oper1.set_actor_params(rsmain.getInt("companies.id"), rsmain.getString("companies.companies_name").trim(),
                                            this.module.my_regions.get(region_id-1));       // TODO: агента взять из БД
                    oper1.setThreshold(6);

                    // добавляем в общий ArrayList операторов
                    my_operators.add(oper1);
                    
                    // добавляем в общий ArrayList ректоры
                    my_reactors.addAll(reactors);
                    //cow = cow+1;            
                }
            }
            provider.close_conn();
        }
        catch(Exception ex){          
           //System.out.print("Connection failed.  "+my_operators.get(my_operators.size()-1).getName()+"  "+String.valueOf(cow)+"\n");
           ex.printStackTrace();
        }
        
        my_operators.forEach((Operator oper) -> oper.init_fuel_needs());
        
        module.setMy_operators(my_operators);
        module.setMy_reactors(my_reactors);
    }
   
    @Override
    public void create_enrichments() {

        ArrayList<Integer> enr_id = find_enrich_id("enrichment_history");

        String ss = "(" + StringUtils.join(enr_id,",") + ")";
       
        String sql_str = "SELECT * FROM companies WHERE companies.[id] IN " + ss;        //"('parameter1','parameter2','parameter3');";
        ArrayList<Enrichment> my_enrichments = new ArrayList<>();
        
        try {
            DBDataLoader provider = new DBDataLoader(this.bd_path);
            ResultSet rsmain = provider.eval(sql_str);
            
            rsmain.beforeFirst();
            while(rsmain.next()){
                // ищем region_id       TODO: раскомментировать
                //int region_id = find_region_id_by_place(rsmain.getInt("enrichment_plants.place"));
                
                // создаем Обогатителя. Сначала массивы
                List<double[]> a1 = fill_arrays("enrichment_history", rsmain.getInt("companies.id"));
                int id = rsmain.getInt("companies.id");
                Enrichment enr1;
                if (id == 171){
                    enr1 = new TVEL(a1.get(0)[0], a1.get(1)[0], a1.get(0), a1.get(1));  // TODO: убрать первые 2 параметра
                }else{
                   enr1 = new Enrichment(a1.get(0)[0], a1.get(1)[0], a1.get(0), a1.get(1));  // TODO: убрать первые 2 параметра 
                }
                
                
                // устанавливанем параметры
                enr1.set_actor_params(id,
                                        rsmain.getString("companies.companies_name").trim(),
                                        get_region_by_company_id(id) 
                                        );       // TODO: установить агента после иницилизации массива агентов. А потом агентов брать из БД
                enr1.pbase = Producer.PBASE_PRICE;// TVEL
                enr1.setMin_marge(0.15);
                enr1.setThreshold(6);
                // добавляем в общий ArrayList
                my_enrichments.add(enr1);          
            }
            provider.close_conn();
        }
        catch(Exception ex){
           ex.printStackTrace();
        }
                
        module.setMy_enrichments(my_enrichments);

    }

    void create_mox_enrichment(){
        
    }
    
    @Override
    void create_mox_supplier() {
        /*ArrayList<MoxSupplier> my_mox_suppliers = new ArrayList<>();
        
        double[] a1 = new double[Time.years.length];
        for (int i = 0; i < a1.length; i++) {
            a1[i] = 350;
        }
        double[] c1 = new double[Time.years.length];
        for (int i = 0; i < c1.length; i++) {
            c1[i] = 2500-4*i;
        }
        MoxSupplier mox1 = new MoxSupplier(a1[0], c1[0], a1, c1);
        Object[] usa0 =  module.my_regions.stream().filter(r -> r.getName().equals("USA")).toArray();
        Region usa = (Region) usa0[0];
        mox1.set_actor_params(0, "Westinghouse", usa);
        my_mox_suppliers.add(mox1);
        
        double[] a2 = new double[Time.years.length];
        for (int i = 0; i < a2.length; i++) {
            a2[i] = 250;
        }
        double[] c2 = new double[Time.years.length];
        for (int i = 0; i < c2.length; i++) {
            c2[i] = 2500-5*i;
        }
        MoxSupplier mox2 = new MoxSupplier(a2[0], c2[0], a2, c2);
        Object[] russia0 =  module.my_regions.stream().filter(r -> r.getName().equals("Russia")).toArray();
        Region russia = (Region) russia0[0];
        mox2.set_actor_params(1, "Rosatom", russia);
        my_mox_suppliers.add(mox2);
        */
        ArrayList<Integer> enr_id = find_enrich_id("mox_history");

        String ss = "(" + StringUtils.join(enr_id,",") + ")";
       
        String sql_str = "SELECT * FROM companies WHERE companies.[id] IN " + ss;        //"('parameter1','parameter2','parameter3');";
        ArrayList<MoxSupplier> my_mox_suppliers = new ArrayList<>();
        
        try {
            DBDataLoader provider = new DBDataLoader(this.bd_path);
            ResultSet rsmain = provider.eval(sql_str);
            
            rsmain.beforeFirst();
            while(rsmain.next()){
                // ищем region_id       TODO: раскомментировать
                //int region_id = find_region_id_by_place(rsmain.getInt("enrichment_plants.place"));
                
                // создаем Обогатителя. Сначала массивы
                List<double[]> a1 = fill_arrays("mox_history", rsmain.getInt("companies.id"));
                int id = rsmain.getInt("companies.id");
                MoxSupplier enr1;
                   enr1 = new MoxSupplier(a1.get(0)[0], a1.get(1)[0], a1.get(0), a1.get(1));  // TODO: убрать первые 2 параметра                 
                
                // устанавливанем параметры
                enr1.set_actor_params(id,
                                        rsmain.getString("companies.companies_name").trim(),
                                        get_region_by_company_id(id) 
                                        );       // TODO: установить агента после иницилизации массива агентов. А потом агентов брать из БД
                enr1.pbase = Producer.PBASE_PRICE;// TVEL
                enr1.setMin_marge(0.15);
                enr1.setThreshold(6);
                // добавляем в общий ArrayList
                my_mox_suppliers.add(enr1);          
            }
            provider.close_conn();
        }
        catch(Exception ex){
           ex.printStackTrace();
        }
        
        module.setMy_mox_suppliers(my_mox_suppliers);
    }
    
    void create_remix_supplier(){
        double[] all_capacity = new double[Time.years.length];
        for (int i = 0; i < all_capacity.length; i++) {
            all_capacity[i] = 400;
        }
        double[] all_cost = new double[Time.years.length];
        for (int i = 0; i < all_cost.length; i++) {
            all_cost[i] = 1800;
        }
        RemixSupplier remix_supplier = new RemixSupplier(all_capacity, all_cost);
        Region russia = module.my_regions.stream().filter(r -> r.getName().equals("Russia")).findFirst().get();
        remix_supplier.set_actor_params(1, "Rosatom_Remix", russia);
        remix_supplier.setPartner(module.my_enrichments.stream().filter(e -> e.id == 171).findFirst().get());
        remix_supplier.setThreshold(7);
        module.remix_supplier =  remix_supplier;
    }
    
    private HashMap<Integer, ArrayList<Deposit>> create_deposits(){
        switch (mining_type){
            case IAEA_MINING: return create_iaea_deposits();
            case TENEX_MINING: return create_tenex_deposits();
            default: return create_iaea_deposits();
        }
    }
    
    private HashMap<Integer, ArrayList<Deposit>> create_tenex_deposits(){
        HashMap<Integer, ArrayList<Deposit>> deposits = new HashMap<>();
        
        String sql_str = "SELECT *\n" +
                            "FROM deposits_tenex";
        
        try {   
            DBDataLoader provider = new DBDataLoader(this.bd_path);
            ResultSet rsmain = provider.eval(sql_str);
            
            rsmain.beforeFirst();

            while(rsmain.next()){

                String dName = rsmain.getString("deposits_tenex.Dname");
                if (! rsmain.wasNull() ){
                  dName = dName.trim();  
                }              
                
                LocalDate start_date;
                int YY = rsmain.getInt("deposits_tenex.Start");
                if (YY == 0){
                    start_date = DEFAULT_COMMERCIAL;
                }
                else{
                    start_date = LocalDate.of(YY, 1, 1);
                }

                int country_id = rsmain.getInt("deposits_tenex.Country_id");
                int owner_id = rsmain.getInt("deposits_tenex.Owner_id");

                if (! deposits.containsKey(owner_id)){
                    deposits.put(owner_id, new ArrayList<>());
                }
                sql_str = "SELECT * FROM deposit_tenex_history WHERE deposit_tenex_history.deposit_id = " + rsmain.getInt("deposits_tenex.id") + " ORDER BY deposit_tenex_history.years";
                ResultSet rsmain2 = provider.eval(sql_str);
                rsmain2.beforeFirst();
                double[] capacity = new double[Time.years.length];
                while(rsmain2.next()){
                    int DB_year = rsmain2.getInt("deposit_tenex_history.years");
                    if (DB_year > Time.ylastTime) continue;
                    capacity[DMath.Arithmetic.indexOf(Time.years, DB_year)] = rsmain2.getDouble("deposit_tenex_history.capacity");
                } 
                deposits.get(owner_id).add(new DepositTenex(rsmain.getInt("deposits_tenex.id"),
                        dName, this.my_countries.get(country_id),
                        owner_id, rsmain.getDouble("deposits_tenex.Reserve"), start_date,capacity,
                        rsmain.getDouble("deposits_tenex.Cost"), rsmain.getDouble("deposits_tenex.Max_Cost"), rsmain.getDouble("deposits_tenex.Grade")));
                
            }
            provider.close_conn();
            
        } catch (SQLException ex) {
            Logger.getLogger(Reactor.class.getName()).log(Level.SEVERE, null, ex);
        }
         catch(java.lang.NullPointerException ex){
             System.out.println("Что-то сломалось");
        }   

        return deposits;
    }
    
    private HashMap<Integer, ArrayList<Deposit>> create_iaea_deposits(){
        HashMap<Integer, ArrayList<Deposit>> deposits = new HashMap<>();
        
        String sql_str = "SELECT *\n" +
                            "FROM deposits";
        
        try {   
            DBDataLoader provider = new DBDataLoader(this.bd_path);
            ResultSet rsmain = provider.eval(sql_str);
            
            rsmain.beforeFirst();

            while(rsmain.next()){

                String dName = rsmain.getString("deposits.Dname");
                if (! rsmain.wasNull() ){
                  dName = dName.trim();  
                }              
                
                LocalDate start_date;
                if (rsmain.getDate("deposits.Data start").equals(null)){
                    start_date = DEFAULT_COMMERCIAL;
                }
                else{
                    start_date = (rsmain.getDate("deposits.Data start")).toLocalDate();
                }

                int country_id = rsmain.getInt("deposits.country_id");
                int owner_id = rsmain.getInt("deposits.Owner_id");

                if (! deposits.containsKey(owner_id)){
                    deposits.put(owner_id, new ArrayList<>());
                }
                sql_str = "SELECT * FROM deposit_history WHERE deposit_history.deposit_id = " + rsmain.getInt("deposits.id") + " ORDER BY deposit_history.years";
                ResultSet rsmain2 = provider.eval(sql_str);
                rsmain2.beforeFirst();
                double[] capacity = new double[Time.years.length];
                while(rsmain2.next()){
                    int DB_year = rsmain2.getInt("deposit_history.years");
                    if (DB_year > Time.ylastTime) continue;
                    capacity[DMath.Arithmetic.indexOf(Time.years, DB_year)] = rsmain2.getDouble("deposit_history.capacity");
                } 
                deposits.get(owner_id).add(new Deposit(rsmain.getInt("deposits.id"),
                        dName, this.my_countries.get(country_id),
                        owner_id, rsmain.getDouble("deposits.Resource"), start_date,capacity));
                
            }
            provider.close_conn();
            
        } catch (SQLException ex) {
            Logger.getLogger(Reactor.class.getName()).log(Level.SEVERE, null, ex);
        }
         catch(java.lang.NullPointerException ex){
             System.out.println("Что-то сломалось");
        }   

        return deposits;
    }
    
    private Mining create_mining(int id){
        String sql_str = "SELECT * \n" +
                            "FROM companies\n" +
                            "WHERE (((companies.id)="+String.valueOf(id)+"));";
        Mining mining = null;
        
        try {
            DBDataLoader provider = new DBDataLoader(this.bd_path);
            ResultSet rsmain = provider.eval(sql_str);
            
            rsmain.beforeFirst();
            if (rsmain.next()){
                Region reg = get_region_by_company_id(id);
                mining = new Mining();
                mining.set_actor_params(id, rsmain.getString("companies.companies_name"), reg);  //rsmain.getInt("companies.country.id")
                mining.setMin_marge(0.2);
                //mining.set_actor_params(0, "Lone Miner", (Region) module.my_regions.get(0));
            }
           
            
            provider.close_conn();
        }
        catch(Exception ex){          
           //System.out.print("Connection failed.  "+my_operators.get(my_operators.size()-1).getName()+"  "+String.valueOf(cow)+"\n");
           ex.printStackTrace();
        }
        
        
        return mining;
    }
    
    @Override
    void crate_minings() {     
      
        HashMap<Integer, ArrayList<Deposit>> deposits = create_deposits(); // создали структуру типа: mining_id -> array of deposits
        ArrayList<Mining> my_minings = new ArrayList<>();
        
        for (Map.Entry<Integer, ArrayList<Deposit>> entry : deposits.entrySet()){
            Mining m = create_mining(entry.getKey());
            int Owner_id = entry.getKey();
            Region my_reg = get_region_by_company_id(Owner_id);
            m.set_actor_params(Owner_id, query_company_name(Owner_id), my_reg);
            m.pbase = Producer.PBASE_PRICE;
            if (m != null){
                m.setDeposits(entry.getValue());
                my_minings.add(m);
            }
            
        }

        module.setMy_minings(my_minings);
    }

    @Override
    void create_trader() {
        super.create_trader(); //To change body of generated methods, choose Tools | Templates.
        Object[] reg0 = module.my_regions.stream().filter(reg -> reg.getId() == 15).toArray();
        Region reg = (Region) reg0[0];
        module.trader.set_actor_params(999, "Trader", reg);
        module.trader.capacity = 150*1000;
        module.trader.start_capacity = 160*1000;
        
        Stream<Region> regA = module.my_regions.stream().filter(regS -> regS.getId() == 3);
        Region reg2 = regA.findFirst().get();
        module.dump = new PKDump();
        module.dump.set_actor_params(1000, "Dump", reg2);
        module.my_minings.add(module.dump);
    }

    
    @Override
    public void create_agents() {
        ArrayList<String> agent_names = new ArrayList();
        ArrayList<Agent> my_agents = new ArrayList<>();
        module.AllActors.forEach((actor) -> {
            String ag_name = actor.getName();
            Region region = actor.getRegion();
            Agent agent = new Agent(ag_name, region);
            my_agents.add(agent);
            actor.set_agent(agent);
            agent_names.add(ag_name);
        });
        my_agents.forEach((t) -> {t.initLogistics(agent_names);});
        my_agents.forEach((t) -> {t.initQuotas(agent_names);});
        my_agents.forEach((t) -> {t.initRelations(agent_names);});
        readAndFillAgentsParamsByRegions(my_agents);
        module.setMy_agents(my_agents);
        
        
    }

    private Region get_region_by_company_id(int Owner_id) {
       
        String sql_str = "SELECT countries.region_id \n" +
        "FROM countries INNER JOIN companies ON countries.id = companies.country_id \n" +
        "WHERE companies.id =" + Owner_id+ ";";
        Region my_region = null;
        try {   
            DBDataLoader provider = new DBDataLoader(this.bd_path);
            ResultSet rsmain = provider.eval(sql_str);
            
            rsmain.beforeFirst();
            int region_id;
            rsmain.next();
            region_id = rsmain.getInt("countries.region_id");
            my_region = module.my_regions.get(region_id-1);   
            provider.close_conn();
            
            
        } catch (SQLException ex) {
            Logger.getLogger(Reactor.class.getName()).log(Level.SEVERE, null, ex);
        }
         catch(java.lang.NullPointerException ex){
             System.out.println("Что-то сломалось");
        }
        return my_region;
    }

    private String query_company_name(int Owner_id) {
        String name = "NONAME";
        String sql_str = "SELECT companies.companies_name\n" +
        "FROM companies \n" +
        "WHERE companies.id =" + Owner_id+ ";";
        
        DBDataLoader provider = new DBDataLoader(this.bd_path);
        ResultSet rsmain = provider.eval(sql_str);
        try {
            rsmain.beforeFirst();
            rsmain.next();
            name = rsmain.getString("companies_name").trim();
        } catch (SQLException ex) {
            Logger.getLogger(ScenarioTest.class.getName()).log(Level.SEVERE, null, ex);
        }
        return name;
    }


    
    
    
}
