/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package smmum_alpha;

import static smmum_alpha.Enrichment.calc_pk_volume;

/**
 *
 * @author Dmitry
 */
public class TVEL extends Enrichment{

    TVEL(double d, double d0, double[] get, double[] get0) {
        super(d,d0,get,get0);
    }

    @Override
    void restore() {
        if(Time.iTime < (Time.lastTime-1)){
            this.capacity = all_capacity[Time.iTime];
            this.cost = all_cost[Time.iTime];
            calc_hipp_capacity();
            hipp_capacities[Time.iTime+1] = hipp_capacity;
            super.calc_opt_tail();
            }
    }

    @Override
    double calc_price(ContractSWUPK c) {
        double marge = calc_marge(c);
        if (c.get_reactor().ru_design){
            double price = (cost)*(1+marge)+investment_cost;
            c.setMin_en_price((cost)*(1+min_marge)+investment_cost);
            return price;
        }else{
            double price = World.spotSWUprice[Time.iTime]*(1+marge);
            c.setMin_en_price(World.spotSWUprice[Time.iTime]*0.8);
            return price;
        }
    }

    @Override
    double calc_price(Contract c, double mean_pk_price) {
        double marge = calc_marge(c);
        c.set_marge_in_tender(marge);
        if (c.get_reactor().ru_design){
            double pk_vol = c.getSon(0).volume;
            //double costl = (pk_vol*mean_pk_price + Enrichment.calc_swu(c.volume, c.enrichment, tail)*this.cost)/c.volume;
            c.setMin_price((pk_vol*mean_pk_price + Enrichment.calc_swu(c.volume, c.enrichment, tail)*(this.cost*(1+min_marge)+investment_cost))/c.volume);
            //return costl*(1+marge);
            double price = (pk_vol*mean_pk_price + Enrichment.calc_swu(c.volume, c.enrichment, tail)*(this.cost*(1+marge)+investment_cost))/c.volume;
            return price; 
        }else{
            c.setMin_price(World.spotEUPprice[Time.iTime]*0.8);
            return (1+marge)*World.spotEUPprice[Time.iTime];
        }
    }

    @Override
    double calc_opt_tail_price(Contract c, double mean_pk_price) {
        double marge = calc_marge(c);
        c.set_marge_in_tender(marge);
        double swu_volume = Enrichment.calc_swu(c.volume, c.enrichment, tail);
        double pk_vol = calc_pk_volume(c.volume, c.enrichment, tail);
        double SWU_cost;
        double price;
        if (c.get_reactor().ru_design && this.pbase == Producer.PBASE_COST){
            c.setMin_price((pk_vol*mean_pk_price + Enrichment.calc_swu(c.volume, c.enrichment, tail)*(this.cost*(1+min_marge)+investment_cost))/c.volume);
            price = (pk_vol*mean_pk_price + Enrichment.calc_swu(c.volume, c.enrichment, tail)*(this.cost*(1+marge)+investment_cost))/c.volume;
        }else{
            price = (1+marge)*World.spotEUPprice[Time.iTime];
            c.setMin_price(World.spotEUPprice[Time.iTime]*0.8);
        }
        SWU_cost = price*c.volume - pk_vol*mean_pk_price;
        c.setSWU_stat(SWU_cost/swu_volume, swu_volume);
        return price;
    }
    
    
    
}
