/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package smmum_alpha;

import DMath.Arithmetic;
import java.util.ArrayList;
import java.util.stream.DoubleStream;


/**
 *
 * @author Dmitry
 */
public class TenderEUP  extends Tender {
    
    boolean sons_canceled = false;
    double marge;
    
    static void create_contracts(Reactor r, double need, Operator o) {
        ArrayList<Enrichment> potential_supliers;
        if (r.ru_design){
            potential_supliers = o.get_my_rus_eup_supplier();
        }
        else{
            potential_supliers = o.get_my_eup_supplier(need);
        }
        
        ArrayList<Contract> all_created_contracts = new ArrayList(potential_supliers.size());
        for (Enrichment ps : potential_supliers){
            
            Contract new_contract = new Contract();
            new_contract.level = Contract.LEVEL_A;
            new_contract.type = Contract.EUP;
            new_contract.volume = need;
            new_contract.product = Contract.P_OUP;
            new_contract.enrichment = r.enrichment;
            new_contract.en_volume = ps.calc_swu(new_contract);
            new_contract.set_buyer(o);
            new_contract.set_seller(ps);
            new_contract.set_current_owner(ps);
            new_contract.set_reactor(r);
            new_contract.year = Time.yTime;
            Tender.set_tender(new_contract);
            ContractChain.add(new_contract);
            all_created_contracts.add(new_contract);
        }
        for (Contract as : all_created_contracts){
            as.set_brothers(all_created_contracts);
        }
    }

    public TenderEUP() {
    }

    @Override
    void setMarge(double marge) {
        this.marge = marge; 
    }
    
    @Override
    void operate_contract_A() {
        // Обогатитель получает предложение от оператора
        // формирует заказ на природный уран
        // Переопределять объем не нужно
        // Новым контрактам вешаем TenderPK
        
        double PK_volume = c.get_seller().calc_pk(c);
        double SWU_volume = c.get_seller().calc_swu(c);
        if (! c.get_seller().is_capable(SWU_volume)){
            // Если обогатитель не в состоянии выполнить заказ
            c.level = Contract.LEVEL_R;
            c.reason = Contract.REASON_CAP;
            return;
        }
        ArrayList<Mining> potential_supliers = c.get_seller().get_my_min_supplier(PK_volume);
        ArrayList<Contract> all_created_contracts = new ArrayList(potential_supliers.size());
        for (Mining ps : potential_supliers){
            
            Contract new_contract = new Contract();
            new_contract.level = Contract.LEVEL_A;
            new_contract.type = Contract.EUP;
            new_contract.volume = PK_volume;
            new_contract.product = Contract.P_PK;
            new_contract.enrichment = c.get_reactor().enrichment;
            new_contract.set_buyer(c.get_seller());
            new_contract.set_seller(ps);
            new_contract.set_current_owner(ps);
            new_contract.set_reactor(c.get_reactor());
            new_contract.set_father(c);
            new_contract.year = Time.yTime;
            c.setSon(new_contract);
            Tender.set_tender(new_contract);
            ContractChain.add(new_contract);
            all_created_contracts.add(new_contract);
        }
        for (Contract as : all_created_contracts){
            as.set_brothers(all_created_contracts);
        }
        c.level = Contract.LEVEL_W;
        if (Tender.LOGGING)
        System.err.println("Contract " + c.id + " end level A");
    }

    @Override
    void operate_contract_B() {
        ArrayList<Contract> ac_contracts;
        try {
            ac_contracts = c.push_brothers();
        } catch (BrotherNotReadyException ex) {
            // метод push_brothers вернул 0-вой вектор. значит не все братья готовы
            return;
        }
        ac_contracts.add(this.c);
        double[] prioritets = new double[ac_contracts.size()];
        int i=0;
        for (Contract ac_brothre : ac_contracts) {
            String S = ac_brothre.get_buyer().getName();
            prioritets[i] = ac_brothre.get_buyer().calc_prioritet(ac_brothre);
            ac_brothre.historic_price.add(ac_brothre.price);
            ac_brothre.historic_prioritet.add(prioritets[i]);
            i++;
        }
        int n = Arithmetic.max(prioritets); 
        Contract W = ac_contracts.get(n);
        check_priority(W);
        if (W.get_buyer().is_acceptаble(W)){
            // могли бы заключить сделку
            // Осталось договориться по PK
            W.level = Contract.LEVEL_F;
            ac_contracts.remove(W);
            ac_contracts.forEach(con ->con.go_to_seller());
        } else{
            ac_contracts.forEach(con -> con.go_to_seller());
        }
        if (Tender.LOGGING)
        System.err.println("Contract " + c.id + " end level B");
    }

    @Override
    void operate_contract_C() {
        // Обогатитель получает обратно контаракт
        // Проверяет текущую возможность выполнить
        // должен обратно опросить шахты и оставаться С пока не придет от них ответ 
        if (! c.get_seller().is_capable(c.en_volume)) {
            c.reason = Contract.REASON_CAP;
            c.cancel();
        } else{
            if (pk_is_ready(Contract.LEVEL_D)){
                // Шахты готовы
                set_discount();
                c.level = Contract.LEVEL_D;
                c.set_current_owner(c.get_buyer());
                ArrayList<Contract> sons = c.getSons();
                sons.forEach((son) -> 
                    {
                        double prioritet = son.get_buyer().calc_prioritet(son);
                        son.historic_prioritet.add(prioritet);
                    }
                );
                sons.forEach(son -> son.waitC());
            } else{
                ArrayList<Contract> sons = c.getSons();
                sons.forEach(son -> son.wake_up());
            }
        }
        if (Tender.LOGGING)
        System.err.println("Contract " + c.id + " end level C");
    }

    @Override
    void operate_contract_D() {
        ArrayList<Contract> ac_contracts;
        try {
            ac_contracts = c.push_brothers();
        } catch (BrotherNotReadyException ex) {
            // метод push_brothers вернул 0-вой вектор. значит не все братья готовы
            return;
        }
        ac_contracts.add(this.c);
        double[] prioritets = new double[ac_contracts.size()];
        int i=0;
        for (Contract ac_brothre : ac_contracts) {
            prioritets[i] = ac_brothre.get_buyer().calc_prioritet(ac_brothre);
            ac_brothre.historic_price.add(ac_brothre.price);
            ac_brothre.historic_prioritet.add(prioritets[i]);
            i++;
        }
        int n = Arithmetic.max(prioritets); 
        Contract W = ac_contracts.get(n);
        check_priority(W);
        if (W.get_buyer().is_acceptаble(W)){
            // могли бы заключить сделку
            // Осталось договориться по PK
            W.level = Contract.LEVEL_F;
            ac_contracts.remove(W);
            ac_contracts.forEach(con ->con.go_to_seller());
        } else{
            ac_contracts.forEach(con -> con.go_to_seller());
        }
        if (Tender.LOGGING)
        System.err.println("Contract " + c.id + " end level D");
    }

    @Override
    void operate_contract_W() {
        super.operate_contract_W(); //To change body of generated methods, choose Tools | Templates.
        if (Tender.LOGGING)
        System.err.println("Contract " + c.id + " end level W");
    }

    @Override
    void operate_contract_F() {
        // это контакт который хочет заключить оператор
        // проверить есть ли готовый сын
        // если есть - заключаем сделку
        // остальные отменяем
        ArrayList<Contract> sons = c.getSons();
        if (pk_is_ready(Contract.LEVEL_W)){

           // DoubleStream dd = sons.stream().mapToDouble(s ->s.get_buyer().calc_prioritet(s));
            //double[] prioritets = dd.toArray();
            double[] prioritets = new double[sons.size()];
            int i = 0;
            for (Contract son : sons) {
                prioritets[i] = son.historic_prioritet.lastElement();
                i++;
            }
            int n = Arithmetic.max(prioritets);
            Contract W = sons.get(n);
            if (c.get_buyer().check_quota(c)){
                c.cancel();
                c.reason = Contract.REASON_QUOTA;
                return;
            }
            if (! c.can_consider_deal(c.historic_prioritet.lastElement())){
                // Невозможно заключить сделку с этим контрактом. 
                // Отправим его обратно к продавцу для выяснения причин
                c.go_to_seller();
                return;
            }
            boolean success = W.consider_deal(prioritets[n]);
            if (success){
                boolean success2 = c.consider_deal(c.historic_prioritet.lastElement());
                if(success2){
                    sons.remove(W);
                    sons.forEach(son -> son.cancel());
                    c.setSon(W);
                    ArrayList<Contract> AAA = c.getBrothers();
                    c.getBrothers().forEach(br -> br.cancel());
                }else{
                    throw new Error("Something goes wrong");
                }
            }else{
                // не была заключена сделка с поставщиком PK
                c.go_to_seller();
                return;
            }
        }
        else{
            throw new Error("Contracts are not ready");
        }
        if (Tender.LOGGING)
        System.err.println("Contract " + c.id + " end level F");
    }

    @Override
    void operate_contract_R() {
        // Нужно отменить сынов
        if (! sons_canceled){
            c.getSons().forEach(con -> con.cancel());
            sons_canceled = true;
        }
    }
    
    @Override
    void set_price() {
        double mean_pk_price = calc_mean_pk_price();
        double price = c.get_seller().calc_price(c, mean_pk_price); 
        c.price = price;
    }

    @Override
    void set_discount() {
       double mean_pk_price = calc_mean_pk_price();
       
        c.set_price(c.get_seller().set_discount_price(c,mean_pk_price ));
    }
    
    private double calc_mean_pk_price() {
        ArrayList<Contract> sons = c.getSons();
        if (sons.size() ==1)
            return sons.get(0).price;
        double[] prices = new double[sons.size()];
        double[] prioritets = new double[sons.size()];
        int i = 0;
        for (Contract son : sons) {
            prices[i] = son.price;
            prioritets[i] = son.historic_prioritet.lastElement();
            i++;
        }
        double min_prior = prioritets[Arithmetic.min(prioritets)];
        double max_prior = prioritets[Arithmetic.max(prioritets)];
        if (min_prior== max_prior)
            return Arithmetic.min(prices);
        double delta = max_prior - min_prior;
        double[] prioritets2 = new double[sons.size()];
        double[] prices2 = new double[sons.size()];
        for (int j = 0; j < sons.size(); j++) {
            prioritets2[j] = (prioritets[j] - min_prior)/delta;
        }
        for(int j = 0; j < sons.size(); j++){
            prices2[j] = prices[j]*prioritets2[j]/Arithmetic.sum(prioritets2);
        }
        return Arithmetic.sum(prices2);
        //return prices[Arithmetic.max(prioritets)];
    }

    @Override
    void wake_up() {
        // проверяем есть ли цена
        if (c.price == 0){
            // Значит цену пока еще не сформировали
            set_price();
            // И ставим уровень B
            c.level = Contract.LEVEL_B;
        } else{
            // Значит цена уже была и ждем скидки
            set_discount();
            c.level = Contract.LEVEL_D;
        }
        
    }
    
    boolean pk_is_ready(short Level){
        ArrayList<Contract> sons = c.getSons();
        boolean[] is_F = new boolean[sons.size()];
        int i = 0;
        for (Contract son : sons) {
            short level = son.level;
            is_F[i] = level == Level;
            i++;
        }
        return Arithmetic.any(is_F);
    } 

    
}
