/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package smmum_alpha;

import DMath.Arithmetic;
import java.util.ArrayList;

/**
 *
 * @author Dmitry
 */
public class TenderEUPSolo extends Tender {
    boolean is_piece;
    public TenderEUPSolo(){
        
    }
    
    static void create_contracts(Reactor r, double need, Operator o) {
        ArrayList<Enrichment> potential_supliers;
        if (r.ru_design){
            potential_supliers = o.get_my_rus_eup_supplier();
        }
        else{
            potential_supliers = o.get_my_eup_supplier(need);
        }
        
        ArrayList<Contract> all_created_contracts = new ArrayList(potential_supliers.size());
        for (Enrichment ps : potential_supliers){
            
            Contract new_contract = new Contract();
            new_contract.level = Contract.LEVEL_A;
            new_contract.type = Contract.EUP;
            new_contract.volume = need;
            new_contract.product = Contract.P_OUP;
            new_contract.enrichment = r.enrichment;
            new_contract.en_volume = ps.calc_swu(new_contract);
            new_contract.set_buyer(o);
            new_contract.set_seller(ps);
            new_contract.set_current_owner(ps);
            new_contract.set_reactor(r);
            new_contract.year = Time.yTime;
            Tender.set_tender(new_contract);
            Tender T = new_contract.getTender();
            TenderEUPSolo T0;
//            if (T.getClass().equals(TenderEUPSolo.class))
            T0 = (TenderEUPSolo) T;
            T0.is_piece = o.has_pieces;
            ContractChain.add(new_contract);
            all_created_contracts.add(new_contract);
        }
        for (Contract as : all_created_contracts){
            as.set_brothers(all_created_contracts);
        }
    }
    
    void set_piece(boolean a){
        this.is_piece = a;
    }
    
    @Override
    void operate_contract_A() {
        // Обогатитель получает предложение от оператора
        // формирует заказ на природный уран
        // Переопределять объем не нужно
        // Новым контрактам вешаем TenderPK
        
        if ((! c.get_seller().is_capable(c,is_piece)) || (c.get_seller().isempty()) ){
            // Если обогатитель не в состоянии выполнить заказ
            c.level = Contract.LEVEL_R;
            c.reason = Contract.REASON_CAP;
            return;
        }
        set_price();
        c.level = Contract.LEVEL_B;
        if (Tender.LOGGING)
        System.err.println("Contract " + c.id + " end level A");
    }
    
    @Override
    void operate_contract_B() {
        ArrayList<Contract> ac_contracts;
        try {
            ac_contracts = c.push_brothers();
        } catch (BrotherNotReadyException ex) {
            // метод push_brothers вернул 0-вой вектор. значит не все братья готовы
            return;
        }
        ac_contracts.add(this.c);
        double[] prioritets = new double[ac_contracts.size()];
        int i=0;
        for (Contract ac_brothre : ac_contracts) {
            String S = ac_brothre.get_buyer().getName();
            prioritets[i] = ac_brothre.get_buyer().calc_prioritet(ac_brothre);
            ac_brothre.historic_price.add(ac_brothre.price);
            ac_brothre.historic_prioritet.add(prioritets[i]);
            i++;
        }
        int n = Arithmetic.max(prioritets); 
        Contract W = ac_contracts.get(n);
        check_priority(W);
        ac_contracts.remove(W);
        ac_contracts.forEach(con ->con.go_to_seller());
        boolean success = W.consider_deal(W.historic_prioritet.lastElement());
        if (success) {
           W.getBrothers().forEach(b -> b.cancel());
        }
        if (Tender.LOGGING)
        System.err.println("Contract " + c.id + " end level C");
    }
    
    @Override
    void operate_contract_C() {
        // Оператор отправил обратно контракт чтобы выторговать себе лучшие условия
        // проверить возможность выполнения контракта
        // Вычислить скидку
        // Изменить цену
        // Поменять тип контракта на D
        
        if (! c.get_seller().is_capable(c,is_piece)) {
            c.level = Contract.LEVEL_R;
            c.reason = Contract.REASON_CAP;
        } else{
            set_discount();
            c.level = Contract.LEVEL_D;
            c.set_current_owner(c.get_buyer());
        }
        
        
    }
    
    @Override
    void operate_contract_D() {
         // Оператор получает ХОТЯ БЫ один ответ от MOX-производителя
         // подтягиваем АКТИВНЫХ братьев 
         // проставляем приоритет для каждого братского контракта и самого контракта
         // У Контракта с максимальным приоритетом выполняется метод проверки возможности сделки
         // У остальных пишется уровень C и они отъезжают из рассмотрения
        ArrayList<Contract> ac_contracts;
        try {
            ac_contracts = c.push_brothers();
        } catch (BrotherNotReadyException ex) {
            // метод push_brothers вернул 0-вой вектор. значит не все братья готовы
            return;
        }
         ac_contracts.add(this.c);
         double[] prioritets = new double[ac_contracts.size()];
         int i=0;
         for (Contract ac_brothre : ac_contracts) {
            prioritets[i] = ac_brothre.get_buyer().calc_prioritet(ac_brothre);
            ac_brothre.historic_price.add(ac_brothre.price);
            ac_brothre.historic_prioritet.add(prioritets[i]);
            i++;
        }
        int n = Arithmetic.max(prioritets); 
        Contract W = ac_contracts.get(n);
        check_priority(W);
        ac_contracts.remove(W);
        ac_contracts.forEach(con ->con.go_to_seller());
        boolean success = W.consider_deal(W.historic_prioritet.lastElement());
        if (success) {
           W.getBrothers().forEach(b -> b.cancel());
        } 
    }
    
    @Override
    void set_discount() {
       double mean_pk_price = World.spotPKprice[Time.iTime];
       
        c.set_price(c.get_seller().set_opt_tail_discount_price(c,mean_pk_price ));
    }
    
    @Override
    void set_price() {
        double mean_pk_price = World.spotPKprice[Time.iTime];
        double price = c.get_seller().calc_opt_tail_price(c, mean_pk_price); 
        c.price = price;
    }
    
    @Override
    boolean consider_deal(double prioritet){
        
        // Если приемлимо заключается контракт
         // Если нет проверить стадию торгов и дату поставки
         // В заисимости от проверки отправить на досогласование, принять или прекраить торги
        if (this.c.get_buyer().is_acceptаble(prioritet) && (this.c.get_seller().is_capable(c,is_piece)) && !c.get_buyer().check_quota(c)){
            // Заключить сделку
            this.c.get_buyer().deal(c);
            this.c.get_seller().deal(c);
            c.set_current_owner(c.get_buyer());
            ArchiveChain.add(c);
            c.level = Contract.LEVEL_H;
            return true;
         }
         else{
            if ((! c.get_seller().is_capable(c))|| c.get_buyer().check_quota(c)){
                c.level = Contract.LEVEL_R;
                if (! c.get_seller().is_capable(c))
                    c.reason = Contract.REASON_CAP;
                else
                    c.reason = Contract.REASON_QUOTA;
                operate_contract_R();
                if (Tender.LOGGING)
                System.err.println("Contract " + c.id + " set to level R");
            }
            else{
                c.level = Contract.LEVEL_C;
                c.set_current_owner(c.get_seller());
            }
            return false;
         }
    
    }
}
