/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package smmum_alpha;

import DMath.Arithmetic;
import java.util.ArrayList;

/**
 *
 * @author Dmitry
 */
public class TenderMOX extends Tender {
    
    int max_stage = 5; 
    
    public TenderMOX() {
    }
    
    static public void create_mox_contracts(Reactor r, double need, Operator o){
        ArrayList<MoxSupplier> potential_supliers = o.get_my_mox_supplier();
        double need_mox = Reactor.recalc_mox(need);
        ArrayList<Contract> all_created_contracts = new ArrayList(potential_supliers.size());
        for (MoxSupplier ps : potential_supliers){
            
            Contract new_contract = new Contract();
            new_contract.level = Contract.LEVEL_A;
            new_contract.type = Contract.MOX;
            new_contract.volume = need_mox;
            new_contract.product = Contract.P_MOX;
            new_contract.set_buyer(o);
            new_contract.set_seller(ps);
            new_contract.set_current_owner(ps);
            new_contract.set_reactor(r);
            new_contract.year = Time.yTime;
            Tender.set_tender(new_contract);
            ContractChain.add(new_contract);
            all_created_contracts.add(new_contract);
        }
        for (Contract as : all_created_contracts){
            as.set_brothers(all_created_contracts);
        }
    }
    
    @Override
    void operate_contract_A() {
        // Оператор передает офферту МОКС-производителю
        // Мокс-производитель оценивает свои возможности и назначет стартовую цену
        
        c.get_buyer().calc_needed_waste(c.volume);
        
        if (this.c.get_seller().is_capable(c.volume)){
            set_price();
            c.level = Contract.LEVEL_B;
            
            c.set_current_owner(c.get_buyer());
        } else {
            c.level = Contract.LEVEL_R;
        }
            
    }

    @Override
    void operate_contract_B() {
         // Оператор получает ХОТЯ БЫ один ответ от MOX-производителя
         // подтягиваем АКТИВНЫХ братьев 
         // проставляем приоритет для каждого братского контракта и самого контракта
         // У Контракта с максимальным приоритетом выполняется метод проверки возможности сделки
         // У остальных пишется уровень C и они отъезжают из рассмотрения
         
         
         
        ArrayList<Contract> ac_contracts;
        try {
            ac_contracts = c.push_brothers();
        } catch (BrotherNotReadyException ex) {
            // метод push_brothers вернул 0-вой вектор. значит не все братья готовы
            return;
        }
         ac_contracts.add(this.c);
         double prioritet;
         double[] prioritets = new double[ac_contracts.size()];
         int i=0;
         for (Contract ac_brothre : ac_contracts) {
            prioritets[i] = ac_brothre.get_buyer().calc_prioritet(ac_brothre);
            ac_brothre.historic_price.add(ac_brothre.price);
            ac_brothre.historic_prioritet.add(prioritets[i]);
            i++;
        }
        int n = Arithmetic.max(prioritets); 
        Contract W = ac_contracts.get(n);
        check_priority(W);
        ac_contracts.remove(W);
        ac_contracts.forEach(con ->con.go_to_seller());
        boolean success = W.consider_deal(W.historic_prioritet.lastElement());
        if (success) {
           W.getBrothers().forEach(b -> b.cancel());
        } 
       
    }

    @Override
    void operate_contract_C() {
        // Оператор отправил обратно контракт чтобы выторговать себе лучшие условия
        // проверить возможность выполнения контракта
        // Вычислить скидку
        // Изменить цену
        // Поменять тип контракта на D
        
        if (! c.get_seller().is_capable(c.volume)) {
            c.level = Contract.LEVEL_R;
        } else{
            set_discount();
            c.level = Contract.LEVEL_D;
            c.set_current_owner(c.get_buyer());
        }
        
        
    }
    
    @Override
    void operate_contract_D() {
         // Оператор получает ХОТЯ БЫ один ответ от MOX-производителя
         // подтягиваем АКТИВНЫХ братьев 
         // проставляем приоритет для каждого братского контракта и самого контракта
         // У Контракта с максимальным приоритетом выполняется метод проверки возможности сделки
         // У остальных пишется уровень C и они отъезжают из рассмотрения
        ArrayList<Contract> ac_contracts;
        try {
            ac_contracts = c.push_brothers();
        } catch (BrotherNotReadyException ex) {
            // метод push_brothers вернул 0-вой вектор. значит не все братья готовы
            return;
        }
         ac_contracts.add(this.c);
         double[] prioritets = new double[ac_contracts.size()];
         int i=0;
         for (Contract ac_brothre : ac_contracts) {
            prioritets[i] = ac_brothre.get_buyer().calc_prioritet(ac_brothre);
            ac_brothre.historic_price.add(ac_brothre.price);
            ac_brothre.historic_prioritet.add(prioritets[i]);
            i++;
        }
        int n = Arithmetic.max(prioritets); 
        Contract W = ac_contracts.get(n);
        check_priority(W);
        ac_contracts.remove(W);
        ac_contracts.forEach(con ->con.go_to_seller());
        boolean success = W.consider_deal(W.historic_prioritet.lastElement());
        if (success) {
           W.getBrothers().forEach(b -> b.cancel());
        } 
    }

    @Override
    void set_price() {
        double price = c.get_seller().calc_price(c);
        c.set_price(price);
    }

    @Override
    void set_discount() {
        double discount = c.get_seller().calc_discount(c);
        double new_price = c.price*(1 - discount);
        if (new_price < c.min_price){new_price = c.min_price;}   
        c.set_price(new_price);
    }
    
    
    
}
