/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package smmum_alpha;

import DMath.Arithmetic;
import java.util.ArrayList;

/**
 *
 * @author Dmitry
 */
public class TenderPKSolo extends TenderPK{

    static void create_contracts(Reactor r, double need, Operator op) {
        ArrayList<Mining> potential_supliers = op.get_my_min_supplier(need);
        ArrayList<Contract> all_created_contracts = new ArrayList(potential_supliers.size());
        for (Mining ps : potential_supliers){
            
            Contract new_contract = new Contract();
            new_contract.level = Contract.LEVEL_A;
            new_contract.type = Contract.PK_Solo;
            new_contract.volume = need;
            new_contract.product = Contract.P_PK;
            new_contract.enrichment = World.natural_enrichment;
            new_contract.set_buyer(op);
            new_contract.set_seller(ps);
            new_contract.set_current_owner(ps);
            new_contract.set_reactor(r);
            new_contract.year = Time.yTime;
            Tender.set_tender(new_contract);
            ContractChain.add(new_contract);
            all_created_contracts.add(new_contract);
        }
        for (Contract as : all_created_contracts){
            as.set_brothers(all_created_contracts);
        }
    }
    
    static void create_contracts(Reactor r, double need, Trader trader) {
        ArrayList<Mining> potential_supliers = trader.get_my_min_supplier(need);
        ArrayList<Contract> all_created_contracts = new ArrayList(potential_supliers.size());
        trader.increase_needs(need);
        for (Mining ps : potential_supliers){
            if(ps.equals(trader)) continue; // У себя не покупаем))
            Contract new_contract = new Contract();
            new_contract.level = Contract.LEVEL_A;
            new_contract.type = Contract.PK_Solo;
            new_contract.volume = need;
            new_contract.product = Contract.P_PK;
            new_contract.enrichment = World.natural_enrichment;
            new_contract.set_buyer(trader);
            new_contract.set_seller(ps);
            new_contract.set_current_owner(ps);
            new_contract.set_reactor(r);
            new_contract.year = Time.yTime;
            Tender.set_tender(new_contract);
            ContractChain.add(new_contract);
            all_created_contracts.add(new_contract);
        }
        for (Contract as : all_created_contracts){
            as.set_brothers(all_created_contracts);
        }
    }
    

    static void create_trader_contracts(Trader trader) {
        ArrayList<Mining> potential_supliers = trader.get_my_min_supplier();
        ArrayList<Contract> all_created_contracts = new ArrayList(potential_supliers.size());
        for (Mining ps : potential_supliers){
            if(ps.equals(trader)) continue; // У себя не покупаем))
            if (ps.capacity < 2500) continue; // У мелочи не покупаем))
            double need = ps.capacity*trader.purchase_rate;
            if (need < 25) continue; // по мелочи не покупаем))
            trader.increase_needs(need);
            Contract new_contract = new Contract();
            new_contract.level = Contract.LEVEL_A;
            new_contract.type = Contract.PK_Solo;
            new_contract.volume = need;
            new_contract.product = Contract.P_PK;
            new_contract.enrichment = World.natural_enrichment;
            new_contract.set_buyer(trader);
            new_contract.set_seller(ps);
            new_contract.set_current_owner(ps);
            new_contract.set_reactor(new Reactor("Trader"));
            new_contract.year = Time.yTime;
            new_contract.set_brothers(new ArrayList());
            Tender.set_tender(new_contract);
            ContractChain.add(new_contract);
            all_created_contracts.add(new_contract);
        }
    }
    @Override
    void operate_contract_A() {
        // проверить выполнимость
        if (this.c.get_seller().is_capable(c.volume)){
            c.level = Contract.LEVEL_B;
            double price = c.get_seller().calc_price(c);
            c.set_price(price);
            c.set_current_owner(c.get_buyer());
        } else {
            c.level = Contract.LEVEL_R;
        }
        if (Tender.LOGGING)
        System.err.println("Contract " + c.id + " end level A");
    }
    @Override
    void operate_contract_B() {
        ArrayList<Contract> ac_contracts;
        try {
            ac_contracts = c.push_brothers();
        } catch (BrotherNotReadyException ex) {
            // метод push_brothers вернул 0-вой вектор. значит не все братья готовы
            return;
        }
         ac_contracts.add(this.c);
         // Расчет Приоритета
         double[] prioritets = new double[ac_contracts.size()];
         int i=0;
         for (Contract ac_brothre : ac_contracts) {
            prioritets[i] = ac_brothre.get_buyer().calc_prioritet(ac_brothre);
            ac_brothre.historic_price.add(ac_brothre.price);
            ac_brothre.historic_prioritet.add(prioritets[i]);
            i++;
        }
        int n = Arithmetic.max(prioritets); 
        Contract W = ac_contracts.get(n);
        check_priority(W);
        ac_contracts.remove(W);
        ac_contracts.forEach(con ->con.go_to_seller());
        boolean success = W.consider_deal(W.historic_prioritet.lastElement());
        if (success) {
           W.getBrothers().forEach(b -> b.cancel());
        } //To change body of generated methods, choose Tools | Templates.
    }
    
    @Override
    void operate_contract_C() {
        if (! c.get_seller().is_capable(c.volume)) {
            c.level = Contract.LEVEL_R;
        } else{
            double discount = c.get_seller().calc_discount(c);
            double new_price = c.price*(1 - discount);
            if (new_price < c.min_price){new_price = c.min_price;}   
            c.set_price(new_price);
            c.level = Contract.LEVEL_D;
            c.set_current_owner(c.get_buyer());
        }
        if (Tender.LOGGING)
        System.err.println("Contract " + c.id + " end level C");
    }
    
    
    void operate_contract_D() {
         // Оператор получает ХОТЯ БЫ один ответ от ПК-продавца
         // подтягиваем АКТИВНЫХ братьев 
         // проставляем приоритет для каждого братского контракта и самого контракта
         // У Контракта с максимальным приоритетом выполняется метод проверки возможности сделки
         // У остальных пишется уровень C и они отъезжают из рассмотрения
        ArrayList<Contract> ac_contracts;
        try {
            ac_contracts = c.push_brothers();
        } catch (BrotherNotReadyException ex) {
            // метод push_brothers вернул 0-вой вектор. значит не все братья готовы
            return;
        }
         ac_contracts.add(this.c);
         double[] prioritets = new double[ac_contracts.size()];
         int i=0;
         for (Contract ac_brothre : ac_contracts) {
            prioritets[i] = ac_brothre.get_buyer().calc_prioritet(ac_brothre);
            ac_brothre.historic_price.add(ac_brothre.price);
            ac_brothre.historic_prioritet.add(prioritets[i]);
            i++;
        }
        int n = Arithmetic.max(prioritets); 
        Contract W = ac_contracts.get(n);
        check_priority(W);
        ac_contracts.remove(W);
        ac_contracts.forEach(con ->con.go_to_seller());
        boolean success = W.consider_deal(W.historic_prioritet.lastElement());
        if (success) {
           W.getBrothers().forEach(b -> b.cancel());
        } 
    }
    
    @Override
    void operate_contract_R() {
    }
}
