/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package smmum_alpha;

import java.util.ArrayList;

/**
 *
 * @author Dmitry
 */
public class TenderRemix extends Tender{

    static void create_contracts(Reactor r, double need, Operator o) {
        RemixSupplier remix_suplier = o.get_my_remix_supplier();
        double need_remix = Reactor.recalc_remix(need, r);

            Contract new_contract = new Contract();
            new_contract.level = Contract.LEVEL_W;
            new_contract.type = Contract.REMIX;
            new_contract.volume = need_remix;
            new_contract.product = Contract.P_REMIX;
            new_contract.enrichment = r.enrichment;
            new_contract.set_buyer(o);
            new_contract.set_seller(remix_suplier);
            new_contract.set_current_owner(remix_suplier);
            new_contract.set_reactor(r);
            new_contract.year = Time.yTime;
            Tender.set_tender(new_contract);
            ContractChain.add(new_contract);
            TenderRemix.create_PK_contracts(remix_suplier, new_contract);    
    }

    private static void create_PK_contracts(RemixSupplier remix_suplier, Contract remix_contract ) {
        
        double need = RemixSupplier.calc_PK(remix_contract, remix_suplier.getTail());
        ArrayList<Mining> potential_supliers = remix_suplier.get_my_min_supplier(need);
        ArrayList<Contract> all_created_contracts = new ArrayList(potential_supliers.size());
        for (Mining ps : potential_supliers){
            Contract new_contract = new Contract();
            new_contract.level = Contract.LEVEL_A;
            new_contract.type = Contract.PK_Solo;
            new_contract.volume = need;
            new_contract.product = Contract.P_PK;
            new_contract.enrichment = World.natural_enrichment;
            new_contract.set_buyer(remix_suplier);
            new_contract.set_seller(ps);
            new_contract.set_current_owner(ps);
            new_contract.set_reactor(remix_contract.get_reactor());
            new_contract.year = Time.yTime;
            new_contract.set_father(remix_contract);
            Tender.set_tender(new_contract);
            ContractChain.add(new_contract);
            all_created_contracts.add(new_contract);
        }
        for (Contract as : all_created_contracts){
            as.set_brothers(all_created_contracts);
        }
    }

    static void wake_father(Contract c) {
        c.getFather().setSon(c);
        c.getFather().wake_up();
    }

    @Override
    void wake_up() {
        c.level = Contract.LEVEL_A;
    }
    
    @Override
    void operate_contract_W() {
        // Wait
    }
    @Override
    void operate_contract_A() {        
        if (this.c.get_seller().is_capable(c.volume)){
            set_price();
            c.level = Contract.LEVEL_B;
            
            c.set_current_owner(c.get_buyer());
        } else {
            throw new Error(" Мощности Ремикс поствщика не хватает ");
        }  
    }
    @Override
    void operate_contract_B() {
       double prioritet = c.get_buyer().calc_prioritet(c);
       c.historic_prioritet.add(prioritet);
       c.historic_price.add(c.price);
       check_priority(c);
       c.consider_deal(c.historic_prioritet.lastElement());
    }
    
    @Override
    void operate_contract_C() {
        if (! c.get_seller().is_capable(c.volume)) {
            throw new Error(" Мощности Ремикс поствщика не хватает ");
        } else{
            set_discount();
            c.level = Contract.LEVEL_D;
            c.set_current_owner(c.get_buyer());
        }
    }
    
    @Override
    void operate_contract_D() {
       double prioritet = c.get_buyer().calc_prioritet(c);
       c.historic_prioritet.add(prioritet);
       c.historic_price.add(c.price);
       check_priority(c);
       c.consider_deal(c.historic_prioritet.lastElement());
    }

    

    
    
    @Override
    void set_price() {
        double price = c.get_seller().calc_price(c);
        c.set_price(price);
    }

    @Override
    void set_discount() {
        double discount = c.get_seller().calc_discount(c);
        double new_price = c.price*(1 - discount);
        if (new_price < c.min_price){new_price = c.min_price;}   
        c.set_price(new_price);
    }
    
    
    
    
}
