/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package smmum_alpha;

import DMath.Arithmetic;
import java.util.ArrayList;

/**
 *
 * @author Dmitry
 */
public class TenderSWU extends Tender {
    
    ContractSWUPK c_swupk;
    private boolean is_piece;
    
    public TenderSWU() {
        }
    
    
    static void create_contracts(Reactor r, double need, Operator o) {
        ArrayList<Enrichment> potential_e_suppliers = o.get_my_swu_supplier(Enrichment.calc_swu(need, r.enrichment));
        ArrayList<Mining> potential_m_suppliers = o.get_my_min_supplier(Enrichment.calc_pk_volume(need, r.enrichment));
        ArrayList<Contract> all_created_contracts = new ArrayList();
        for (Enrichment potential_e_supplier : potential_e_suppliers) {
            for (Mining potential_m_supplier : potential_m_suppliers) {
                ContractSWUPK new_contract = new ContractSWUPK();
                new_contract.level = Contract.LEVEL_A;
                new_contract.type = Contract.SWU_PK;
                new_contract.volume = need;
                new_contract.en_volume = Enrichment.calc_swu(need, r.enrichment);
                new_contract.pk_volume = Enrichment.calc_pk_volume(need, r.enrichment);
                new_contract.enrichment = r.enrichment;
                new_contract.product = Contract.P_SWU;
                new_contract.set_buyer(o);
                new_contract.setEn_seller(potential_e_supplier);
                new_contract.setPk_seller(potential_m_supplier);
                new_contract.set_current_owner(o);
                new_contract.set_reactor(r);
                new_contract.year = Time.yTime;
                Tender.set_tender(new_contract);
                TenderSWU T0 = (TenderSWU) new_contract.getTender();
                T0.is_piece = o.has_pieces;
                ContractChain.add(new_contract);
                all_created_contracts.add(new_contract);
            }
        }
        for (Contract as : all_created_contracts){
            as.set_brothers(all_created_contracts);
        }
        
    }

    @Override
    void set_contract(Contract con) {
        this.c = (ContractSWUPK) con;
        this.c_swupk = (ContractSWUPK) c;
    }
    
    @Override
    void operate_contract_A() {

        if ((c_swupk.getEn_seller().is_capable(c_swupk,is_piece) )&& c_swupk.getPk_seller().is_capable(c_swupk.pk_volume) ){
            set_price();
            c.level = Contract.LEVEL_B;
            if (Tender.LOGGING)
            System.err.println("Contract " + c.id + " end level A");
        } else {
            c.level = Contract.LEVEL_R;
            c.reason = Contract.REASON_CAP;
            if (Tender.LOGGING)
            System.err.println("Send Contract " + c.id + " to R");
        }    
    }    
    
    @Override
    void operate_contract_B() {
        ArrayList<Contract> ac_contracts;
        try {
            ac_contracts = c.push_brothers();
        } catch (BrotherNotReadyException ex) {
            // метод push_brothers вернул 0-вой вектор. значит не все братья готовы
            return;
        }
         ac_contracts.add(this.c);
         double[] prioritets = new double[ac_contracts.size()];
         int i=0;
         for (Contract ac_brothre : ac_contracts) {
            prioritets[i] = ac_brothre.get_buyer().calc_prioritet(ac_brothre);
            ac_brothre.historic_price.add(ac_brothre.price);
            ac_brothre.historic_prioritet.add(prioritets[i]);
            i++;
        }
        int n = Arithmetic.max(prioritets); 
        Contract W = ac_contracts.get(n);
        check_priority((ContractSWUPK) W);
        ac_contracts.remove(W);
        ac_contracts.forEach(con ->con.go_to_seller());
        boolean success = W.consider_deal(W.historic_prioritet.lastElement());
        if (Tender.LOGGING)
            System.err.println("Send Contract " + W.id + " to attemp deal");
        if (success) {
           W.getBrothers().forEach(b -> b.cancel());
        } 
        if (Tender.LOGGING)
            System.err.println("Contract " + c.id + " end level B");
    }

    @Override
    void operate_contract_C() {

        if (! ((c_swupk.getEn_seller().is_capable(c_swupk,is_piece) )&& c_swupk.getPk_seller().is_capable(c_swupk.pk_volume)) ) {
            c.level = Contract.LEVEL_R;
            c.reason = Contract.REASON_CAP;
            if (Tender.LOGGING)
                System.err.println("Send Contract " + c.id + " to R");
            
        }
        else if (
            c.get_buyer().getAgent().fail_quota(c_swupk)){
            c.level = Contract.LEVEL_R;
            c.reason = Contract.REASON_QUOTA;
        }
        else{
            
            calc_discount();
            
            c.level = Contract.LEVEL_D;
            c.set_current_owner(c.get_buyer());
            if (Tender.LOGGING)
            System.err.println("Contract " + c.id + " end level C");
        }
    }
    
    @Override
    void operate_contract_D() {
        ArrayList<Contract> ac_contracts;
        try {
            ac_contracts = c.push_brothers();
        } catch (BrotherNotReadyException ex) {
            // метод push_brothers вернул 0-вой вектор. значит не все братья готовы
            return;
        }
         ac_contracts.add(this.c);
         double prioritet;
         double[] prioritets = new double[ac_contracts.size()];
         int i=0;
         for (Contract ac_brothre : ac_contracts) {
            prioritets[i] = ac_brothre.get_buyer().calc_prioritet(ac_brothre);
            ac_brothre.historic_price.add(ac_brothre.price);
            ac_brothre.historic_prioritet.add(prioritets[i]);
            i++;
        }
        int n = Arithmetic.max(prioritets); 
        Contract W = ac_contracts.get(n);
        check_priority(W);
        ac_contracts.remove(W);
        ac_contracts.forEach(con ->con.go_to_seller());
        if (Tender.LOGGING)
            System.err.println("Send Contract " + W.id + " to attemp deal");
        boolean success = W.consider_deal(W.historic_prioritet.lastElement());
        if (success) {
           W.getBrothers().forEach(b -> b.cancel());
        }
        if (Tender.LOGGING)
        System.err.println("Contract " + c.id + " end level D");
    }

    @Override
    void set_price() {
        double en_price = c_swupk.getEn_seller().calc_price(c_swupk);
        c_swupk.setEn_price(en_price);
        double pk_price = c_swupk.getPk_seller().calc_price(c);
        c_swupk.setPk_price(pk_price);
        double eup_price = (c_swupk.en_price*c_swupk.en_volume + c_swupk.pk_price*c_swupk.pk_volume)/c.volume;
        c.set_price(eup_price);
    }

    private void calc_discount() { 

       
       
       double new_en_price = c_swupk.getEn_seller().set_discount_price(c_swupk);
       double new_pk_price = c_swupk.getPk_seller().set_discount_price(c_swupk);

       c_swupk.setEn_price(new_en_price);
       c_swupk.setPk_price(new_pk_price);
       
       double new_eup_price = (c_swupk.en_price*c_swupk.en_volume + c_swupk.pk_price*c_swupk.pk_volume)/c.volume;
       c.set_price(new_eup_price);
    }

    @Override
    boolean consider_deal(double prioritet) {
        if (c.get_buyer().getAgent().fail_quota(c_swupk)){
            c.level = Contract.LEVEL_R;
            c.reason = Contract.REASON_QUOTA;
            operate_contract_R();
            return false;
        }
        
        if (this.c.get_buyer().is_acceptаble(prioritet) && (this.c_swupk.getEn_seller().is_capable(c_swupk, is_piece) )
                && this.c_swupk.getPk_seller().is_capable(c_swupk.pk_volume) ){
            // Заключить сделку
            this.c.get_buyer().deal(c);
            this.c_swupk.getEn_seller().deal(c_swupk);
            this.c_swupk.getPk_seller().deal(c_swupk);
            c.set_current_owner(c.get_buyer());
            ArchiveChain.add(c);
            c.level = Contract.LEVEL_H;
            return true;
        }
        else{
            if ((! this.c_swupk.getEn_seller().is_capable(c_swupk,is_piece)) ||
                    (! this.c_swupk.getPk_seller().is_capable(c_swupk.pk_volume)) ){
                c.level = Contract.LEVEL_R;
                c.reason = Contract.REASON_CAP;
                operate_contract_R();
                if (Tender.LOGGING)
                System.err.println("Contract " + c.id + " set to level R");
            }
            else{
                c.level = Contract.LEVEL_C;
            }
            return false;
        }
    }

    
}
