/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package smmum_alpha;

import java.util.ArrayList;
import java.util.LinkedHashMap;

/**
 *
 * @author Dmitry
 */
public class Trader extends Mining{
    double purchase_rate = 0.00;
    int max_iter = 6;
    double sum_needs = 0;
    int active_year = 2017;
    double start_capacity = 0;
    double storage_cost = 1.3;// Стоимость хранения киллограмма ПК
    PKRaitingFuzzyCalculator PKFuzzyCalculator;
    public Trader() {
        all_capacity = new double[Time.years.length];
        all_cost = new double[Time.years.length];
        all_reserves = new double[Time.years.length];
        PKFuzzyCalculator = new PKRaitingFuzzyCalculator(this);
        MargeFuzzyCalculator = new PKMargeFuzzyCalculator(this);
        DiscountMargeCalculator = new PKDiscountFuzzyCalculator(this);
        pseudocountries = new ArrayList<>();
        deposits = new ArrayList<>();
        stats = new TraderStat(this);
        pbase = PBASE_PRICE;
    }

    public int getActive_year() {
        return active_year;
    }
    
    @Override
    public void form_demand(){
        TenderPKSolo.create_trader_contracts(this);
    }
    
    public boolean isActive(){
        return Time.yTime  >= getActive_year();
    }
    public void form_special_demands(double volume, int year){
        if (Time.yTime != year) return;
        // нарезаем по 50 тонн
        Reactor r = new Reactor("Trader");
            int I = (int) Math.floor(volume/50);
            for (int i = 0; i < I; i++) {
                TenderPKSolo.create_contracts(r, 50.0, this);
            }
            if(volume%50 > 0)
                TenderPKSolo.create_contracts(r,volume%50,this);
    }

    @Override
    double calc_price(Contract c) {
        double marge = calc_marge(c);
        double base = World.tbulletin.get_max_pk_cost();
        double price = base*(1+marge);
        if (c.getClass().equals(ContractSWUPK.class)){
            c.setMin_pk_price(base*0.95);
        }else
            c.setMin_price(base*0.8);
        return price;
    }
    
    
    @Override
    void restore() {
        sum_needs = 0;
        if(Time.iTime < (Time.lastTime-1)){
            all_capacity[Time.iTime +1] =  capacity;
            all_reserves[Time.iTime +1] = capacity;
            calc_cost();
        decide_if_active();
        } 
        else{
        calc_cost();
        }
    }
    private void calc_cost(){
        if (Time.iTime == 0)
            all_cost[Time.iTime] = stats.get_pk_balance(storage_cost, start_capacity);
        else if (stats.get_pk_buy_volume(Time.iTime) == 0)
            all_cost[Time.iTime] =  all_cost[Time.iTime-1];
        else{
            all_cost[Time.iTime] = stats.get_pk_balance(storage_cost, all_capacity[0]);
        }
    }
    
    private void decide_if_active(){
        if (this.active_year > Time.yTime){
            if (all_cost[Time.iTime] > 0 && all_cost[Time.iTime] < World.spotPKprice[Time.iTime+1]){
                this.active_year = Time.yTime;
            }
        }
        else{
            if (all_cost[Time.iTime] > World.spotPKprice[Time.iTime+1])
                this.active_year = Time.ylastTime;
        }
    }
    @Override
    double calc_prioritet(Contract c) {
        return PKFuzzyCalculator.calc_prioritet(c);
    }
    
    @Override
    void deal_pk(Contract c) {
        // проверка покупатель или продавец;
        if(c.get_buyer().equals(this)){
            buy(c);
            increase_capacity(c);
            c.get_seller().decrease_capacity(c);
        }
        else if (c.get_seller().equals(this)){
            sell(c);
        } else
        throw new Error("This is not contract for me!!!!");
    }
    @Override
    void deal_swu_pk(ContractSWUPK c) {
        money = money + c.pk_price*c.pk_volume;
        capacity = capacity - c.pk_volume;         
        Agreement[] aa = Agreement.create_agreement(c);
        sales.get(c.year).add(aa[0]);
        stats.recalc_deals_stat(c.year, aa[0].product);
        stats.revenue[Time.iTime] = stats.revenue[Time.iTime] + c.pk_price*c.pk_volume;
        stats.loaded[Time.iTime] = stats.loaded[Time.iTime] + c.pk_volume;
    }
    void sell(Contract c) {
        capacity = capacity - c.volume;    
        money = money + c.price*c.volume;
        sales.get(c.year).add(Agreement.create_agreement(c));
        stats.recalc_deals_stat(c.year, c.product);
        stats.revenue[Time.iTime] = stats.revenue[Time.iTime] + c.price*c.volume;
        stats.loaded[Time.iTime] = stats.loaded[Time.iTime] + c.volume;
    }
    
    void buy(Contract c){
        this.money = this.money - c.price*c.volume;
        Agreement aa = Agreement.create_agreement(c);
        purchases.get(c.year).add(aa);
        sum_needs = sum_needs - c.volume;
        stats.recalc_buy_deals_stat(c.year);
        stats.write_detailed_vol_info(aa);
        stats.expenses[Time.iTime] = stats.expenses[Time.iTime] + c.price*c.volume;
    }
    
    void increase_capacity(Contract c){
        capacity = capacity + c.volume;
        all_capacity[Time.iTime] = capacity;
    } 
    
    @Override
    boolean is_acceptаble(Contract W) {
        double p = W.historic_prioritet.lastElement();
        if ((W.historic_prioritet.size()) > max_iter) {
            return true;
        }
        return super.is_acceptаble(p); //To change body of generated methods, choose Tools | Templates.
    }

    void increase_needs(double need) {
        sum_needs = sum_needs + need;
    }
}

class TraderStat extends Statistic{
    double[] pk_buy_volume;
    double[] pk_buy_price;
    
    
    public TraderStat(Actor act) {
        super(act);
        pk_buy_volume = new double[Time.years.length];
        pk_buy_price = new double[Time.years.length];
    }

    @Override
    void recalc_deals_stat(int year, short product) {

        ArrayList<Agreement> all_args = act.sales.get(year);

        double new_volume = 0;
        double new_revenue = 0;
        for (Agreement arg : all_args) {
            new_volume = new_volume + arg.volume;
            new_revenue = new_revenue + arg.volume*arg.price;
        }
        int f = DMath.Arithmetic.indexOf(Time.years, year);
        pk_price[f] = new_revenue/new_volume;
        pk_volume[f] = new_volume;
    }
    
    @Override
    void recalc_buy_deals_stat(int year) {
        ArrayList<Agreement> all_args = act.purchases.get(year);
        
        double new_volume = 0;
        double new_revenue = 0;
        for (Agreement arg : all_args) {
            new_volume = new_volume + arg.volume;
            new_revenue = new_revenue + arg.volume*arg.price;
        }
        int f = DMath.Arithmetic.indexOf(Time.years, year);
                pk_buy_price[f] = new_revenue/new_volume;
                pk_buy_volume[f] = new_volume;
    }

    @Override
    public LinkedHashMap<String, Object> assembleActorSet(){
        LinkedHashMap<String, Object> Eimport = new LinkedHashMap<>(); 
        Trader trader = (Trader)this.act;
        Eimport.put("year", Time.years);
        Eimport.put("Выручка", this.revenue);
        Eimport.put("Затраты", this.expenses);
        Eimport.put("Объем продаж ПК, т.", this.pk_volume);
        Eimport.put("Средняя цена продажи, &/кг", this.pk_price);
        Eimport.put("Объем закупок ПК, т.", this.pk_buy_volume);
        Eimport.put("Средняя цена покупки, &/кг", this.pk_buy_price);
        Eimport.put("Запасы на начало года, т.", trader.all_capacity);
        
        return Eimport;
    }
    @Override
    double get_pk_buy_price(int i){
        return pk_buy_price[i];
    }
    
    @Override
    double get_pk_buy_volume(int i){
        return pk_buy_volume[i];
    }
    
    @Override
    double get_pk_balance(double storage_cost, double start_capacity){
        double cum_volume = start_capacity;
        double cum_expenses = 0;
        double Lexpenses;
        for (int i = 0; i <= Time.iTime; i++) {
                cum_volume = cum_volume + pk_buy_volume[i] - pk_volume[i];
                if(i == 0)
                    Lexpenses = pk_buy_volume[i]*pk_buy_price[i] - pk_volume[i]*pk_price[i] + start_capacity*World.start_PK_price;
                else
                    Lexpenses = pk_buy_volume[i]*pk_buy_price[i] - pk_volume[i]*pk_price[i];
                Lexpenses = Lexpenses + cum_volume*storage_cost;
                Lexpenses = Lexpenses*1.025;
                cum_expenses = cum_expenses + Lexpenses;
        }
        double balance = cum_expenses/cum_volume;
        return balance;
    }
}