/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package smmum_alpha;

import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeCellRenderer;
import javax.swing.tree.DefaultTreeModel;

/**
 *
 * @author z
 */
public class TreeActor extends javax.swing.JTree{

    static final String FABRICATOR_LABEL = "Фабрикаторы";
    static final String OPERATOR_LABEL = "Операторы";
    static final String MINING_LABEL = "Поставщики природного урана";
    static final String ENRICH_LABEL = "Обогатительные предприятия";
    static final String MOX_LABEL = "Поставщики МОКСа";
    
    private DefaultMutableTreeNode root = new DefaultMutableTreeNode("Участники");
    
    public TreeActor(DemoModule dm1) {
        
        this.setCellRenderer(new DefaultTreeCellRenderer(){
            @Override
            public java.awt.Component getTreeCellRendererComponent(javax.swing.JTree pTree,
                    Object pValue, boolean pIsSelected, boolean pIsExpanded,
                    boolean pIsLeaf, int pRow, boolean pHasFocus) {
                    java.awt.Component component = super.getTreeCellRendererComponent(pTree,
                            pValue, pIsSelected, pIsExpanded, pIsLeaf, pRow, pHasFocus);
                    try {
//                        ((javax.swing.JLabel) component).setText( ((DefaultMutableTreeNode)pValue).get );
//                        ((javax.swing.JLabel) component).setFont(pTree.getFont());
                        DefaultMutableTreeNode node = (DefaultMutableTreeNode)pValue;
                        if (node.getUserObject() instanceof Actor){
                            ((javax.swing.JLabel) component).setText( ((Actor)(node.getUserObject())).getName() );
                            ((javax.swing.JLabel) component).setFont(pTree.getFont());
                        }
                        if (node.getUserObject() instanceof Reactor){
                            ((javax.swing.JLabel) component).setText(((Reactor)(node.getUserObject())).getName() );
                            ((javax.swing.JLabel) component).setFont(pTree.getFont());
                        }
                        if (node.getUserObject() instanceof Deposit){
                            ((javax.swing.JLabel) component).setText(((Deposit)(node.getUserObject())).getName() );
                            ((javax.swing.JLabel) component).setFont(pTree.getFont());
                        }
                    }
                    catch(java.lang.ClassCastException e){
                        ((javax.swing.JLabel) component).setText(String.valueOf(pValue));
                        ((javax.swing.JLabel) component).setFont(pTree.getFont());
                    }
                    
                    return component; 
                }   
        });
        
        createTree(dm1);
    }
    
    private void createTree(DemoModule dm1){
            
        
        DefaultTreeModel model = new DefaultTreeModel(this.root);
        this.setModel(model);
        
        DefaultMutableTreeNode fabricators = new DefaultMutableTreeNode(FABRICATOR_LABEL);     
        DefaultMutableTreeNode operators = new DefaultMutableTreeNode(OPERATOR_LABEL);
        DefaultMutableTreeNode minings = new DefaultMutableTreeNode(MINING_LABEL);
        DefaultMutableTreeNode enrichments = new DefaultMutableTreeNode(ENRICH_LABEL);
        DefaultMutableTreeNode mox_suppliers = new DefaultMutableTreeNode(MOX_LABEL);
        
        for (int i=0; i < dm1.AllActors.size(); i++){
//            if (dm1.AllActors.get(i) instanceof Fabricator){
//                mox_suppliers.add(new DefaultMutableTreeNode(dm1.AllActors.get(i)));
//            }        
            
            if (dm1.AllActors.get(i) instanceof Operator){

                DefaultMutableTreeNode child = new DefaultMutableTreeNode((Operator) dm1.AllActors.get(i));        // поддерево с реакторами этого оператора (корень - имя Оператора)
                ((Operator) dm1.AllActors.get(i)).reactors.forEach(reac -> {
                    child.add(new DefaultMutableTreeNode(reac));
                });
                operators.add(child);       // добавление Оператора к поддереву операторов

            }
            
            if (dm1.AllActors.get(i) instanceof Trader){
                DefaultMutableTreeNode child = new DefaultMutableTreeNode((Trader) dm1.AllActors.get(i));        // поддерево с месторожд. этого mining (корень - имя Mining)
                if (((Trader) dm1.AllActors.get(i)).getDeposits() != null){   
                    ((Trader) dm1.AllActors.get(i)).getDeposits().forEach(dep -> {
                        child.add(new DefaultMutableTreeNode(dep));
                    });
                }
                minings.add(child);       // добавление Mining к поддереву операторов
                continue;
            }
            
            if (dm1.AllActors.get(i) instanceof Mining){
                DefaultMutableTreeNode child = new DefaultMutableTreeNode((Mining) dm1.AllActors.get(i));        // поддерево с месторожд. этого mining (корень - имя Mining)
                ((Mining) dm1.AllActors.get(i)).getDeposits().forEach(dep -> {
                    child.add(new DefaultMutableTreeNode(dep));
                });
                minings.add(child);       // добавление Mining к поддереву операторов
            }
            
            if (dm1.AllActors.get(i) instanceof Enrichment){
                enrichments.add(new DefaultMutableTreeNode(dm1.AllActors.get(i)));
            }
            
            if (dm1.AllActors.get(i) instanceof MoxSupplier){
                mox_suppliers.add(new DefaultMutableTreeNode(dm1.AllActors.get(i)));
            }
            
        }
  
        model.insertNodeInto(fabricators, this.root, 0);
        model.insertNodeInto(operators, this.root, 1);
        model.insertNodeInto(minings, this.root, 2);
        model.insertNodeInto(enrichments, this.root, 3);
        model.insertNodeInto(mox_suppliers, this.root, 4);
//        
//        model.insertNodeInto(root2, this.root, 1);
        
        
        // чтобы при запуске в дереве не надо было раскрывать список классов участников(акторов)
        this.expandRow(0);
        
    }
    
    
    public DefaultMutableTreeNode getRoot(){
        return this.root;
    }
}
