/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package smmum_alpha;

import DMath.Arithmetic;
import java.io.IOException;
import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.function.Function;
import java.util.logging.Level;
import java.util.logging.Logger;
import org.apache.commons.math3.stat.descriptive.rank.Percentile;

/**
 *
 * @author Dmitry
 */
public class World {

    static TradeBulletin tbulletin;
    static double natural_enrichment = 0.0071;
    static double waste_enrichment = 0.0016;
    static double[] total_swu_demand;
    static double[] total_pk_demand;
    static double[] total_eup_demand;
    static double[] total_mox_demand;
    static double[] total_remix_demand;
    static double[] total_swu_supply;
    static double[] total_pk_supply;
    static double[] total_mox_supply;
    static double[] total_remix_supply;
    
    static double INFLATION_RATE = 0.00;
    static double start_EUP_price = 800;
    static double start_PK_price = 56;
    static double start_SWU_price = 40;
    static double start_MOX_price = 3000;
    static double start_Remix_price = 1500;
    
    static double[] spotEUPprice;
    static double[] spotPKprice;
    static double[] spotSWUprice;
    static double[] spotMOXprice;
    static double[] spotREMIXprice;
    
    /*
    QUESTION
    static String DB_path = "./"
    static String AGENT_FOLDER = "./"
    */
    
    static String SAVE_PATH = "./";
    
    static boolean LOGGING = false;
    
    static String EXCEL_WORLD_FILE = "example_world.xlsx";    // TODO: изменить?
    static String EXCEL_WORLD_FILE_PATH = "./" + EXCEL_WORLD_FILE; 
    static String EXCEL_OP_FILE = "example_operators.xlsx"; 
    static String EXCEL_OP_FILE_PATH =  "./" + EXCEL_OP_FILE; 
    static String EXCEL_FILE = "example_actors.xlsx";    // TODO: изменить?
    static String EXCEL_FILE_PATH = "./" + EXCEL_FILE; 
    static String EXCEL_ENRICHMENT_FILE = "example_enrichments.xlsx";    // TODO: изменить?
    static String EXCEL_ENRICHMENT_FILE_PATH = "./" + EXCEL_ENRICHMENT_FILE; 
    static String EXCEL_MININGS_FILE = "example_minings.xlsx"; 
    static String EXCEL_MININGS_FILE_PATH = "./" + EXCEL_MININGS_FILE; 
    static String EXCEL_COUNTRY_FILE = "example_countries.xlsx"; 
    static String EXCEL_COUNTRY_FILE_PATH =  "./" + EXCEL_COUNTRY_FILE;
    static boolean Switch_reac_deal_type = false;
    static boolean Switch_PBase = true;
    static boolean SWITCH_REMIX = false;
    static boolean SWITCH_REMIX_VVER = false;
    
    static int FIN_QUOTE = 0;  // 0 - алгоритм невыбран; 1 - алг.1, 2 - алг.2, 3 - алг.3
            
    static void set_tbulletin(TradeBulletin tb) {
       tbulletin = tb;
    }
    
    static TradeBulletin get_tbulletin(){
        return tbulletin;
    }
    
    /*
    static double get_mean_price(short Id_product){
        
        
        double mprice;
        try {
            mprice = calc_mean_prices(Id_product, Time.years[Time.iTime]);
            return mprice;
        } catch (NoPContractException ex) {
            if(Id_product == Contract.P_OUP){return start_EUP_price;}
            else
                if(Id_product == Contract.P_PK){return start_PK_price;}
                else
                   throw new Error(""); 
        } catch (NoYContractException ex) {
            if(Id_product == Contract.P_OUP){try {
                return calc_mean_prices(Id_product, Time.years[Time.iTime-1]);
                } catch (NoPContractException ex1) {
                    throw new Error("");
                } catch (NoYContractException ex1) {
                    throw new Error("");
                }
            }
            else
                if (Id_product == Contract.P_PK){
                try {
                    return calc_mean_prices(Id_product, Time.years[Time.iTime-1]);
                } catch (NoPContractException ex1) {
                    Logger.getLogger(World.class.getName()).log(Level.SEVERE, null, ex1);
                } catch (NoYContractException ex1) {
                    Logger.getLogger(World.class.getName()).log(Level.SEVERE, null, ex1);
                }
                }
            else
                throw new Error("");    
        } 
        return 0;
    }
      */ 
    static double[] calc_mean_prices(short Id_product){
        ArrayList<Contract> cons = ArchiveChain.getContracts(Id_product);
        int[] ii = Time.years;
        double[] mean_price = new double[ii.length];
        int m = 0;
        for (int i : ii) {
            ArrayList<Contract> year_con = new ArrayList();
            cons.stream().filter(c -> c.year == i).forEachOrdered((c) -> {
            year_con.add(c);}
            );
            
            double Value = 0;
            double Volume = 0;
            for (Contract contract : year_con) {
                Value = Value + contract.price*contract.volume;
                Volume = Volume +  contract.volume;
            }
            mean_price[m] = Value/Volume;
            if(Volume == 0)
                mean_price[m] = getSpot(Id_product, i);
            m++;
        }
        return mean_price;
    }
    
    static double[] calc_max_prices(short Id_product){
        ArrayList<Contract> cons = ArchiveChain.getContracts(Id_product);
        int[] ii = Time.years;
        double[] spot_price = new double[ii.length];
        int m = 0;
        for (int i : ii) {
            ArrayList<Contract> year_con = new ArrayList();
            cons.stream().filter(c -> c.year == i).forEachOrdered((c) -> {
            year_con.add(c);}
            );
            double[] prices = new double[year_con.size()];
            double Volume = 0;
            int nn = 0;
            for (Contract contract : year_con) {
                prices[nn] = contract.price;
                Volume = Volume +  contract.volume;
                nn++;
            }
            Percentile Pe = new Percentile();
            Pe.setData(prices);
            spot_price[m] = Pe.evaluate(95);
            if(Volume == 0)
                spot_price[m] = getSpot(Id_product, i);
            m++;
        }
        return spot_price;
    }
    
    static double[] calc_mean_swu_prices(){
        short Id_product = Contract.P_SWU;
        ArrayList<Contract> cons = ArchiveChain.getContracts(Id_product);
        int[] ii = Time.years;
        double[] mean_price = new double[ii.length];
        int m = 0;
        for (int i : ii) {
            try {
                mean_price[m] = calc_mean_swu_prices(i);
            } catch (NoPContractException ex) {
                Logger.getLogger(World.class.getName()).log(Level.SEVERE, null, ex);
            } catch (NoYContractException ex) {
                Logger.getLogger(World.class.getName()).log(Level.SEVERE, null, ex);
            }
            m++;
        }
        return mean_price;
    }
    
    static double[] calc_max_swu_prices(){
        short Id_product = Contract.P_SWU;
        ArrayList<Contract> cons = ArchiveChain.getContracts(Id_product);
        int[] ii = Time.years;
        double[] spot_price = new double[ii.length];
        int m = 0;
        for (int i : ii) {
            ArrayList<Contract> year_con = new ArrayList();
            cons.stream().filter(c -> c.year == i && c.type != Contract.REMIX).forEachOrdered((c) -> {
            year_con.add(c);}
            );
            double Volume = 0;
            double[] prices = new double[year_con.size()];
            int nn = 0;
            for (Contract contract : year_con) {
                prices[nn] = contract.price;
                Volume = Volume +  contract.volume;
                nn++;
            }
            Percentile Pe = new Percentile();
            Pe.setData(prices);
            spot_price[m] = Pe.evaluate(95);
            if(Volume == 0)
                spot_price[m] = getSpot(Id_product, i);
            m++;
        }
        return spot_price;
    }
    
    
    static double calc_mean_prices(short Id_product, int i) throws NoPContractException, NoYContractException{
        ArrayList<Contract> cons = ArchiveChain.getContracts(Id_product);
        if(cons.isEmpty()){throw new NoPContractException("NO product " + Id_product + " contracts");}
        double mean_price;

            ArrayList<Contract> year_con = new ArrayList();
            cons.stream().filter(c -> c.year == i).forEachOrdered((c) -> {
            year_con.add(c);}
            );
            if(year_con.isEmpty()){ throw new NoYContractException("NO " + i + " contracts");}
            double Value = 0;
            double Volume = 0;
            for (Contract contract : year_con) {
                Value = Value + contract.price*contract.volume;
                Volume = Volume +  contract.volume;
            }
            mean_price = Value/Volume;
            if(Volume == 0)
                return getSpot(Id_product, i);

        return mean_price;
    }  
    
    static double calc_max_prices(short Id_product, int i) throws NoPContractException, NoYContractException{
        ArrayList<Contract> cons = ArchiveChain.getContracts(Id_product);
        if(cons.isEmpty()){throw new NoPContractException("NO product " + Id_product + " contracts");}
        double spot_price;

            ArrayList<Contract> year_con = new ArrayList();
            cons.stream().filter(c -> c.year == i).forEachOrdered((c) -> {
            year_con.add(c);}
            );
            if(year_con.isEmpty()){ throw new NoYContractException("NO " + i + " contracts");}
            double Volume = 0;
            double[] prices = new double[year_con.size()];
            int nn = 0;
            for (Contract contract : year_con) {
                prices[nn] = contract.price;
                Volume = Volume +  contract.volume;
                nn++;
            }
            Percentile Pe = new Percentile();
            Pe.setData(prices);
            spot_price = Pe.evaluate(95);
            if(Volume == 0)
                return getSpot(Id_product, i);

        return spot_price;
    }  
    
    static double calc_max_swu_prices(int i) throws NoPContractException, NoYContractException{
        short Id_product = Contract.P_SWU;
        ArrayList<Contract> cons = ArchiveChain.getContracts(Id_product);
        if(cons.isEmpty()){throw new NoPContractException("NO product " + Id_product + " contracts");}
        double spot_price;

            ArrayList<Contract> year_con = new ArrayList();
            cons.stream().filter(c -> c.year == i && c.type != Contract.REMIX).forEachOrdered((c) -> {
            year_con.add(c);}
            );
            if(year_con.isEmpty()){ throw new NoYContractException("NO " + i + " contracts");}
            double Volume = 0;
            double[] prices = new double[year_con.size()];
            int nn = 0;
            for (Contract contract : year_con) {
                prices[nn] = contract.price;
                Volume = Volume +  contract.volume;
                nn++;
            }
            Percentile Pe = new Percentile();
            Pe.setData(prices);
            spot_price = Pe.evaluate(95);
            if(Volume == 0)
                return getSpot(Id_product, i);

        return spot_price;
    }
    
    static double calc_mean_swu_prices(int i) throws NoPContractException, NoYContractException{
        short Id_product = Contract.P_SWU;
        ArrayList<Contract> cons = ArchiveChain.getContracts(Id_product);
        if(cons.isEmpty()){
            short Id_product2 = Contract.P_OUP;
            ArrayList<Contract> cons2 = ArchiveChain.getContracts(Id_product2);
            if(cons2.isEmpty())
                {throw new NoPContractException("NO product " + Id_product + " contracts");}
            else
            {
                double mean_price;
                ArrayList<Contract> year_con = new ArrayList();
                cons2.stream().filter(c -> c.year == i && c.type != Contract.REMIX).forEachOrdered((c) -> {
                year_con.add(c);}
                );
                if(year_con.isEmpty()){ throw new NoYContractException("NO " + i + " contracts");}
                double Value = 0;
                double Volume = 0;
                for (Contract contract : year_con) {
                    Value = Value + contract.en_volume*contract.swu_price;
                    if(Double.isNaN(Value)){
                        System.err.println("Value is NaN");
                    }
                    Volume = Volume +  contract.en_volume;
                }
                mean_price = Value/Volume;
                if(Volume == 0)
                    return getSpot(Id_product, i);
                return mean_price;
            }
        } 
        else{
            double mean_price;

                ArrayList<Contract> year_con = new ArrayList();
                cons.stream().filter(c -> c.year == i && c.type != Contract.REMIX).forEachOrdered((c) -> {
                year_con.add(c);}
                );
                if(year_con.isEmpty()){ throw new NoYContractException("NO " + i + " contracts");}
                double Value = 0;
                double Volume = 0;
                for (Contract contract : year_con) {
                    Value = Value + contract.price*contract.volume;
                    Volume = Volume +  contract.volume;
                }
                mean_price = Value/Volume;
                if(Volume == 0)
                    return getSpot(Id_product, i);

            return mean_price;
            }
    }
    
    
    static double getSpot(short Id_product, int i){
        int y = DMath.Arithmetic.indexOf(Time.years, i);
        switch (Id_product){
            case Contract.P_MOX: return spotMOXprice[y];
            case Contract.P_OUP: return spotEUPprice[y];
            case Contract.P_PK: return spotPKprice[y];
            case Contract.P_SWU: return spotSWUprice[y];
            default: return Double.NaN;
        }
    }
    
    
    static void calc_total_supply_demand(ArrayList<Actor> AllActors) {
        ArrayList<Operator> operators = new ArrayList();
        ArrayList<Enrichment> enrichments = new ArrayList();
        ArrayList<Mining> minings = new ArrayList();
        ArrayList<MoxSupplier> mox_suppliers = new ArrayList();
        for (Actor actor : AllActors) {
            //System.out.println( actor.getClass().toString());
            if (actor instanceof Operator){
                operators.add((Operator) actor);
            }
            if (actor instanceof Enrichment){
                enrichments.add((Enrichment) actor);
            }
            if (actor instanceof Mining){
                minings.add((Mining) actor);
            }
            if (actor instanceof MoxSupplier){
                mox_suppliers.add((MoxSupplier) actor);
            }
        }
        total_swu_demand = new double[Time.years.length];
        total_pk_demand = new double[Time.years.length];
        total_swu_supply = new double[Time.years.length];
        total_pk_supply = new double[Time.years.length];
        total_eup_demand = new double[Time.years.length];
        total_mox_demand = new double[Time.years.length];
        total_mox_supply = new double[Time.years.length];
        total_remix_demand = new double[Time.years.length];
        total_remix_supply = new double[Time.years.length];
        double[] total_pk_reserves = new double[Time.years.length];
        int y = 0;
        for(int year : Time.years) {
            for (Operator operator : operators) {
                double op_swu_need = 0; double op_eup_need = 0; double op_pk_need = 0;
                for(Reactor reactor : operator.reactors){
                    if (reactor.type == Contract.EUP || reactor.type == Contract.SWU_PK || reactor.type == Contract.EUP){
                        total_eup_demand[y] = total_eup_demand[y] + reactor.needs[y];
                        total_swu_demand[y] = total_swu_demand[y] + Enrichment.calc_swu(reactor.needs[y], reactor.enrichment);
                        total_pk_demand[y] = total_pk_demand[y] + Enrichment.calc_pk_volume(reactor.needs[y], reactor.enrichment);
                        total_mox_demand[y] = total_mox_demand[y]+0;
                        op_eup_need = op_eup_need + reactor.needs[y];
                        op_swu_need = op_swu_need + Enrichment.calc_swu(reactor.needs[y], reactor.enrichment);
                        op_pk_need = op_pk_need + Enrichment.calc_pk_volume(reactor.needs[y], reactor.enrichment);
                    }
                    else if (reactor.type == Contract.PK_Solo){
                        total_pk_demand[y] = total_pk_demand[y] + reactor.needs[y];
                        op_pk_need = op_eup_need + reactor.needs[y];
                    }
                    else if (reactor.type == Contract.PWR_MOX){
                        total_eup_demand[y] = total_eup_demand[y] + reactor.needs[y]/3*2;
                        total_swu_demand[y] = total_swu_demand[y] + Enrichment.calc_swu(reactor.needs[y]/3*2, reactor.enrichment);
                        total_pk_demand[y] = total_pk_demand[y] + Enrichment.calc_pk_volume(reactor.needs[y]/3*2, reactor.enrichment);
                        total_mox_demand[y] = total_mox_demand[y] + Reactor.recalc_mox(reactor.needs[y]/3);
                        op_eup_need = op_eup_need + reactor.needs[y]/3*2;
                        op_swu_need = op_swu_need + Enrichment.calc_swu(reactor.needs[y]/3*2, reactor.enrichment);
                        op_pk_need = op_pk_need + Enrichment.calc_pk_volume(reactor.needs[y]/3*2, reactor.enrichment);
                    }else if (reactor.type == Contract.MOX){
                        total_eup_demand[y] = total_eup_demand[y] + 0;
                        total_swu_demand[y] = total_swu_demand[y] + 0;
                        total_pk_demand[y] = total_pk_demand[y] + 0;
                        total_mox_demand[y] = total_mox_demand[y] + Reactor.recalc_mox(reactor.needs[y]);
                        op_eup_need = op_eup_need + 0;
                        op_swu_need = op_swu_need + 0;
                        op_pk_need = op_pk_need + 0;
                    }
                    else if (reactor.type == Contract.REMIX){
                        total_eup_demand[y] = total_eup_demand[y] + 0;
                        total_swu_demand[y] = total_swu_demand[y] + 0;
                        total_pk_demand[y] = total_pk_demand[y] + 0;
                        total_mox_demand[y] = total_mox_demand[y] + 0;
                        total_remix_demand[y] = total_remix_demand[y] + Reactor.recalc_remix(reactor.needs[y], reactor);
                        op_eup_need = op_eup_need + 0;
                        op_swu_need = op_swu_need + 0;
                        op_pk_need = op_pk_need + 0;    
                    }
                }
                operator.stats.swu_needs[y] = op_swu_need;
                operator.stats.eup_needs[y] = op_eup_need;
                operator.stats.pk_needs[y] = op_pk_need;
            }
            
            for (Mining mining : minings) {
                total_pk_reserves[y] = total_pk_reserves[y] + mining.calc_reserves();
            }
            if (y>0){total_pk_reserves[y] = total_pk_reserves[y-1] - total_pk_demand[y-1];}
            for (Enrichment enrichment : enrichments) {
                total_swu_supply[y] = total_swu_supply[y] + enrichment.all_capacity[y];
            }
            for (MoxSupplier mox_supplier : mox_suppliers) {
                total_mox_supply[y] = total_mox_supply[y] + mox_supplier.all_capacity[y];
            }
            y++;
        }
        minings.forEach((mining) -> {
            total_pk_supply[0] = total_pk_supply[0]+ mining.capacity;
        });
        for (int i = 1; i < Time.years.length; i++) {
            total_pk_supply[i] = total_pk_reserves[i]*minings.get(0).production_rate;
        }
    }
    
    static void update_demand(){
        int y = Time.iTime + 1;
        if (y >= Time.lastTime)
            return;
        ArrayList<Operator> operators = tbulletin.my_operators;
        total_eup_demand[y] = 0;
        total_swu_demand[y] = 0;
        total_pk_demand[y] = 0;
        total_mox_demand[y] = 0;
        for (Operator operator : operators) {
                double op_swu_need = 0; double op_eup_need = 0; double op_pk_need = 0;
                for(Reactor reactor : operator.reactors){
                    if (reactor.type == Contract.EUP || reactor.type == Contract.SWU_PK){
                        total_eup_demand[y] = total_eup_demand[y] + reactor.needs[y];
                        total_swu_demand[y] = total_swu_demand[y] + Enrichment.calc_swu(reactor.needs[y], reactor.enrichment);
                        total_pk_demand[y] = total_pk_demand[y] + Enrichment.calc_pk_volume(reactor.needs[y], reactor.enrichment);
                        total_mox_demand[y] = total_mox_demand[y]+0;
                        op_eup_need = op_eup_need + reactor.needs[y];
                        op_swu_need = op_swu_need + Enrichment.calc_swu(reactor.needs[y], reactor.enrichment);
                        op_pk_need = op_pk_need + Enrichment.calc_pk_volume(reactor.needs[y], reactor.enrichment);
                    }
                    else if (reactor.type == Contract.PK_Solo){
                        total_pk_demand[y] = total_pk_demand[y] + reactor.needs[y];
                        op_pk_need = op_eup_need + reactor.needs[y];
                    }
                    else if (reactor.type == Contract.PWR_MOX){
                        total_eup_demand[y] = total_eup_demand[y] + reactor.needs[y]/3*2;
                        total_swu_demand[y] = total_swu_demand[y] + Enrichment.calc_swu(reactor.needs[y]/3*2, reactor.enrichment);
                        total_pk_demand[y] = total_pk_demand[y] + Enrichment.calc_pk_volume(reactor.needs[y]/3*2, reactor.enrichment);
                        total_mox_demand[y] = total_mox_demand[y] + Reactor.recalc_mox(reactor.needs[y]/3);
                        op_eup_need = op_eup_need + reactor.needs[y]/3*2;
                        op_swu_need = op_swu_need + Enrichment.calc_swu(reactor.needs[y]/3*2, reactor.enrichment);
                        op_pk_need = op_pk_need + Enrichment.calc_pk_volume(reactor.needs[y]/3*2, reactor.enrichment);
                    }else if (reactor.type == Contract.MOX){
                        total_eup_demand[y] = total_eup_demand[y] + 0;
                        total_swu_demand[y] = total_swu_demand[y] + 0;
                        total_pk_demand[y] = total_pk_demand[y] + 0;
                        total_mox_demand[y] = total_mox_demand[y] + Reactor.recalc_mox(reactor.needs[y]);
                        op_eup_need = op_eup_need + 0;
                        op_swu_need = op_swu_need + 0;
                        op_pk_need = op_pk_need + 0;
                    }
                    else if (reactor.type == Contract.REMIX){
                        total_eup_demand[y] = total_eup_demand[y] + 0;
                        total_swu_demand[y] = total_swu_demand[y] + 0;
                        total_pk_demand[y] = total_pk_demand[y] + 0;
                        total_mox_demand[y] = total_mox_demand[y] + 0;
                        total_remix_demand[y] = total_remix_demand[y] + Reactor.recalc_remix(reactor.needs[y], reactor);
                        op_eup_need = op_eup_need + 0;
                        op_swu_need = op_swu_need + 0;
                        op_pk_need = op_pk_need + 0;    
                    }
                }
                operator.stats.swu_needs[y] = op_swu_need;
                operator.stats.eup_needs[y] = op_eup_need;
                operator.stats.pk_needs[y] = op_pk_need;
            }
        
    }   
    
    static void update_total_pk_supply(){
        if (Time.iTime < Time.lastTime-1)
        {
            ArrayList<Mining> minings = tbulletin.my_minings;
            int y = Time.iTime+1;
            total_pk_supply[y] = 0;
            for (Mining mining : minings) {
                total_pk_supply[y] = total_pk_supply[y] + mining.capacity;
            }
            Object[] tr = minings.stream().filter(m -> m.getClass().equals(Trader.class)).toArray();
            Trader trader = (Trader) tr[0];
            tr = null;
            if ((total_pk_supply[y] - trader.capacity)< total_pk_demand[y]*(1 + 0.05 + trader.purchase_rate)){
                ArrayList<Mining> minings_for_upgrade = (ArrayList<Mining>) minings.clone();
                minings_for_upgrade.removeIf(M ->(M.getClass().equals(Trader.class) || M.getClass().equals(PKDump.class)) );
                minings_for_upgrade.forEach(m -> m.upgrade());
            }
        }
    }
    static void setStartSpot() {
        World.spotEUPprice = new double[Time.years.length+1];
        World.spotEUPprice[0] = World.start_EUP_price;
        
        World.spotMOXprice = new double[Time.years.length+1];
        World.spotMOXprice[0] = World.start_MOX_price;
        
        World.spotPKprice = new double[Time.years.length+1];
        World.spotPKprice[0] = World.start_PK_price;
        
        World.spotSWUprice = new double[Time.years.length+1];
        World.spotSWUprice[0] = World.start_SWU_price;
        
        World.spotREMIXprice = new double[Time.years.length+1];
        World.spotREMIXprice[0] = World.start_Remix_price;
    }
    
    static void setSpot(){
        // ОУП
        try {
            double new_spot_price = World.calc_mean_prices(Contract.P_OUP, Time.yTime);
            World.spotEUPprice[Time.iTime+1] = new_spot_price;
        } catch (NoPContractException | NoYContractException ex) {
            System.err.println(ex.getMessage());
        }
        // PK
        try {
            double new_spot_price = World.calc_mean_prices(Contract.P_PK, Time.yTime);
            World.spotPKprice[Time.iTime+1] = new_spot_price;
        } catch (NoPContractException | NoYContractException ex) {
            System.err.println(ex.getMessage());
        }
        // SWU
        try {
            double new_spot_price = World.calc_mean_swu_prices(Time.yTime);
            World.spotSWUprice[Time.iTime+1] = new_spot_price;
        } catch (NoPContractException | NoYContractException ex) {
            System.err.println(ex.getMessage());
        }
        
        
        
        // MOX
        try {
            double new_spot_price = World.calc_mean_prices(Contract.P_MOX, Time.yTime);
            World.spotMOXprice[Time.iTime+1] = new_spot_price;
        } catch (NoPContractException | NoYContractException ex) {
            System.err.println(ex.getMessage());
        }
        // REMIX
        try {
            double new_spot_price = World.calc_mean_prices(Contract.P_REMIX, Time.yTime);
            World.spotREMIXprice[Time.iTime+1] = new_spot_price;
        } catch (NoPContractException | NoYContractException ex) {
            System.err.println(ex.getMessage());
            World.spotREMIXprice[Time.iTime+1] = World.tbulletin.remix_supplier.calc_spot_price();
        }
    }
    
    
    static void calc_reactor_stats(){
        int y = 0;
        int RC = 0;
        ArrayList<Operator> operators = World.tbulletin.my_operators;
        for(int year : Time.years) {
            for (Operator op : operators) {
                ArrayList<Reactor> reacs = op.get_reactors();
                ArrayList<Reactor> Areacs = new ArrayList();
                for (Reactor reac : reacs) {
                    if (reac.status[y] == 1){
                        Areacs.add(reac);
                    }
                }
                if (Areacs.isEmpty())continue;
                op.stats.reactors[y] = Areacs.size();
                double termal_capcity = 0;
                double electric_capcity = 0;
                double electrcity = 0;
                for (Reactor Areac : Areacs) {
                    termal_capcity = termal_capcity + Areac.termal_capacity;
                    electric_capcity = electric_capcity + Areac.electrical_capacity;
                    electrcity = electrcity + Areac.calc_energy();
                }
                op.stats.termal_capcity[y] = termal_capcity;
                op.stats.electric_capcity[y] = electric_capcity;
                op.stats.electrcity[y] = electrcity;
            }
            y++;
        }
        
    }
    
    static int calc_current_reactor(ArrayList<Operator> ops){
        int RC = 0;
        for (Operator op : ops) {
            RC = op.reactors.stream().filter((reactor) -> (reactor.status[0] == 1)).map((_item) -> 1).reduce(RC, Integer::sum);
        }
        return RC;
    }
    
    static int calc_all_reactor(ArrayList<Operator> ops){
        int RC = 0;
        for (Operator op : ops) {
            for (Reactor reactor : op.reactors) {
                    RC++;
            }
        }
        return RC;
    }

    static void setStart() {
        setStartSpot();
        setTail();
        calc_reactor_stats();
    }

    private static void setTail() {
        ArrayList<Enrichment> E = tbulletin.my_enrichments;
        double tails  = 0;
        double capacity = 0;
        for (Enrichment enrichment : E) {
            tails = tails + enrichment.tail*enrichment.capacity;
            capacity = capacity + enrichment.capacity;
        }
        World.waste_enrichment = tails/capacity;
    }

    static void setTurn() {
        //setSpot();
        setTail();
        World_statisitic.turn();
        Update_demand_supply();
        
    }
    static void Update_demand_supply(){
        update_total_pk_supply();
        update_demand();
    }
    static void final_stat(ArrayList<Actor>  AllActors) {
        update_total_pk_supply();
        try {
            World_statisitic.write_report_var2();
            World_statisitic.write_region();
            World_statisitic.write_world();
            World_statisitic.write_operator();
            World_statisitic.write_actor(AllActors);
            World_statisitic.write_enrichments();
            World_statisitic.write_minings();
            World_statisitic.write_detail_eup();
            World_statisitic.write_detail_swu();
        } catch (IOException ex) {
            Logger.getLogger(World.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    static LinkedHashMap createInfo() {
        LinkedHashMap<String, Object> Eimport = new LinkedHashMap<>();
        
        Eimport.put("year", Time.years);
        Eimport.put("Совокупный спрос на ОУП, т.", total_eup_demand);
        Eimport.put("Совокупный спрос на ПК, т.", total_pk_demand);
        Eimport.put("Совокупное предложение ПК, т.", total_pk_supply);
        Eimport.put("Совокупный спрос на РР, тыс. ЕРР", total_swu_demand);
        Eimport.put("Совокупный предложение РР, тыс. ЕРР", total_swu_supply);
        Eimport.put("Совокупный спрос на МОКС, т.", total_mox_demand);
        Eimport.put("Совокупный спрос на РЕМИКС, т.", total_remix_demand);
        Eimport.put("Средняя цена MOX, $/кг", World.calc_mean_prices(Contract.P_MOX));
        Eimport.put("Средняя цена РР, $/ЕРР", World.calc_mean_swu_prices());
        Eimport.put("Средняя цена ПК, $/кг", World.calc_mean_prices(Contract.P_PK));
        Eimport.put("Средняя цена ОУП, $/кг", World.calc_mean_prices(Contract.P_OUP));
        Eimport.put("Средняя цена РЕМИКС, $/кг", World.calc_mean_prices(Contract.P_REMIX));
        Eimport.put("Котировка MOX, $/кг", World.calc_max_prices(Contract.P_MOX));
        Eimport.put("Котировка РР, $/ЕРР", World.calc_max_swu_prices());
        Eimport.put("Котировка ПК, $/кг", World.calc_max_prices(Contract.P_PK));
        Eimport.put("Котировка ОУП, $/кг", World.calc_max_prices(Contract.P_OUP));
        Eimport.put("Котировка РЕМИКС, $/кг", World.calc_max_prices(Contract.P_REMIX));
        
        return Eimport;
        
    }
}

class NoYContractException extends Exception{ 
    public NoYContractException(Throwable e) { 
        initCause(e); 
    } 

    public NoYContractException(String message) {
        super(message);
    }
    
} 

class NoPContractException extends Exception{ 
    public NoPContractException(Throwable e) { 
        initCause(e); 
    } 

    public NoPContractException(String message) {
        super(message);
    }
}

class World_statisitic {

    static void turn(){
        ArrayList<Region> regions = World.tbulletin.my_regions;
        
        for (Region region : regions) {
            ArrayList<Country> cons = region.countries;
            for (Country con : cons) {
                con.write_turn_stat();
            }
        }
        
    }
    
    
    static void write_region() throws IOException{
        ArrayList<Region> regions = World.tbulletin.my_regions;
        for (Region region : regions) {
            Function<Region, LinkedHashMap> func = (reg)-> reg.assembleSet();
                ExcelLoader<Region> el = new ExcelLoader<>(World.EXCEL_WORLD_FILE_PATH);
                Object participant = region;
                el.writeIntoExcel((Region) participant, func, "Регион  "+region.getName());
            for (Country country : region.getCountries()){
                Function<Country, LinkedHashMap> funcC = (cou)-> cou.assembleSet();
                ExcelLoader<Country> elC = new ExcelLoader<>(World.EXCEL_COUNTRY_FILE_PATH);
                Object participantC = country;
                elC.writeIntoExcel((Country) participantC, funcC, "Регион  "+country.getName());
            
            }
        }
        
    }
    
    static void write_world() throws IOException{
         ExcelLoader<Region> el = new ExcelLoader<>(World.EXCEL_WORLD_FILE_PATH);
         LinkedHashMap info = World.createInfo();
         el.writeIntoExcel(info, "Мир");
    }
    
    static void write_operator() throws IOException{
        ArrayList<Region> regions = World.tbulletin.my_regions;
        ArrayList<Operator> operators = World.tbulletin.my_operators;
        LinkedHashMap eup_price_info = new LinkedHashMap();
        LinkedHashMap eup_volume_info = new LinkedHashMap();
        LinkedHashMap swu_price_info = new LinkedHashMap();
        LinkedHashMap swu_volume_info = new LinkedHashMap();
        LinkedHashMap capacity_info = new LinkedHashMap();
        LinkedHashMap reactor_info = new LinkedHashMap();
        LinkedHashMap electricity_info = new LinkedHashMap();
        eup_price_info.put("Years", Time.years);
        eup_volume_info.put("Years", Time.years);
        swu_price_info.put("Years", Time.years);
        swu_volume_info.put("Years", Time.years);
        capacity_info.put("Years", Time.years);
        reactor_info.put("Years", Time.years);
        electricity_info.put("Years", Time.years);
        for (Region region : regions) {
            Object[] opos = operators.stream().filter(a -> a.getRegion().equals(region)).toArray();
            ArrayList<Operator> ops = new ArrayList();
            for (Object opo : opos) {
                ops.add((Operator) opo);
            }
            opos = null;
            LinkedHashMap info = Statistic.agregateOperator(ops);
            LinkedHashMap detail_eup_info = Statistic.agregateOperatorDetailInfo(ops,Contract.P_OUP);
            LinkedHashMap detail_swu_info = Statistic.agregateOperatorDetailInfo(ops,Contract.P_SWU);
            eup_price_info.put(region.getName(), info.get("eup_price"));
            eup_volume_info.put(region.getName(), info.get("eup_volume"));
            swu_price_info.put(region.getName(), info.get("swu_price"));
            swu_volume_info.put(region.getName(), info.get("swu_volume"));
            capacity_info.put(region.getName(), info.get("electric_capcity"));
            reactor_info.put(region.getName(), info.get("reactors"));
            electricity_info.put(region.getName(), info.get("electrcity"));
            
            
             ExcelLoader<Region> el = new ExcelLoader<>(World.EXCEL_OP_FILE_PATH);
             el.writeIntoExcel(info, "Регион  "+ region.getName());
             el.writeIntoExcel(detail_eup_info, "Поставки ОУП Детально "+ region.getName());
             el.writeIntoExcel(detail_swu_info, "Поставки РР Детально "+ region.getName());
        }
            ExcelLoader<Region> el = new ExcelLoader<>(World.EXCEL_OP_FILE_PATH);
            el.writeIntoExcel(eup_price_info, "ОУП цена");
            el.writeIntoExcel(eup_volume_info, "ОУП объем");
            el.writeIntoExcel(swu_price_info, "ЕРР цена");
            el.writeIntoExcel(swu_volume_info, "ЕРР объем");
            el.writeIntoExcel(reactor_info, "Реакторы");
            el.writeIntoExcel(capacity_info, "Установленная мощность, МВт");
            el.writeIntoExcel(electricity_info, "Генерация Электроэнергии, МВтч");
    }
    
    static void write_enrichments() throws IOException{
        ArrayList<Enrichment> enrichments = World.tbulletin.my_enrichments;
        LinkedHashMap<String, Object> capacity = new LinkedHashMap<>();
        LinkedHashMap<String, Object> deplited = new LinkedHashMap<>();
        LinkedHashMap<String, Object> revenue = new LinkedHashMap<>();
        LinkedHashMap<String, Object> expenses = new LinkedHashMap<>();
        LinkedHashMap<String, Object> pk_price = new LinkedHashMap<>();
        LinkedHashMap<String, Object> pk_volume = new LinkedHashMap<>();
        LinkedHashMap<String, Object> eup_price = new LinkedHashMap<>();
        LinkedHashMap<String, Object> eup_volume = new LinkedHashMap<>();
        LinkedHashMap<String, Object> swu_price = new LinkedHashMap<>();
        LinkedHashMap<String, Object> swu_volume = new LinkedHashMap<>();
        LinkedHashMap<String, Object> loaded = new LinkedHashMap<>();
        LinkedHashMap<String, Object> opt_tails = new LinkedHashMap<>();
        LinkedHashMap<String, Object> prod_tails = new LinkedHashMap<>();
        LinkedHashMap<String, Object> hipp_capacities = new LinkedHashMap<>();
        LinkedHashMap<String, Object> F_needs = new LinkedHashMap<>();
        LinkedHashMap<String, Object> storages = new LinkedHashMap<>();
        LinkedHashMap<String, Object> F_Givens = new LinkedHashMap<>();
        capacity.put("Года", Time.years);
        deplited.put("Года", Time.years);
        revenue.put("Года", Time.years);
        expenses.put("Года", Time.years);
        pk_price.put("Года", Time.years);
        pk_volume.put("Года", Time.years);
        eup_price.put("Года", Time.years);
        eup_volume.put("Года", Time.years);
        swu_price.put("Года", Time.years);
        swu_volume.put("Года", Time.years);
        loaded.put("Года", Time.years);
        opt_tails.put("Года", Time.years);
        prod_tails.put("Года", Time.years);
        hipp_capacities.put("Года", Time.years);
        F_needs.put("Года", Time.years);
        storages.put("Года", Time.years);
        F_Givens.put("Года", Time.years);
        for (Enrichment enrichment : enrichments) {
            capacity.put(enrichment.getName(), enrichment.all_capacity);
            deplited.put(enrichment.getName(), enrichment.stats.deplited);
            revenue.put(enrichment.getName(), enrichment.stats.revenue);
            expenses.put(enrichment.getName(), enrichment.stats.expenses);
            pk_price.put(enrichment.getName(), enrichment.stats.pk_price);
            pk_volume.put(enrichment.getName(), enrichment.stats.pk_volume);
            eup_price.put(enrichment.getName(), enrichment.stats.eup_price);
            eup_volume.put(enrichment.getName(), enrichment.stats.eup_volume);
            swu_price.put(enrichment.getName(), enrichment.stats.swu_price);
            swu_volume.put(enrichment.getName(), enrichment.stats.swu_volume);
            loaded.put(enrichment.getName(), enrichment.stats.loaded);
            opt_tails.put(enrichment.getName(), enrichment.opt_tails);
            prod_tails.put(enrichment.getName(), enrichment.prod_tails);
            hipp_capacities.put(enrichment.getName(), enrichment.hipp_capacities);
            F_needs.put(enrichment.getName(), enrichment.F_needs);
            storages.put(enrichment.getName(), enrichment.storages);
            F_Givens.put(enrichment.getName(), enrichment.F_Givens);
        }
        ExcelLoader<Operator> el = new ExcelLoader<>(World.EXCEL_ENRICHMENT_FILE_PATH);
        el.writeIntoExcel(capacity, "Производственные мощности");
        el.writeIntoExcel(deplited, "Отвал");
        el.writeIntoExcel(revenue, "Выручка");
        el.writeIntoExcel(expenses, "Затраты");
        el.writeIntoExcel(pk_price, "Цена ПК");
        el.writeIntoExcel(pk_volume, "Объем ПК");
        el.writeIntoExcel(eup_price, "Цена ОУП");
        el.writeIntoExcel(eup_volume, "Объем ОУП");
        el.writeIntoExcel(swu_price, "Цена ЕРР");
        el.writeIntoExcel(swu_volume, "Объем ЕРР");
        el.writeIntoExcel(loaded, "Загрузка");
        el.writeIntoExcel(opt_tails, "Оптимальные хвосты");
        el.writeIntoExcel(prod_tails, "Производственные хвосты");
        el.writeIntoExcel(hipp_capacities, "Гипотетический предел");
        el.writeIntoExcel(F_needs, "Требуемый объем ресурса");
        el.writeIntoExcel(storages, "Сохраненный запас");
        el.writeIntoExcel(F_Givens, "Давальческое сырье");
    }
    
    static void write_minings() throws IOException{
        ArrayList<Mining> minings = World.tbulletin.my_minings;
        LinkedHashMap<String, Object> revenue = new LinkedHashMap<>();
        LinkedHashMap<String, Object> expenses = new LinkedHashMap<>();
        LinkedHashMap<String, Object> pk_price = new LinkedHashMap<>();
        LinkedHashMap<String, Object> pk_volume = new LinkedHashMap<>();
        LinkedHashMap<String, Object> cost = new LinkedHashMap<>();
        LinkedHashMap<String, Object> capacity = new LinkedHashMap<>();
        LinkedHashMap<String, Object> reserves = new LinkedHashMap<>();

        revenue.put("Года", Time.years);
        expenses.put("Года", Time.years);
        pk_price.put("Года", Time.years);
        pk_volume.put("Года", Time.years);
        cost.put("Года", Time.years);
        capacity.put("Года", Time.years);
        reserves.put("Года", Time.years);
        
        for (Mining mining : minings) {
            revenue.put(mining.getName(), mining.stats.revenue);
            expenses.put(mining.getName(), mining.stats.expenses);
            pk_price.put(mining.getName(), mining.stats.pk_price);
            pk_volume.put(mining.getName(), mining.stats.pk_volume);
            cost.put(mining.getName(), mining.all_cost);
            capacity.put(mining.getName(), mining.all_capacity);
            reserves.put(mining.getName(), mining.all_reserves);
        }
        ExcelLoader<Operator> el = new ExcelLoader<>(World.EXCEL_MININGS_FILE_PATH);
        el.writeIntoExcel(revenue, "Совокупная Выручка, $");
        el.writeIntoExcel(expenses, "Совокупные Затраты, $");
        el.writeIntoExcel(pk_price, "Средняя Цена продажи ПК, $ за кг");
        el.writeIntoExcel(pk_volume, "Объем продаж ПК, т.");
        el.writeIntoExcel(cost, "Себестоимость на конец года, $ за кг");
        el.writeIntoExcel(capacity, "Предложение, т.");
        el.writeIntoExcel(reserves, "Резервы, т.");
    }
    
    static void write_actor(ArrayList<Actor>  AllActors) throws IOException {
        for (Actor actor : AllActors) {
            if (actor.getClass().equals(Operator.class)){
                Function<Operator, LinkedHashMap> func = (a)-> a.getStats().assembleOperatorSet();
                ExcelLoader<Operator> el = new ExcelLoader<>(World.EXCEL_FILE_PATH);
                el.writeIntoExcel((Operator) actor, func, "Оператор "+actor.getName());
            }else if (actor.getClass().equals(Enrichment.class)){
                Function<Enrichment, LinkedHashMap> func = (a)-> a.getStats().assembleEnrichmentSet();
                ExcelLoader<Enrichment> el = new ExcelLoader<>(World.EXCEL_FILE_PATH);
                el.writeIntoExcel((Enrichment)actor, func, "Обогатитель "+actor.getName());
            }
            else{
                Function<Actor, LinkedHashMap> func = (a)-> a.getStats().assembleActorSet();
                ExcelLoader<Actor> el = new ExcelLoader<>(World.EXCEL_FILE_PATH);
                el.writeIntoExcel(actor, func, actor.getName());
            }
        }
    }

    static void write_detail_eup() throws IOException {
        ArrayList<Enrichment> enrichments = World.tbulletin.my_enrichments;
        ArrayList<Region> regions = World.tbulletin.my_regions;
        for (Enrichment my_enrichment :  enrichments) {
            LinkedHashMap<String, Object> E = my_enrichment.calc_region_eup_sales_stat(regions);
            ExcelLoader<Operator> el = new ExcelLoader<>("./example_detail_EUP.xlsx");
            el.writeIntoExcel(E, my_enrichment.getName());
        }
    }
    
    static void write_detail_swu() throws IOException {
        ArrayList<Enrichment> enrichments = World.tbulletin.my_enrichments;
        ArrayList<Region> regions = World.tbulletin.my_regions;
        for (Enrichment my_enrichment :  enrichments) {
            LinkedHashMap<String, Object> E = my_enrichment.calc_region_swu_sales_stat(regions);
            ExcelLoader<Operator> el = new ExcelLoader<>("./example_detail_SWU.xlsx");
            el.writeIntoExcel(E, my_enrichment.getName());
        }
    }
    
    static void write_report_var2() throws IOException {
        LinkedHashMap<String, Object> report = new LinkedHashMap<>();
        report.put("Года", Time.years);
        report.put("Число действующих реакторов", Statistic.calc_sum_reactors(World.tbulletin.my_operators));
        report.put("Совокупная установленная мощность, ГВт", Statistic.calc_sum_el_capacity(World.tbulletin.my_operators));
        report.put("Себестоимость добычи ПУ, $/кг (Средневзвешенная мировая)", Statistic.calc_mean_pk_cost(World.tbulletin.my_minings));
        report.put("Себестоимость производства ЕРР, $/ЕРР (Средневзвешенная мировая)", Statistic.calc_mean_swu_cost(World.tbulletin.my_enrichments));
        report.put("Оптимальный отвал, Базисный пункт,‰", Arithmetic.array_prod(World.tbulletin.my_enrichments.get(0).opt_tails, 100));
        report.put("Средневзвешенная мировая цена ПУ $/кг", World.calc_mean_prices(Contract.P_PK));
        report.put("Средневзвешенная мировая цена ЕРР  $/ЕРР", World.calc_mean_swu_prices());
        report.put("Объем добычи ПУ, Кт", Statistic.calc_sum_pk_production(World.tbulletin.my_minings));
        report.put("Совокупный объем поставки ОУП, т.", Statistic.calc_sum_eup_delivery(World.tbulletin.my_enrichments));
        for(Enrichment en : World.tbulletin.my_enrichments   ){
            report.put("Объем поставки ОУП " + en.getName() + ", т.", en.stats.eup_volume);
        }
        for(Enrichment en : World.tbulletin.my_enrichments   ){
            report.put("Производственный отвал " + en.getName() + ", Базисный пункт,‰ ", Arithmetic.array_prod(en.prod_tails, 100) );
        }
        report.put("Совокупные производственные мощности, тыс. ЕРР", Statistic.calc_sum_capacity(World.tbulletin.my_enrichments));
        for(Enrichment en : World.tbulletin.my_enrichments   ){
            report.put("Производственные мощности " + en.getName() + ", тыс. ЕРР", en.all_capacity);
        }
        
        ExcelLoader<Operator> el = new ExcelLoader<>("./Report.xlsx");
        el.set_vertical_header();
            el.writeReport(report, "Report");
    }
} 
