/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package DMath;

import com.fuzzylite.Engine;
import com.fuzzylite.variable.InputVariable;
import com.fuzzylite.variable.OutputVariable;

/**
 *
 * @author Dima
 */
public class FuzzyDiscount extends Fuzzy {
    double buyer_raiting;
    double logistic;
    double cost_price;
    double spot_price;
    double price_dynamic;
    double supply_demand;
    
    public FuzzyDiscount(Engine fis) {
        this.fis = fis;
    }
    
    public void setBuyer_raiting(double buyer_raiting) {
        this.buyer_raiting = buyer_raiting;
        InputVariable input = fis.getInputVariable(0);
        if(input.getMinimum() > buyer_raiting) this.buyer_raiting = input.getMinimum();
        else if (input.getMaximum() < buyer_raiting) this.buyer_raiting = input.getMaximum();
    }

    public void setLogistic(double logistic) {
        this.logistic = logistic;
        InputVariable input = fis.getInputVariable(1);
        if(input.getMinimum() > logistic) this.logistic = input.getMinimum();
        else if (input.getMaximum() < logistic) this.logistic = input.getMaximum();
    }

    public void setCost_price(double cost_price) {
        this.cost_price = cost_price;
        InputVariable input = fis.getInputVariable(2);
        if(input.getMinimum() > cost_price) this.cost_price = input.getMinimum();
        else if (input.getMaximum() < cost_price) this.cost_price = input.getMaximum();
    }

    public void setSpot_price(double spot_price) {
        this.spot_price = spot_price;
        InputVariable input = fis.getInputVariable(3);
        if(input.getMinimum() > spot_price) this.spot_price = input.getMinimum();
        else if (input.getMaximum() < spot_price) this.spot_price = input.getMaximum();
    }

    public void setPrice_dynamic(double price_dynamic) {
        this.price_dynamic = price_dynamic;
        InputVariable input = fis.getInputVariable(4);
        if(input.getMinimum() > price_dynamic) this.price_dynamic = input.getMinimum();
        else if (input.getMaximum() < price_dynamic) this.price_dynamic = input.getMaximum();
    }

    public void setSupply_demand(double supply_demand) {
        this.supply_demand = supply_demand;
        InputVariable input = fis.getInputVariable(4);
        if(input.getMinimum() > supply_demand) this.supply_demand = input.getMinimum();
        else if (input.getMaximum() < supply_demand) this.supply_demand = input.getMaximum();
    }
    
    
    public double eval(){
        if (! fis.isReady()){
            throw new Error("Fis is not ready");
        }
        InputVariable input1 = fis.getInputVariable(0);
        input1.setValue(buyer_raiting);
        InputVariable input2 = fis.getInputVariable(1);
        input2.setValue(logistic);
        InputVariable input3 = fis.getInputVariable(2);
        input3.setValue(cost_price);
        InputVariable input4 = fis.getInputVariable(3);
        input4.setValue(spot_price);
        InputVariable input5 = fis.getInputVariable(4);
        input5.setValue(price_dynamic);
        InputVariable input6 = fis.getInputVariable(5);
        input6.setValue(supply_demand);
        
        OutputVariable output = fis.getOutputVariable(0);
        
        fis.process();
        return output.getValue();
    }
    
    
    
}
