/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package DMath;

import com.fuzzylite.Engine;
import com.fuzzylite.variable.InputVariable;
import com.fuzzylite.variable.OutputVariable;
import java.util.List;

/**
 *
 * @author Dima
 */
public class FuzzyRaiting extends Fuzzy {
    double supplier_raiting;
    double rel_price;
    double supplier_share;
    double spot_price;
    double logistic;
    double expectense;
    
    public FuzzyRaiting(Engine fis) {
        this.fis = fis;
    }
    
    public FuzzyRaiting() {
        
    }

    public void setSupplierRaiting(double supplier_raiting) {
        this.supplier_raiting = supplier_raiting;
        InputVariable input = fis.getInputVariable(0);
        if(input.getMinimum() > supplier_raiting) this.supplier_raiting = input.getMinimum();
        else if (input.getMaximum() < supplier_raiting) this.supplier_raiting = input.getMaximum();
    }

    public void setRelPrice(double rel_price) {
        this.rel_price = rel_price;
        InputVariable input = fis.getInputVariable(1);
        if(input.getMinimum() > rel_price) this.rel_price = input.getMinimum();
        else if (input.getMaximum() < rel_price) this.rel_price = input.getMaximum();
    }

    public void setSupplierShare(double supplier_share) {
        this.supplier_share = supplier_share;
        InputVariable input = fis.getInputVariable(2);
        if(input.getMinimum() > supplier_share) this.supplier_share = input.getMinimum();
        else if (input.getMaximum() < supplier_share) this.supplier_share = input.getMaximum();
    }

    public void setSpotPrice(double spot_price) {
        this.spot_price = spot_price;
        InputVariable input = fis.getInputVariable(3);
        if(input.getMinimum() > spot_price) this.spot_price = input.getMinimum();
        else if (input.getMaximum() < spot_price) this.spot_price = input.getMaximum();
    }

    public void setLogistic(double logistic) {
        this.logistic = logistic;
    }

    public void setExpectense(double expectense) {
        this.expectense = expectense;
    }
    
    public double eval(){
        if (! fis.isReady()){
            throw new Error("Fis is not ready");
        }
        InputVariable input1 = fis.getInputVariable(0);
        input1.setValue(supplier_raiting);
        InputVariable input2 = fis.getInputVariable(1);
        input2.setValue(rel_price);
        InputVariable input3 = fis.getInputVariable(2);
        input3.setValue(supplier_share);
        InputVariable input4 = fis.getInputVariable(3);
        input4.setValue(spot_price);
        InputVariable input5 = fis.getInputVariable(4);
        input5.setValue(logistic);
        InputVariable input6 = fis.getInputVariable(5);
        input6.setValue(expectense);
        
        OutputVariable output = fis.getOutputVariable(0);
        
        fis.process();
        return output.getValue();
    }
    /*
    public double[] getInputValues() {
        List<InputVariable> Inupts = fis.getInputVariables();
        double[] InputValues = new double[Inupts.size()];
        int i = 0;
        for (InputVariable Inupt : Inupts) {
            InputValues[i] = Inupt.getValue();
            i++;
        }
        return InputValues;
    }
*/
}
