/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package DMath;

import com.fuzzylite.Engine;
import com.fuzzylite.imex.FisExporter;
import com.fuzzylite.imex.FisImporter;
import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Locale;
import java.util.stream.Stream;
import smmum_alpha.Contract;
import java.util.HashMap;
/**
 *
 * @author Dima
 */
public class FuzzyStore {
    
    static Locale Old_locale;
    static ArrayList<Engine> FISes;
    static HashMap<String,HashMap<Short, HashMap<Integer,Engine>>> FISMap;
    
    static public boolean init() throws IOException{
        FISes = new ArrayList<Engine>();
        change_locale();
        load_fises();
        rechange_locale();
        return true;   
    } 
    
    static public void clear(){
        FISes.clear();
    }
    
    
    static void change_locale(){
        Old_locale = Locale.getDefault();
        Locale newLocale = new Locale("en", "USA");
        Locale.setDefault(newLocale);
    }
    
    
    static boolean load_fises() throws IOException{
       String d = System.getProperty("user.dir"); 
       File F = new File(d+"//fis");
       FisExporter FUUE = new FisExporter();
       FisImporter FUUI = new FisImporter();
       for (final File f : F.listFiles()) {
           Engine fis = FUUI.fromFile(f);
           FISes.add(fis);
           System.out.println(FUUE.toString(fis));
       }
       pack_in_Map();
       
       return true;
    }
    private static void pack_in_Map(){
        FISMap = new HashMap<>();
        FISMap.put("contr", new HashMap<>());
        FISMap.put("marge", new HashMap<>());
        FISMap.put("discount", new HashMap<>());
        for (String type : FISMap.keySet()) {
           FISMap.get(type).put(Contract.P_MOX, new HashMap<>());
           FISMap.get(type).put(Contract.P_OUP, new HashMap<>());
           FISMap.get(type).put(Contract.P_PK, new HashMap<>());
           FISMap.get(type).put(Contract.P_SWU, new HashMap<>());
        }
        short[] Products = {Contract.P_MOX, Contract.P_OUP,Contract.P_PK, Contract.P_SWU};
        for (Engine FISe : FISes) {
            HashMap<Short, HashMap<Integer, Engine>> Level1;
            if (FISe.getName().contains("contr")){
                Level1 = FISMap.get("contr");
            } 
            else if (FISe.getName().contains("marge")){
                Level1 = FISMap.get("marge");
            }
            else if (FISe.getName().contains("discount")){
                Level1 = FISMap.get("discount");
            }
            else{
                Level1 = null;
                throw new Error("Level1 == null");
            }
            HashMap<Integer, Engine> Level2; 
            if (FISe.getName().contains(read_product(Contract.P_MOX))){
                Level2 = Level1.get(Contract.P_MOX);
            }
            else if (FISe.getName().contains(read_product(Contract.P_OUP))){
                Level2 = Level1.get(Contract.P_OUP);
            }
            else if (FISe.getName().contains(read_product(Contract.P_PK))){
                Level2 = Level1.get(Contract.P_PK);
            }
            else if (FISe.getName().contains(read_product(Contract.P_SWU))){
                Level2 = Level1.get(Contract.P_SWU);
            }
            else{
                Level2 = null;
                throw new Error("Level2 == null");
            }
            
            if ((FISe.getName().contains(write_brain(smmum_alpha.Region.BAmerica)))){
                Level2.put(smmum_alpha.Region.BAmerica, FISe);
            }
            else if ((FISe.getName().contains(write_brain(smmum_alpha.Region.BAsia)))){
                Level2.put(smmum_alpha.Region.BAsia, FISe);
            }
            else if ((FISe.getName().contains(write_brain(smmum_alpha.Region.BEurope)))){
                Level2.put(smmum_alpha.Region.BEurope, FISe);
            }
        }
    } 
    private static void rechange_locale() {
       System.setProperty(".level", "INFO");
       smmum_alpha.DimaCrazyLogger.SaveFromDisaster();
       Locale.setDefault(Old_locale);
    }
    
    public static Engine getEngine(String type, short product, int brain){
        return FISMap.get(type).get(product).get(brain);
    }
    
    public static Engine getRaiting(short product, int brain) {
        
        Stream<Engine> my_product_engines = FISes.stream().filter(e -> e.getName().contains(read_product(product)));
        Object[] disp_my_product_engines = my_product_engines.toArray();
        ArrayList<Engine> Amy_engine_product = new ArrayList();
        for (Object disp_my_product_engine : disp_my_product_engines) {
            Amy_engine_product.add((Engine) disp_my_product_engine);
        }
        Stream<Engine> my_engine_raiting = Amy_engine_product.stream().filter(e -> e.getName().contains("contr"));
        Object[] disp_my_engine_raiting =  my_engine_raiting.toArray();
        //Engine[] disp_my_product_engines = (Engine[]) sssss;
//        Engine[] disp_my_product_engines = (Engine[]) my_product_engines.toArray();
        //ArrayList<Engine> Amy_engine_product = new ArrayList();
        //Collections.addAll(Amy_engine_product, disp_my_product_engines);
        
        ArrayList<Engine> Amy_engine_raiting = new ArrayList();
        for (Object object : disp_my_engine_raiting) {
            Amy_engine_raiting.add((Engine) object);
        }
        
        Stream<Engine> stream_fis = Amy_engine_raiting.stream().filter(e -> e.getName().contains(write_brain(brain)));
        Object[] arr_fis = stream_fis.toArray();
        Object r_fis = arr_fis[0];
        return (Engine) r_fis;
    }
    
    public static Engine getMarge(short product, int brain) {
        
        Stream<Engine> my_product_engines = FISes.stream().filter(e -> e.getName().contains(read_product(product)));
        Object[] disp_my_product_engines = my_product_engines.toArray();
        ArrayList<Engine> Amy_engine_product = new ArrayList();
        for (Object disp_my_product_engine : disp_my_product_engines) {
            Amy_engine_product.add((Engine) disp_my_product_engine);
        }
        Stream<Engine> my_engine_raiting = Amy_engine_product.stream().filter(e -> e.getName().contains("marge"));
        Object[] disp_my_engine_raiting =  my_engine_raiting.toArray();
        
        ArrayList<Engine> Amy_engine_raiting = new ArrayList();
        for (Object object : disp_my_engine_raiting) {
            Amy_engine_raiting.add((Engine) object);
        }
        
        Stream<Engine> stream_fis = Amy_engine_raiting.stream().filter(e -> e.getName().contains(write_brain(brain)));
        Object[] arr_fis = stream_fis.toArray();
        Object r_fis = arr_fis[0];
        return (Engine) r_fis;
    }
    
    public static Engine getDiscount(short product, int brain) {
        
        Stream<Engine> my_product_engines = FISes.stream().filter(e -> e.getName().contains(read_product(product)));
        Object[] disp_my_product_engines = my_product_engines.toArray();
        ArrayList<Engine> Amy_engine_product = new ArrayList();
        for (Object disp_my_product_engine : disp_my_product_engines) {
            Amy_engine_product.add((Engine) disp_my_product_engine);
        }
        Stream<Engine> my_engine_raiting = Amy_engine_product.stream().filter(e -> e.getName().contains("discount"));
        Object[] disp_my_engine_raiting =  my_engine_raiting.toArray();
        
        ArrayList<Engine> Amy_engine_raiting = new ArrayList();
        for (Object object : disp_my_engine_raiting) {
            Amy_engine_raiting.add((Engine) object);
        }
        
        Stream<Engine> stream_fis = Amy_engine_raiting.stream().filter(e -> e.getName().contains(write_brain(brain)));
        Object[] arr_fis = stream_fis.toArray();
        Object r_fis = arr_fis[0];
        return (Engine) r_fis;
    }
    
    public static String read_product(short product){
        switch(product){
            case Contract.P_OUP: 
                return "oup";
            case Contract.P_PK:
                return "pk";
            case Contract.P_SWU:
                return "swu";
            case Contract.P_MOX:
                return "mox";
            default:
                return "";
        }
    }
    
    public static String write_brain(int brain){
        switch (brain){
            case 1:
                return "america";
            case 2:
                return "europe";
            case 3:
                return "asia";
            default: 
                return "";
            
        }
        
    }
}
